/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

LPFɃTCYk(GrayScale)
OpenGL only
*/
//摜t@C
//#define FILENAME_IN "../../bmp256/tiger1-1.bmp"
#define FILENAME_IN "../../bmp256/zone256.bmp"
//o͉摜t@C
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glut.h>
#include <math.h>
#include "../../bmpLoadSave.h"
#define M_PI 3.14159265358979

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void reduction();
void createOperator();
void digitalFilter();

//ϐ
//摜f[^̃TCY
int imgWidth, imgHeight;
int newWidth, newHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte imageD[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
//EChȄTCY
int width  = 600;
int height = 550;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int qy0;//
//k
float ratio = 0.5;
//digital filterparameter
int nTap = 7;//number ofimpulse responces
int nWeight = nTap * nTap;//tB^W̌
float weight[81];
float h0[10];//impulse responce
float h[10]; //֐悶impulse responce
bool flagHelp = false;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGB);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("GL_Reduce");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
  //Cxg[vɓ
  glutMainLoop();
  return 0;
}

void init(void)
{
  //wiF
  glClearColor(0.0, 0.0, 0.0, 1.0);
	loadGrayData(image, &imgWidth, &imgHeight, FILENAME_IN);
	//TCYϊ̉摜TCY
	newWidth = int((float)imgWidth * ratio);
	newHeight = int((float)imgHeight * ratio);
	printf("ratio= %f, imgWidth = %d,  newWidth = %d \n", ratio, imgWidth, newWidth);
	printf("tB^TCYnTap = %d \n", nTap);
}

void display(void)
{
	
  //Ԍv
  LARGE_INTEGER freq, time1, time2;
	DWORD pTime;
	memset(&freq,  0x00, sizeof freq);
	memset(&time1, 0x00, sizeof time1);
	memset(&time2, 0x00, sizeof time2);
	pTime = 0;

  QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &time1);

	//J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);

	createOperator();
	digitalFilter();
	reduction();//k

	int y0 = height - newHeight- py0;
	if(y0 < 0) y0 = 0;
	glRasterPos2i(px0, y0);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glDrawPixels(newWidth, newHeight, GL_LUMINANCE, GL_UNSIGNED_BYTE, image);

	QueryPerformanceCounter( &time2);
	pTime = (DWORD)((time2.QuadPart - time1.QuadPart) * 1000000 / freq.QuadPart);
	printf(" = %d[s] \n", pTime);
	if(flagHelp)
  {
		printf("[F1]L[F{̕ύX(0.1`1.0, 0.05݁j \n");
		printf("[F2]L[FtB^̃TCYύX(3,5,7,9) \n");
		flagHelp = false;
	}
	//I
  glFlush();
}

void reduction()
{
	int i, j, i1, i2, j1, j2;
	float p, q;
	float gray11, gray12, gray21, gray22;

	//`
	for(j = 0; j < newHeight; j++)
	{
		j1 = int((float)j / ratio);
		j2 = j1 + 1;
		if(j2 > imgHeight) j2 = imgHeight - 1;
		q = (float)j / ratio - (float)j1;
		for(i = 0; i < newWidth; i++)
		{
			i1 = int((float)i / ratio);
			i2 = i1 + 1;
			if(i2 > imgWidth) i2 = imgWidth - 1;
			p = (float)i / ratio - (float)i1;
			gray11 = (float)imageD[i1 + j1 * imgWidth];
			gray21 = (float)imageD[i2 + j1 * imgWidth];
			gray12 = (float)imageD[i1 + j2 * imgWidth];
			gray22 = (float)imageD[i2 + j2 * imgWidth];

			image[i + j * newWidth] 
			  = (GLubyte)((1.0 - q) * ((1.0 - p) * gray11 + p * gray21) 
				+ q * ((1.0 - p) * gray12 + p * gray22));
		}
	}
}

void createOperator()
{//digital filter ̃Iy[^id݁j߂

	int k, i, j, nt;
	float h0[10];

	nWeight = nTap * nTap;
	nt = (nTap - 1) / 2 ; //Sh(0)Б^bv

	//LPF
	float cut = ratio;//KՒfgkɈv;
	h0[0] = cut;
//k=0;
//printf("k=%d h0[0]=%f \n", k, h0[k]);
	for( k = 1; k <= nt; k++)
	{
		h0[k] = cut * sin(k * cut * M_PI) / (k * cut * M_PI);
//printf("k=%d h0[k]=%f \n", k, h0[k]);
	}

	//HAMMING:
	for( k = 0; k <= nt; k++)
		h[k] = h0[k] * (0.54 + 0.46 * cos((double)k * M_PI / (double)nt));
	
	//CASCADE
	for(j = 0; j < nTap; j++)
		for(i = 0; i < nTap; i++)
	  {
		  weight[i + j * nTap] = h[abs(i-nt)] * h[abs(j-nt)];
		}
		
	//v1.0ɂȂ悤ɐK
	float sum = 0.0;
	for(k = 0; k < nWeight; k++) sum += weight[k];
	for(k = 0; k < nWeight; k++) weight[k] /= sum;
}

void digitalFilter()
{
	int i, j,ii, jj, i0, j0, k;
	int nt = (nTap - 1) / 2;

	//R{[V
	float c;

	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
        c = 0.0;
				for(jj = - nt; jj <= nt; jj++)
				{
					j0 = j + jj;
					if(j0 < 0) j0 = 0;
					if(j0 > imgHeight-1) j0 = imgHeight - 1;
					for(ii = - nt; ii <= nt; ii++)
					{
						i0 = i + ii;
						if(i0 < 0) i0 = 0;
						if(i0 > imgWidth-1) i0 = imgWidth - 1;
						k = nt+ii + (nt+jj) * nTap;
						c += (float)image[i0 + j0 * imgWidth] * weight[k];
					}
					
					if(c > 255) c = 255.0;
					if(c < 0)   c = 0.0;
					imageD[i + j * imgWidth] = (GLubyte)c;
				}
		}
	}
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒieϊj
	gluOrtho2D(0.0, w, 0.0, h);
	//fOs̎wƏ
//  glMatrixMode(GL_MODELVIEW);
//  glLoadIdentity();

	width = w;
	height = h;
	init();
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		saveBitmap8(imgWidth, imgHeight, image, FILENAME_OUT); 
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}


void special(int key, int x, int y)
{
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) ratio += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	ratio -= 0.05;  
		if(ratio < 0.1) ratio = 0.1;
		if(ratio > 1.0) ratio = 1.0;
	}	

	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) nTap += 2;
		if(nTap > 9) nTap = 3;
	}	

	init();
	display();
}

