
uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform float ratio;//{
varying vec2 pos;
float w = 1.0 / float(imgWidth);
float h = 1.0 / float(imgHeight);

void main(void)
{
	vec4 col;
	//`
	vec2 pos1 = floor(pos / ratio);
	vec2 pos2 = pos1 + vec2(1.0, 1.0);
	vec2 pq = pos / ratio - pos1;
	vec4 col11 = texture2D(image, vec2(pos1.x * w, pos1.y * h));
	vec4 col21 = texture2D(image, vec2(pos2.x * w, pos1.y * h));
	vec4 col12 = texture2D(image, vec2(pos1.x * w, pos2.y * h));
	vec4 col22 = texture2D(image, vec2(pos2.x * w, pos2.y * h));
	col = mix(mix(col11, col21, pq.x), mix(col12, col22, pq.x), pq.y);
	gl_FragColor.rgb = col.rgb;
}