/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

TCYk
LPF(DigitalFilter)ɏk
OpenGL + GLSL

*/
//摜t@C
//#define FILENAME_IN "../../bmp256/tiger1-1.bmp"
#define FILENAME_IN "../../bmp256/zone256.bmp"

//o͉摜t@C
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../bmpLoadSave.h"

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void drawPlate1();
void drawPlate2();
void setTexture();
void setTextureFBO();
void special(int key, int x, int y);
void setFramebuffer();

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
int newWidth, newHeight;//VTCY
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
//EChẼTCY
int width  = 800;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int qy0;//
//VF[_vO
GLuint program1, program2;
//digital filter
int nTap = 3;//number ofimpulse responces
float cutoff = 0.5;//KՒfg

//g嗦
float ratio = 0.5;
//wvL[tO
bool flagHelp = false;
//texture object
GLuint texName[2];
//framebuffer object
GLuint fbName;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGB);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_Reduce");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
	glewInit();//glew.hɎĂ
  init();
	initGlsl(&program1, "lpf.vert", "lpf.frag");
	initGlsl(&program2, "reduce.vert", "reduce.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteTextures(2, texName);
	glDeleteFramebuffersEXT(1, &fbName);
	glDeleteProgram(program1);
	glDeleteProgram(program2);
  return 0;
}

void init(void)
{
  //wiF
  glClearColor(0.0, 0.0, 0.0, 1.0);
	//J[摜̎擾
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	//TCYϊ̉摜TCY
	newWidth = int((float)imgWidth * ratio);
	newHeight = int((float)imgHeight * ratio);
	printf("ratio= %f, imgWidth = %d,  newWidth = %d \n", ratio, imgWidth, newWidth);
  
	glGenTextures(2, texName);//eNX`IuWFNg̖Ot
	setTexture();
	setTextureFBO();
	setFramebuffer();
	printf("}EX/L[̐ɂ'H'L[vbV \n");
}

void setTexture()
{
  glBindTexture(GL_TEXTURE_2D, texName[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setTextureFBO()
{
  glBindTexture(GL_TEXTURE_2D, texName[1]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,0);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setFramebuffer(void)
{
	glGenFramebuffersEXT( 1, &fbName );
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbName );
  //textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT,
	                                           GL_TEXTURE_2D, texName[1], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void display(void)
{
	
  //Ԍv
  LARGE_INTEGER freq, time1, time2;
	DWORD pTime;
	memset(&freq,  0x00, sizeof freq);
	memset(&time1, 0x00, sizeof time1);
	memset(&time2, 0x00, sizeof time2);
	pTime = 0;

 	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &time1);

	//Step1:Digital Filter
	//framebuffer objectL
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbName );
  glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);
	//J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);
	int width0 = width;//Window̃TCYۑ
	int height0 = height;
	resize(imgWidth, imgHeight);
	width = width0;//WindowTCYɖ߂
	height = height0;

	cutoff = ratio;//Ւfg{Ɉv
  glUseProgram(program1);
  GLint imageLoc = glGetUniformLocation(program1, "image");
  glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint imgWidthLoc = glGetUniformLocation(program1, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program1, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint ntapLoc = glGetUniformLocation(program1, "nTap");
	glUniform1i(ntapLoc, nTap);
	GLint cutLoc = glGetUniformLocation(program1, "cutoff");
	glUniform1f(cutLoc, cutoff);
	drawPlate1();
  // VF[_vỎ 
  glUseProgram(0);
  glBindTexture(GL_TEXTURE_2D, 0);
  //framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );

	//Step2:Reduction
	glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, texName[1]);

	//J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);
	resize(width, height);

  glUseProgram(program2);

  GLint imageLoc2 = glGetUniformLocation(program2, "image");
  glUniform1i(imageLoc2, 1);//GL_TEXTURE1Kp
	GLint imgWidthLoc2 = glGetUniformLocation(program2, "imgWidth");
	glUniform1i(imgWidthLoc2, imgWidth);
	GLint imgHeightLoc2 = glGetUniformLocation(program2, "imgHeight");
	glUniform1i(imgHeightLoc2, imgHeight);
	GLint ratioLoc = glGetUniformLocation(program2, "ratio");
	glUniform1f(ratioLoc, ratio);

	qy0 = height - newHeight- py0;
	if(qy0 < 0) qy0 = 0;
	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	drawPlate2();
	glPopMatrix();
  // VF[_vỎ 
  glUseProgram(0);
  glBindTexture(GL_TEXTURE_2D, 0);

	QueryPerformanceCounter( &time2);
	pTime = (DWORD)((time2.QuadPart - time1.QuadPart) * 1000000 / freq.QuadPart);
	printf(" = %d[s] \n", pTime);

	if(flagHelp)
  {
		printf("[F1]L[F{̕ύX(0.1`1.0, 0.05݁j \n");
		printf("[F2]L[FtB^̃TCYύX(3,5,7,9) \n");
		flagHelp = false;
  }
  //I
	glFlush();
}

void drawPlate1()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth, 0);
		glVertex2i(imgWidth, imgHeight);
		glVertex2i(0, imgHeight);
	glEnd();
}

void drawPlate2()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(newWidth, 0);
		glVertex2i(newWidth, newHeight);
		glVertex2i(0, newHeight);
	glEnd();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒ
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(px0, qy0, newWidth, newHeight, GL_RGB, GL_UNSIGNED_BYTE, image);
		saveBitmap24(newWidth, newHeight, image, FILENAME_OUT); 
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) ratio += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	ratio -= 0.05;  
		if(ratio < 0.1) ratio = 0.1;
		if(ratio > 1.0) ratio = 1.0;
		newWidth = ratio * imgWidth;
		newHeight = ratio * imgHeight;
		printf("k = %f \n", ratio);
	}	
  if(key == GLUT_KEY_F2) 
  {
		nTap += 2;
		if(nTap > 9) nTap = 3;
		printf("nTap = %d \n", nTap);
	}
	display();
}
