/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

qXgORicolor)
ŒVF[_iOpenGL onlyj

*/
//摜t@C
//#define FILENAME_IN "../../bmp256/Lenna.bmp"
//#define FILENAME_IN "../../bmp256/tiger1-1.bmp"
#define FILENAME_IN "../../bmp256/couple.bmp"
//o͉摜t@C
#define FILENAME_OUT "file0.bmp"
#define HISTO_OUT "hist0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glut.h>
#include "../../bmpLoadSave.h"
#include "math.h"
#define M_PI 3.1415926535
#define HISTO_SIZE 256

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void getHistogram(GLubyte picture[][3]);
void dispHistogram();
void histoFlat();

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageFlat[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageHisto[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
//EChẼTCY
int width  = 800;
int height = 600;
//qXgOp
int histo[HISTO_SIZE][3];
int levelA = 0;
int levelB = 128;
int levelC = 0;
int levelD = 255;
int levelConst = 100;
double scale = 0.2;//\{
//\摜̍n_
int px0 = 10;
int py0 = 10;
bool flagHelp = false;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGBA);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("GL_HistoFlatColor2");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();

	//Cxg[vɓ
  glutMainLoop();
  return 0;
}

void init(void)
{
  //wiF
  glClearColor(0.0, 0.0, 0.0, 1.0);
	//mN摜̎擾
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
}

void display(void)
{
  //J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);

	histoFlat();
	//̈ʒu
	int qx0= px0;
	int qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;
	glRasterPos2i(qx0, qy0);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glDrawPixels(imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, imageFlat);
	getHistogram(imageFlat);
//	glDrawPixels(imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, image);
//	getHistogram(image);
	dispHistogram();

	if(flagHelp)
  {
		printf("[F1]L[FlevelA_̕ύX \n");
		printf("[F2]L[FlevelB_̕ύX \n");
		printf("[F3]L[FlevelC_̕ύX \n");
		printf("[F4]L[FlevelD_̕ύX \n");
		printf("[F5]L[FZllevelConst̕ύX \n");
		printf("[F6]L[F˽ĸяcscale̕ύX \n");
		printf("[S]L[FS̉ʂ̕ۑ \n");
		printf("[Shift]+[S]L[F摜̕ۑ \n");
		flagHelp = false;
  }

  //I
  glFlush();
}


void histoFlat()
{
	int i, j, k, k1, k2, n, newK;
	int ss, kMin, kMax, size0;
	int nmove[HISTO_SIZE][HISTO_SIZE];//nmove[k1,k2]--k1k2ֈړ߸ِ
	int cnt[HISTO_SIZE][HISTO_SIZE];//cnt[k1,k2]-----k1k2ֈړς݂߸ِ(`Ŏgp)
	int zMax = HISTO_SIZE - 1;
	int histo2[HISTO_SIZE][3];//C̃qXgO(ڕWlj

	//qXgǑvZ
	getHistogram(image);
//	for(i=0; i<HISTO_SIZE; i++) printf("i=%d histo=%d \n",i, histo[i][0]);
//	for(n = 0; n < 3; n++) 
	//ڕWqXgǑvZiqXgO`ۑ)
	for(n = 0; n < 3; n++)
	{
	//	histo[zMax][0] = 0;
		for(k = 0; k <= zMax; k++)
		{
			histo2[k][n] = 0;
		}

		for(k = 0; k <= zMax; k++)
		{
			if(k < levelA) newK = int(float(levelC * k) / float(levelA));
			else if(k < levelB)
				newK = int(float(k - levelA) * float(levelD - levelC)/ float(levelB - levelA)) + levelC;
			else 
				newK = int(float(k - levelB) * float(zMax - levelD)/ float(zMax - levelB)) + levelD;

			histo2[newK][n] = histo[k][n];
		}
/*
		//nonlinear
		for(k = 0; k <= zMax;k++)
		{
			//double aa = ;
			newK = int(double(zMax) * pow( double(k) / double(zMax), 2.0));
			histo2[newK][n] = histo[k][n];
		}
*/
/*
		//sin
		for(k = 0; k <= zMax; k++)
		{
			
			histo2[k][n] *= (int)(10.0 * (sin(M_PI * double(k) / double(zMax))));
			histo2[k][n] *= (int)(10.0 * (sin(M_PI * double(k) / double(zMax))));
			if(histo2[k][n] < 0) histo2[k][n] = 0;
		}
*/
		histo2[0][n] = 0;
		histo2[zMax][n] = 0;
		//Ԃ𖄂߂
		for(k = 1; k <= zMax/2; k++)
		{
			if(histo2[k][n] == 0) histo2[k][n] = histo2[k-1][n];
		}
		for(k = zMax-1; k > zMax/2; k--)
		{
			if(histo2[k][n] == 0) histo2[k][n] = histo2[k+1][n];
		}

		//lZ
		for(k = 0; k <= zMax; k++) 
		{
			histo2[k][n] += levelConst;
			if(histo2[k][n] < 0) histo2[k][n] = 0;
		}

		//qXgOafɓȂ悤
		int sum = 0;
		for(k = 0; k <= zMax; k++) sum += histo2[k][n];
		float ratio = float(imgWidth * imgHeight) / float(sum);
		for(k = 0; k <= zMax; k++) histo2[k][n] = int( ratio * float(histo2[k][n]) );

	}

	//
	for(n = 0; n < 3; n++)
	{
		//ړ߸ِnmove[k1,k2]̏
		for(k = 0;k <= zMax;k++)
		{
			for(k1 = 0;k1 < HISTO_SIZE; k1++) nmove[k][k1] = 0;
			nmove[k][k] = histo[k][n];
		}

		//ړ߸ِnmove[k1][k2]̌vZ
		for(k = 0;k < zMax;k++)
		{
			if(histo[k][n] > histo2[k][n])
			{ //k̉fڕWl荂
				ss = nmove[0][k];
				for(k1 = 0; k1 <= k;k1++)
				{//kႢقkɈړĂf𒲂ׂ
					if(ss < histo2[k][n]) ss += nmove[k1+1][k];
					else 
					{
						nmove[k1][k+1] = ss - histo2[k][n];//ڕWl𒴂ƂȂֈړ
						nmove[k1][k] = nmove[k1][k] - nmove[k1][k+1];
						histo[k][n] -= nmove[k1][k+1];
						histo[k + 1][n] += nmove[k1][k+1];
						if(k != k1)
						{
							for(k2 = k1+1;k2 <= k;k2++)
							{
								//k1`kׂ̂Ăق̂ƂȂֈړ
								nmove[k2][k+1] = nmove[k2][k];
								histo[k + 1][n] += nmove[k2][k+1];
								histo[k][n] -= nmove[k2][k+1];
								nmove[k2][k] = 0;
							}
						}
						break;
					}
				}
			}
			else
			{ //k̉fςႢ
				ss = histo[k][n];
				for(k1 = k + 1;k1<= zMax;k1++)
				{
					ss += histo[k1][n];//ƂȂ̉f
					if(ss <= histo2[k][n])
					{//ƂȂĂAψȉȂ炷ׂĂkֈړ
						nmove[k1][k] = histo[k1][n];
						histo[k][n] += nmove[k1][k];
						nmove[k1][k1] = 0;
						histo[k1][n] = 0;
					}
					else
					{//ڕWlzȂAskֈړ
						nmove[k1][k] = histo2[k][n] - histo[k][n];
						histo[k][n] = histo[k][n] + nmove[k1][k];
						nmove[k1][k1] = nmove[k1][k1] - nmove[k1][k];
						histo[k1][n] = histo[k1][n] - nmove[k1][k];
						break;
					}
				}//k1
			}//end if
		}//k
		//ϊ
		//ϊς݃JEg̃NA
		for(k1 = 0;k1 <= zMax;k1++)
			for(k2 = 0;k2 <= zMax;k2++) cnt[k1][k2] = 0;

		for(j = 0; j < imgHeight;j++)
			for(i = 0;i < imgWidth;i++)
			{
				k1 = image[i + j * imgWidth][n];
				for(k2 = 0;k2 <= zMax; k2++)
				{//Zxl̒ႢD
					if(cnt[k1][k2] < nmove[k1][k2]) break;
				}
				imageFlat[i + j * imgWidth][n] = k2;
				cnt[k1][k2] ++; //ϊς݃JEg
			}
	}
}

void getHistogram(GLubyte picture[][3])
{
	int i, j, k;

	for(k = 0; k < 3; k++)
	{
		//clear
		for(i = 0; i < HISTO_SIZE; i++) histo[i][k] = 0;
		//histogram count
		for(j = 0; j < imgHeight; j++)
			for(i = 0; i < imgWidth; i++) 
				histo[picture[i + j * imgWidth][k]][k] ++;	
	}
}

void dispHistogram()
{
	int i;

	//̈ʒu
	int qx0= px0 + imgWidth + 10;
	int qy0 = 10 + 2 * height / 3;

	//Red
	glBegin(GL_LINES);
	glColor3f(1.0, 0.0, 0.0);
	for(i = 0; i < HISTO_SIZE; i++) 
	{
		glVertex2s(qx0 + i, qy0);
		glVertex2s(qx0 + i, histo[i][0] * scale + qy0);
	}
	glEnd();

//	for(i=0; i<HISTO_SIZE; i++) printf("i=%d histo=%d \n",i, histo[i][0]);
	glColor3f(0.0, 1.0, 1.0);
	glBegin(GL_LINES);
	//
	glVertex2s(qx0, qy0);
	glVertex2s(qx0 + HISTO_SIZE, qy0);
	//c
	glVertex2s(qx0, qy0);
	glVertex2s(qx0, qy0 + height/3 - 20);
	glEnd();

	//Green
	qy0 = 10 + height / 3;
	glBegin(GL_LINES);
	glColor3f(0.0, 1.0, 0.0);
	for(i = 0; i < HISTO_SIZE; i++) 
	{
		glVertex2s(qx0 + i, qy0);
		glVertex2s(qx0 + i, histo[i][1] * scale + qy0);
	}
	glEnd();

	glColor3f(1.0, 0.0, 1.0);
	glBegin(GL_LINES);
	//
	glVertex2s(qx0, qy0);
	glVertex2s(qx0 + HISTO_SIZE, qy0);
	//c
	glVertex2s(qx0, qy0);
	glVertex2s(qx0, qy0 + height/3 - 20);
	glEnd();

	//Blue
	qy0 = 10 ;
	glBegin(GL_LINES);
	glColor3f(0.0, 0.0, 1.0);
	for(i = 0; i < HISTO_SIZE; i++) 
	{
		glVertex2s(qx0 + i, qy0);
		glVertex2s(qx0 + i, histo[i][2] * scale + qy0);
	}
	glEnd();

	glColor3f(1.0, 1.0, 0.0);
	glBegin(GL_LINES);
	//
	glVertex2s(qx0, qy0);
	glVertex2s(qx0 + HISTO_SIZE, qy0);
	//c
	glVertex2s(qx0, qy0);
	glVertex2s(qx0, qy0 + height/3 - 20);
	glEnd();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒieϊj
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 's':
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(0, 0, width, height, GL_RGB, GL_UNSIGNED_BYTE, imageHisto);
		saveBitmap24(width, height, imageHisto, HISTO_OUT); 
	  break;

  case 'S'://摜ۑ
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		saveBitmap24(imgWidth, imgHeight, imageFlat, FILENAME_OUT); 
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

	default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) levelA += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	levelA -= 1;  
		if(levelA < 0) levelA = 0;
		if(levelA > levelB - 10) levelA = levelB - 10;
		printf("levelA = %d \n", levelA);
	}	
	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) levelB += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	levelB -= 1;  
		if(levelB < levelA + 10) levelB = levelA + 10;
		if(levelB > 255) levelB = 255;
		printf("levelB = %d \n", levelB);
	}	
	if(key == GLUT_KEY_F3) 
	{
	  if(glutGetModifiers() == 0) levelC += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	levelC -= 1;  
		if(levelC < 0) levelC = 0;
		if(levelC > levelD) levelC = levelD;
		printf("levelC = %d \n", levelC);
	}	
	if(key == GLUT_KEY_F4) 
	{
	  if(glutGetModifiers() == 0) levelD += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	levelD -= 1;  
		if(levelD < levelC) levelD = levelC;
		if(levelD > 255) levelD = 255;
		printf("levelD = %d \n", levelD);
	}	
	
	if(key == GLUT_KEY_F5) 
	{
	  if(glutGetModifiers() == 0) levelConst += 50;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	levelConst -= 50;  
		printf("levelConst = %d \n", levelConst);
	}

	if(key == GLUT_KEY_F6) 
	{
	  if(glutGetModifiers() == 0) scale += 0.01;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	scale -= 0.01;  
		if(scale < 0.01) scale = 0.01;
		printf("\{ = %f \n", scale);
	}
	display();
}
