/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

摜̕`ƃqXgO\iGrayScale)
ŒVF[_iOpenGL onlyj

*/
//摜t@C
//#define FILENAME_IN "../../bmp/Px1.bmp"
#define FILENAME_IN "../../bmp256/couple.bmp"

//o͉摜t@C
#define FILENAME_OUT "file0.bmp"
//#define HISTO_FILENAME_OUT "histo.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glut.h>
#include "../../bmpLoadSave.h"
#define HISTO_SIZE 256

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void getHistogram();
void dispHistogram();

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte imageHisto[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
//EChẼTCY
int width  = 800;
int height = 600;
GLushort histo[HISTO_SIZE];
float scale = 0.2;
//\摜̍n_
int px0 = 10;
int py0 = 10;
//wvL[tO
bool flagHelp = false;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGBA);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("GL_HistoGray");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();

	//Cxg[vɓ
  glutMainLoop();
  return 0;
}

void init(void)
{
  //wiF
  glClearColor(0.0, 0.0, 0.0, 1.0);
	//mN摜̎擾
	loadGrayData(image, &imgWidth, &imgHeight, FILENAME_IN);
}

void display(void)
{
  //J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);

	//̈ʒu
	int qx0= px0;
	int qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;
	glRasterPos2i(qx0, qy0);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glDrawPixels(imgWidth, imgHeight, GL_LUMINANCE, GL_UNSIGNED_BYTE, image);

	getHistogram();
	dispHistogram();
  //I
  glFlush();
}

void getHistogram()
{
	int i, j;
	//clear
	for(i = 0; i < 256; i++) histo[i] = 0;
	//histogram count
	for(j = 0; j < imgHeight; j++)
		for(i = 0; i < imgWidth; i++) histo[image[i + j * imgWidth]] ++;	
}

void dispHistogram()
{
	int i;

	//̈ʒu
	int qx0= px0 + imgWidth + 10;
	int qy0 = height - imgHeight- py0;

	glBegin(GL_LINES);
	glColor3f(1.0, 1.0, 1.0);
	for(i = 0; i < HISTO_SIZE; i++) 
	{
		glVertex2s(qx0 + i, qy0);
		glVertex2s(qx0 + i, histo[i] * scale + qy0);
	}
	glEnd();

	glColor3f(0.0, 1.0, 1.0);
	glBegin(GL_LINES);
	//
	glVertex2s(qx0, qy0);
	glVertex2s(qx0 + HISTO_SIZE, qy0);
	//c
	glVertex2s(qx0, qy0);
	glVertex2s(qx0, qy0 + imgHeight - 20);
	glEnd();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒieϊj
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S':
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(0, 0, width, height, GL_RED, GL_UNSIGNED_BYTE, imageHisto);
		saveBitmap8(width, height, imageHisto, FILENAME_OUT); 
	  break;

	default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) scale += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	scale -= 0.05;  
		if(scale < 0.05) scale = 0.05;
		printf("\{ = %f \n", scale);
	}	
	display();
}
