uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform float gamma;
varying vec2 pos;

void main(void)
{
	vec2 texCoord = vec2(pos.x / float(imgWidth), pos.y / float(imgHeight));
	vec3 col = texture2D(image, texCoord).rgb;//摜
	vec3 newCol = pow(col, vec3(gamma));

	gl_FragColor = vec4(newCol, 1.0);
}