/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

`ZxϊiColor)
RgXgPp
OpenGL + GLSL

*/
//摜t@C
//#define FILENAME_IN "../../bmp/Px1.bmp"
//#define FILENAME_IN "../../bmp256/couple.bmp"
#define FILENAME_IN "../../bmp256/matumae256-4.bmp"
//o͉摜t@C
#define FILENAME_OUT "file0.bmp"
#define HISTO_FILENAME_OUT "histo0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../bmpLoadSave.h"
#define HISTO_SIZE 256

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void drawPlate();
void setTexture();
void special(int key, int x, int y);
void getHistogram();
void dispHistogram();
//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageHisto[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
//EChẼTCY
int width  = 800;
int height = 600;
//qXgOp
GLuint histo[HISTO_SIZE][3];
float scale = 0.2;//\{

//\摜̍n_
int px0 = 10;
int py0 = 10;
int qy0;//
//VF[_vO
GLuint program;
//wvL[tO
bool flagHelp = false;
//Zxϊp[^
float gamma1 = 2.0;
float gamma2 = 0.5;
int levelCenter = 128;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGB);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_NoninearLevel2");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
	initGlsl(&program, "nonlinear2.vert", "nonlinear2.frag");

  //Cxg[vɓ
  glutMainLoop();
	glDeleteProgram(program);
  return 0;
}

void init(void)
{
  //wiF
  glClearColor(0.0, 0.0, 0.0, 1.0);
	//J[摜̎擾
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	setTexture();
  printf("}EX/L[̐ɂ'H'L[vbV \n");
}

void setTexture()
{
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);//NEAREST);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);//NEAREST);
}

void display(void)
{
	//J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);

	//摜
  // VF[_vO̓Kp 
  glUseProgram(program);
  GLint imageLoc = glGetUniformLocation(program, "image");
  glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint imgWidthLoc = glGetUniformLocation(program, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint gamma1Loc = glGetUniformLocation(program, "gamma1");
	glUniform1f(gamma1Loc, gamma1);
	GLint gamma2Loc = glGetUniformLocation(program, "gamma2");
	glUniform1f(gamma2Loc, gamma2);
	GLint centerLoc = glGetUniformLocation(program, "levelCenter");
	glUniform1i(centerLoc, levelCenter);
		
	qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;

	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	drawPlate();
	glPopMatrix();
  // VF[_vỎ 
  glUseProgram(0);

	//_O摜CPU
	glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, image);
	getHistogram();
	dispHistogram();
//resize2(width2, height2);
	if(flagHelp)
  {
		printf("[F1]L[Fgamma1l̕ύX \n");
		printf("[F1]L[Fgamma2l̕ύX \n");
		printf("[F1]L[FԔZxl̕ύX \n");
		printf("[F2]L[F˽ĸяcscale̕ύX \n");
		printf("[S]L[FS̉ʂ̕ۑ \n");
		printf("[Shift]+[S]L[F摜̕ۑ \n");
		flagHelp = false;
  }
//printf("aaaaa \n");
//	display2();
  //I
	glFlush();
}

void drawPlate()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth, 0);
		glVertex2i(imgWidth, imgHeight);
		glVertex2i(0, imgHeight);
	glEnd();
}

void getHistogram()
{
	int i, j, k;

	//clear
	for(k = 0; k < 3; k++)
		for(i = 0; i < 256; i++) histo[i][k] = 0;
	//histogram count
	for(j = 0; j < imgHeight; j++)
		for(i = 0; i < imgWidth; i++) 
			for(k = 0; k < 3; k++) histo[image[i + j * imgWidth][k]][k] ++;	
}

void dispHistogram()
{
	int i;

	//̈ʒu
	int qx0= px0 + imgWidth + 10;
	int qy0 = 10 + 2 * height / 3;

	//Red
	glBegin(GL_LINES);
	glColor3f(1.0, 0.0, 0.0);
	for(i = 0; i < HISTO_SIZE; i++) 
	{
		glVertex2s(qx0 + i, qy0);
		glVertex2s(qx0 + i, histo[i][0] * scale + qy0);
	}
	glEnd();

//	for(i=0; i<HISTO_SIZE; i++) printf("i=%d histo=%d \n",i, histo[i][0]);
	glColor3f(0.0, 1.0, 1.0);
	glBegin(GL_LINES);
	//
	glVertex2s(qx0, qy0);
	glVertex2s(qx0 + HISTO_SIZE, qy0);
	//c
	glVertex2s(qx0, qy0);
	glVertex2s(qx0, qy0 + height/3 - 20);
	glEnd();

	//Green
	qy0 = 10 + height / 3;
	glBegin(GL_LINES);
	glColor3f(0.0, 1.0, 0.0);
	for(i = 0; i < HISTO_SIZE; i++) 
	{
		glVertex2s(qx0 + i, qy0);
		glVertex2s(qx0 + i, histo[i][1] * scale + qy0);
	}
	glEnd();

	glColor3f(1.0, 0.0, 1.0);
	glBegin(GL_LINES);
	//
	glVertex2s(qx0, qy0);
	glVertex2s(qx0 + HISTO_SIZE, qy0);
	//c
	glVertex2s(qx0, qy0);
	glVertex2s(qx0, qy0 + height/3 - 20);
	glEnd();

	//Blue
	qy0 = 10 ;
	glBegin(GL_LINES);
	glColor3f(0.0, 0.0, 1.0);
	for(i = 0; i < HISTO_SIZE; i++) 
	{
		glVertex2s(qx0 + i, qy0);
		glVertex2s(qx0 + i, histo[i][2] * scale + qy0);
	}
	glEnd();

	glColor3f(1.0, 1.0, 0.0);
	glBegin(GL_LINES);
	//
	glVertex2s(qx0, qy0);
	glVertex2s(qx0 + HISTO_SIZE, qy0);
	//c
	glVertex2s(qx0, qy0);
	glVertex2s(qx0, qy0 + height/3 - 20);
	glEnd();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒ
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 's'://imageHisto̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(0, 0, width, height, GL_RGB, GL_UNSIGNED_BYTE, imageHisto);
		saveBitmap24(width, height, imageHisto, HISTO_FILENAME_OUT); 
	  break;
  case 'S'://摜
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, image);
		saveBitmap24(imgWidth, imgHeight, image, FILENAME_OUT); 
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) gamma1 += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	gamma1 -= 0.05;  
		if(gamma1 < 0.0) gamma1 = 0.0;
		printf("gamma1 = %f \n", gamma1);
	}	
	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) gamma2 += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	gamma2 -= 0.05;  
		if(gamma2 < 0.0) gamma2 = 0.0;
		printf("gamma2 = %f \n", gamma2);
	}	
	if(key == GLUT_KEY_F3) 
	{
	  if(glutGetModifiers() == 0) levelCenter += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	levelCenter -= 1;  
		if(levelCenter < 0) levelCenter = 0;
		if(levelCenter > 255) levelCenter = 255;
		printf("levelCenter = %d \n", levelCenter);
	}	
	
	if(key == GLUT_KEY_F4) 
	{
	  if(glutGetModifiers() == 0) scale += 0.01;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	scale -= 0.01;  
		if(scale < 0.01) scale = 0.01;
		printf("\{ = %f \n", scale);
	}	
	display();
}
