/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

ől/ŏltB^iGrayScale)
ŒVF[_iOpenGL onlyj

*/
//摜t@C
#define FILENAME_IN "../../bmp256/matumaeNoise2.bmp"
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glut.h>
#include "../../bmpLoadSave.h"

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void maxFilter();
void minFilter();
void maxminFilter();

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte imageOut[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
//EChẼTCY
int width  = 800;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int type = 0;//max
int size = 3;//only 3
bool flagHelp = false;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGBA);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("GL_MaxMinGray");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
  //Cxg[vɓ
  glutMainLoop();
  return 0;
}

void init(void)
{
  //wiF
  //glClearColor(0.2, 0.2, 0.2, 1.0);
	//mN摜̎擾
	loadGrayData(image, &imgWidth, &imgHeight, FILENAME_IN);
  printf("}EX/L[̐ɂ'H'L[vbV \n");
}

void display(void)
{
  //J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);

	if(type == 0) maxFilter();
	else if(type == 1) minFilter();
	else if(type == 2) //closing
	{
		maxFilter();
		for(int j=0; j < imgHeight;j++)
			for(int i = 0; i < imgWidth; i++) image[i + j * imgWidth] = imageOut[i + j * imgWidth];
		minFilter();
	}
	else//opening
	{
		minFilter();
		for(int j=0; j < imgHeight;j++)
			for(int i = 0; i < imgWidth; i++) image[i + j * imgWidth] = imageOut[i + j * imgWidth];
		maxFilter();
	}

	//̈ʒu
	int qx0= px0;
	int qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;
	glRasterPos2i(qx0, qy0);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glDrawPixels(imgWidth, imgHeight, GL_LUMINANCE, GL_UNSIGNED_BYTE, imageOut);

	if(flagHelp)
  {
		printf("[F1]L[FtB^^Cvtype̕ύX \n");
  }
//I
  glFlush();
}

void maxFilter()
{
	int i, j, k, m;
	GLubyte gray[9];
	GLubyte value;
	int Size = size*size;
	int ss = (size - 1) / 2;//SБɃTCY

	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			if(i < ss || i >= imgWidth - ss - 1 || j < ss || j >= imgHeight - ss - 1) 
			{
				imageOut[i + j * imgWidth] = image[i + j * imgWidth];
				continue;
			}

			int n = 0;
			for(m = -ss; m <= ss; m++)
			{
				for(k = -ss; k <= ss; k++)
				{
					gray[n] = image[(i + k) + (j + m) * imgWidth];
					n++;
				}
			}
			
			value = 0;
			for(k = 0; k < Size; k++)
			{
				if(value < gray[k])
				{
					value = gray[k];
					//gray[k] = value;
				}
			}//k
			imageOut[i + j * imgWidth] = value;
		}//i
	}//j
}

void minFilter()
{
	int i, j, k, m;
	GLubyte gray[9];
	GLubyte value;
	int Size = size*size;
	int ss = (size - 1) / 2;//SБɃTCY

	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			if(i < ss || i >= imgWidth - ss - 1 || j < ss || j >= imgHeight - ss - 1) 
			{
				imageOut[i + j * imgWidth] = image[i + j * imgWidth];
				continue;
			}

			int n = 0;
			for(m = -ss; m <= ss; m++)
			{
				for(k = -ss; k <= ss; k++)
				{
					gray[n] = image[(i + k) + (j + m) * imgWidth];
					n++;
				}
			}
			//ёւ
			value = 255;
			for(k = 0; k < Size; k++)
			{
				if(value > gray[k])
				{
					value = gray[k];
				}
			}//k
			imageOut[i + j * imgWidth] = value;
		}//i
	}//j
}
void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒieϊj
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 's')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		saveBitmap8(imgWidth, imgHeight, imageOut, FILENAME_OUT); 
	  break;

	case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

	default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(key == GLUT_KEY_F1) 
	{
		type ++;
		if(type == 4) type = 0;
		if(type == 0)      printf("type = 0:max filter \n");
		else if(type == 1) printf("type = 1:min filter \n");
		else if(type == 2) printf("type = 2:closing filter \n");
		else               printf("type = 3:opening filter \n");
	}	

	loadGrayData(image, &imgWidth, &imgHeight, FILENAME_IN);
	display();
}

