/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

GtiColor)
ŒVF[_iOpenGL onlyj

*/
//摜t@C
//#define FILENAME_IN "../../bmp256/zone256.bmp"
#define FILENAME_IN "../../bmp256/matumae256-1.bmp"
//#define FILENAME_IN "../../bmp/Px1.bmp"
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glut.h>
#include "../../bmpLoadSave.h"

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void setUniformRandom();
void setNormalRandom();
double getNormalRandom(double mean, double sigma);
double random(double minValue, double maxValue);

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageNoise[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
//EChẼTCY
int width  = 800;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
//mCYp[^
double noiseAmp = 50.0;//GU
double sigma0 = 1.0;//Uɑ΂W΍
double probability = 0.2;//G^px
int seed = 0;
bool flagHelp = false;
enum TypeNoise {N_UNIFORM, N_NORMAL};
TypeNoise typeRandom = N_UNIFORM;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGBA);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("GL_NoiseColor");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
  //Cxg[vɓ
  glutMainLoop();
  return 0;
}

void init(void)
{
  //wiF
  glClearColor(0.2, 0.2, 0.2, 1.0);
	//mN摜̎擾
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	if(typeRandom == N_UNIFORM) printf("typeRandom = N_UNIFORM \n");
	else printf("typeRandom = N_NORMAL \n");
	printf("GUnoiseAmp = %f \n", noiseAmp);
	printf("W΍sigma0 = %f \n", sigma0);
	printf("pxprobability = %f \n", probability); 
	printf("nseed = %d \n", seed);
  printf("}EX/L[̐ɂ'H'L[vbV \n");
}

void display(void)
{
  //J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);

	if(typeRandom == N_UNIFORM) setUniformRandom();
	else                        setNormalRandom();
	//̈ʒu
	int qx0= px0;
	int qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;
	glRasterPos2i(qx0, qy0);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glDrawPixels(imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, imageNoise);

	if(flagHelp)
  {
		printf("[F1]L[F̎typeRandom \n");
		printf("[F2]L[FGUnoiseAmp̕ύX \n");
		printf("[F3]L[FW΍sigma0̕ύX \n");
		printf("[F4]L[Fpxprobability̕ύX \n");
		printf("[F5]L[Fnseed̕ύX \n");
		flagHelp = false;
  }
//I
  glFlush();
}

double random(double minV, double maxV)
{//minV`maxV̈l
	return( (maxV - minV) * (double)rand() / (double)RAND_MAX ) + minV;
}

void setUniformRandom()
{
	int i, j, k, nn;
  srand(seed);

	for(k = 0; k < 3; k++)
		for(j = 0;j < imgHeight; j++)
			for(i = 0; i < imgWidth; i++)
			{
				if(random(0.0, 1.0) > probability)
				{
					imageNoise[i + j * imgWidth][k] = image[i + j * imgWidth][k] ;
					continue;
				}
				int ran = int( noiseAmp * random(-1.0, 1.0));
//if(j==100 || j == 200) printf("ran = %d \n", ran);
				nn = image[i + j * imgWidth][k] + ran;
				if(nn > 255) nn = 255;
				if(nn < 0) nn = 0;
				imageNoise[i + j * imgWidth][k] = nn;
			}
}

void setNormalRandom()
{
	int i, j, k, nn;
  srand(seed);

	for(k = 0; k < 3; k++)
		for(j = 0;j < imgHeight; j++)
			for(i = 0; i < imgWidth; i++)
			{
				if(random(0.0, 1.0) > probability)
				{
					imageNoise[i + j * imgWidth][k] = image[i + j * imgWidth][k] ;
					continue;
				}
				nn = image[i + j * imgWidth][k] + int( noiseAmp * getNormalRandom(0.0, sigma0));
					if(nn > 255) nn = 255;
				if(nn < 0) nn = 0;
				imageNoise[i + j * imgWidth][k] = nn;
			}
}

//K
double getNormalRandom(double mean, double sigma)
{
  double ran = 0.0;
  for(int i = 0; i < 12; i++) ran += random(0.0, 1.0);
  ran -= 6.0;
  ran *= sigma;
	ran += mean;
//printf("ran = %f \n", ran);
  return ran;
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒieϊj
	gluOrtho2D(0.0, w, 0.0, h);
	//fOs̎wƏ
//  glMatrixMode(GL_MODELVIEW);
//  glLoadIdentity();

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 's')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		saveBitmap24(imgWidth, imgHeight, imageNoise, FILENAME_OUT); 
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

	default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(key == GLUT_KEY_F1) 
	{
	  if(typeRandom == N_UNIFORM)
		{
			typeRandom = N_NORMAL;
			printf("typeRandom = N_NORMAL \n");
		}
		else
		{
			typeRandom = N_UNIFORM;
			printf("typeRandom = N_UNIFORML \n");
		}
	}	

	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) noiseAmp += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	noiseAmp -= 1.0;  
		if(noiseAmp < 0.0) noiseAmp = 0.0;
		printf("GUnoiseAmp = %f \n", noiseAmp);
	}	
	if(key == GLUT_KEY_F3) 
	{
	  if(glutGetModifiers() == 0) sigma0 += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	sigma0 -= 0.1;  
		if(sigma0 < 0.1) sigma0 = 0.1;
		printf("W΍sigma0 = %f \n", sigma0);
	}	
	if(key == GLUT_KEY_F4) 
	{
	  if(glutGetModifiers() == 0) probability += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	probability -= 0.05;  
		if(probability < 0.0) probability = 0.0;
		if(probability > 1.0) probability = 1.0;
		printf("pxprobability  = %f \n", probability );
	}	
	if(key == GLUT_KEY_F5) 
	{
	  if(glutGetModifiers() == 0) seed += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	seed -= 1;  
	//	if(seed < 0.0) noiseAmp = 0.0;
		printf("nseed = %d \n", seed);
	}	

	display();
}

