
uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform int size;
uniform float sigmaD;
uniform float sigmaC;

varying vec2 pos;
//1f̋
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	int i, j, m, n;
	int s0 = (size-1) / 2;//Ǐ̈̒S
	float weight;
	vec2 offset;
	float d;
	//eNX`W̒ړ_
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 col0 =  texture2D(image, texCoord).rgb ;//Sfl
	vec3 col = vec3(0.0);
	vec3 colA = vec3(0.0);
	float sum = 0.0;//weight̑a
	for(j = 0; j < size; j++)
	{
		n = -s0 + j;
		for(i = 0; i < size; i++)
		{
			m = -s0 + i;
			offset = vec2(float(m) * dx, float(n) * dy) ;
			weight = exp(-float(m*m + n*n) / (2.0 * sigmaD * sigmaD));
      colA = texture2D(image, texCoord + offset).rgb;
      d = distance(colA, col0);//Fԋ
      weight *= exp(-d*d / (2.0 * sigmaC * sigmaC));
			sum += weight;
			col += colA * weight;			
		}
	}
	col /= sum;
  
	gl_FragColor = vec4(col, 1.0) ;	
}
