uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform float weight0;//ϒltB^̒S̏d
uniform int size;//tB^TCY
uniform float sigma;//W΍
uniform int type;//0FϒlC1F޳
varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	int i, j, m, n;
	int s0 = (size-1) / 2;//Ǐ̈̒S
	float weight;
	vec2 offset;
	vec3 col = vec3(0.0);
	//eNX`W̒ړ_
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);

	if(type == 0)//average
	{
		for(j = 0; j < size; j++)
			for(i = 0; i < size; i++)
			{ 
				offset = vec2(float(-s0 + i) * dx, float(-s0 + j) * dy) ;
				weight = 1.0 / (float(size * size) + weight0 - 1.0);
				col += texture2D(image, texCoord + offset).rgb * weight;
			}
	}

	else//Gaussian
	{			
		float sum = 0.0;//weight̑a
		for(j = 0; j < size; j++)
		{
			n = -s0 + j;
			for(i = 0; i < size; i++)
			{
				m = -s0 + i;
				offset = vec2(float(m) * dx, float(n) * dy) ;
				weight = exp(-float(m*m + n*n) / (2.0 * sigma * sigma));
				sum += weight;
				col += texture2D(image, texCoord + offset).rgb * weight;			
			}
		}
		col /= sum;//K
  }
	gl_FragColor = vec4(col, 1.0) ;	
}
