uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform float coef;
varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	int i, j;
	float weight[9];
	vec2 offset[9];
	//offseťvZ
	for(int j = 0; j < 3; j++)
		for(int i = 0; i < 3; i++)
		{ 
			offset[i + j * 3] = vec2(float(-1 + i) * dx, float(-1 + j) * dy) ;
		}

	//LaplacianɂNs̏d
	weight[0] =  0.0; weight[1] = -coef; weight[2] = 0.0;
	weight[3] = -coef; weight[4] = 1.0 + 4.0 * coef; weight[5] = -coef;
	weight[6] =  0.0; weight[7] = -coef; weight[8] =  0.0;
	
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 col = vec3(0.0);
	//ݍ݉Z
	for(j = 0; j < 9; j++) 
		col += texture2D(image, texCoord + offset[j]) * weight[j];
	
	gl_FragColor = vec4(col, 1.0);
}
