/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

N}L[
OpenGL + GLSL
*/
//摜t@C
#define FILENAME_IN_0 "../../bmp256/1.bmp"
#define FILENAME_IN_1 "../../bmp256/giraffe.bmp"

#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../bmpLoadSave.h"

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void drawPlate();
void setTexture(int n);
void special(int key, int x, int y);

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image1[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte image2[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
//EChẼTCY
int width  = 800;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int qy0;//
//VF[_vO
GLuint program;
//texture object
GLuint texName[2];
//chroma key
float chroma[] = {0.0, 0.0, 1.0};
float delta1 = 0.2;
float delta2 = 0.3;

//wvL[tO
bool flagHelp = false;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGB);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_ChromaKey");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
	initGlsl(&program, "chroma.vert", "chroma.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteProgram(program);
  return 0;
}

void init(void)
{
  //wiF
  glClearColor(0.2, 0.2, 0.2, 1.0);
	//J[摜̎擾
	loadColorData(image1, &imgWidth, &imgHeight, FILENAME_IN_0);
	loadColorData(image2, &imgWidth, &imgHeight, FILENAME_IN_1);
//	posMouse[0] = (float)imgWidth / 2.0;
//	posMouse[1] = (float)imgHeight / 2.0;

	glGenTextures(2, texName);//eNX`IuWFNg̖Ot
	setTexture(0);
	setTexture(1);
  printf("}EX/L[̐ɂ'H'L[vbV \n");
}

void setTexture(int n)
{
  glBindTexture(GL_TEXTURE_2D, texName[n]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
	if(n == 0)
		glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image1);
	else
		glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image2);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void display(void)
{
	//J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);

	//
  glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);
  glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, texName[1]);

  // VF[_vO̓Kp 
	glUseProgram(program);
	GLint image1Loc = glGetUniformLocation(program, "image1");
	glUniform1i(image1Loc, 0);//GL_TEXTURE0Kp
	GLint image2Loc = glGetUniformLocation(program, "image2");
	glUniform1i(image2Loc, 1);//GL_TEXTURE1Kp
	GLint imgWidthLoc = glGetUniformLocation(program, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint chromaLoc = glGetUniformLocation(program, "chroma");
	glUniform3fv(chromaLoc, 1, chroma);
	GLint delta1Loc = glGetUniformLocation(program, "delta1");
	glUniform1f(delta1Loc, delta1);
	GLint delta2Loc = glGetUniformLocation(program, "delta2");
	glUniform1f(delta2Loc, delta2);

	qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;

	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	drawPlate();
	glPopMatrix();
  // VF[_vỎ 
  glUseProgram(0);
	if(flagHelp)
  {
		printf("[F1]L[Falphal̕ύX \n");
		flagHelp = false;
  }

  //I
	glFlush();
}

void drawPlate()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth, 0);
		glVertex2i(imgWidth, imgHeight);
		glVertex2i(0, imgHeight);
	glEnd();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒ
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, image1);
		saveBitmap24(imgWidth, imgHeight, image1, FILENAME_OUT); 
	  break;

	case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}
void special(int key, int x, int y)
{
	
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) delta1 += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	delta1 -= 0.05; 
		if(delta1 < 0.0) delta1 = 0.0;
		if(delta1 > delta2) delta1 = delta2;
		printf("delta1 = %f \n", delta1); 
	}
	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) delta2 += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	delta2 -= 0.05; 
		if(delta2 < delta1) delta2 = delta1;
		if(delta2 > 1.0) delta2 = 1.0;
		printf("delta2 = %f \n", delta2); 
	}

	display();
}
