/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

ʓx𗘗pGbWoiColor)
PrewittCSobel,Roberts,Laplacian
OpenGL + GLSL

*/
//摜t@C
//#define FILENAME_IN "../../bmp/Px1.bmp"
//#define FILENAME_IN "../../bmp256/matumae256-1.bmp"
#define FILENAME_IN "../../bmp256/fruits1.bmp"
//o͉摜t@C
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../bmpLoadSave.h"

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void drawPlate();
void setTexture();
void special(int key, int x, int y);

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
//EChẼTCY
int width  = 800;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int qy0;//
//VF[_vO
GLuint program;
int type = 0;//Prewitt
int inverse = 0;//]
int binary = 0;//2l
int grad = 0;//xNg̑傫\
float threshold = 0.5;
int space = 0;//YCC
//wvL[tO
bool flagHelp = false;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGB);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_EdgeFilterChroma");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
	initGlsl(&program, "edgeChroma.vert", "edgeChroma.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteProgram(program);
  return 0;
}

void init(void)
{
  //wiF
  glClearColor(0.2, 0.2, 0.2, 1.0);
	//J[摜̎擾
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	setTexture();

	if(type == 0) printf("PrewitttB^̎s@\n");
	else if(type == 1) printf("SobeltB^̎s@\n");
	else if(type == 2) printf("RobertstB^̎s \n");
	else               printf("LaplaciantB^̎s \n");


  printf("}EX/L[̐ɂ'H'L[vbV \n");
}


void setTexture()
{
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);//NEAREST);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);//NEAREST);
}

void display(void)
{
  //Ԍv
  LARGE_INTEGER freq, time1, time2;
	DWORD pTime;
	memset(&freq,  0x00, sizeof freq);
	memset(&time1, 0x00, sizeof time1);
	memset(&time2, 0x00, sizeof time2);
	pTime = 0;

	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &time1);

	//J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);

	//摜
  // VF[_vO̓Kp 
  glUseProgram(program);
  GLint imageLoc = glGetUniformLocation(program, "image");
  glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint imgWidthLoc = glGetUniformLocation(program, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint typeLoc = glGetUniformLocation(program, "type");
	glUniform1i(typeLoc, type);
	GLint gradLoc = glGetUniformLocation(program, "grad");
	glUniform1i(gradLoc, grad);
	GLint inverseLoc = glGetUniformLocation(program, "inverse");
	glUniform1i(inverseLoc, inverse);
	GLint binaryLoc = glGetUniformLocation(program, "binary");
	glUniform1i(binaryLoc, binary);
	GLint thresholdLoc = glGetUniformLocation(program, "threshold");
	glUniform1f(thresholdLoc, threshold);
	GLint spaceLoc = glGetUniformLocation(program, "space");
	glUniform1i(spaceLoc, space);

	qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;

	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	drawPlate();
	glPopMatrix();
  // VF[_vỎ 
  glUseProgram(0);

	QueryPerformanceCounter( &time2);
	pTime = (DWORD)((time2.QuadPart - time1.QuadPart) * 1000000 / freq.QuadPart);
	printf(" = %d[s] \n", pTime);

	if(flagHelp)
  {
		printf("[F1]L[FtB^̎ނ̕ύX \n");
		printf("[F2]L[FžvZ̕ύX \n");
		printf("[F3]L[F]\̐؂ւ \n");
		printf("[F4]L[F2l\̐؂ւ \n");
		printf("[F5]L[F2ll̕ύX \n");
		printf("[F6]L[FFԂ̕ύX \n");
		flagHelp = false;
  }
  //I
	glFlush();
}

void drawPlate()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth, 0);
		glVertex2i(imgWidth, imgHeight);
		glVertex2i(0, imgHeight);
	glEnd();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒ
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, image);
		saveBitmap24(imgWidth, imgHeight, image, FILENAME_OUT); 
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(key == GLUT_KEY_F1) 
	{
		type ++;
		if(type == 4) type = 0;
		if(type == 0)      printf("PrewitttB^̎s \n");
		else if(type == 1) printf("SobeltB^̎s \n");
		else if(type == 2) printf("RobertstB^̎s \n");
		else               printf("LaplaciantB^̎s \n");
	}
	if(key == GLUT_KEY_F2) 
	{
		grad ++;
		if(grad == 3) grad = 0;
		if(grad == 0) printf("xNg̑傫 \n");
		else if(grad == 1) printf("Zlŕ\ \n");
		else printf("őlŕ\ \n");
	}
	if(key == GLUT_KEY_F3) 
	{
		inverse ++;
		if(inverse == 2) inverse = 0;
		if(inverse == 0) printf("]\łȂ \n");
		else printf("]\ \n");
	}
	if(key == GLUT_KEY_F4) 
	{
		binary ++;
		if(binary == 2) binary = 0;
		if(binary == 0) printf("2l\łȂ \n");
		else printf("2l\ \n");
	}
	if(key == GLUT_KEY_F5) 
	{
	  if(glutGetModifiers() == 0) threshold += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	threshold -= 0.05;  
		if(threshold < 0.0) threshold = 0.0;
		if(threshold > 1.0) threshold = 1.0;
		printf("lthreshold = %f \n", threshold); 
	}
	if(key == GLUT_KEY_F6) 
	{
		space ++;
		if(space == 3) space = 0;
		if(space == 0) printf("YCC-HSYF \n");
		else if(space == 1) printf("HSLF \n");
		else printf("HSVF \n");
	}


	display();
}
