
uniform sampler2D imageMask;
uniform sampler2D image1;
uniform sampler2D image2;
uniform int imgWidth, imgHeight;
varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	int i, j, k, l;
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 mask = texture2D(imageMask, texCoord).rgb;
	float alpha = mask.r;
	vec3 col1 = texture2D(image1, texCoord).rgb;
	vec3 col2 = texture2D(image2, texCoord).rgb;
	vec3 col = mix(col1, col2, alpha);
	gl_FragColor = vec4(col, 1.0);		
}
