/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

HSVɂ掿ϊ

OpenGL + GLSL
*/

//摜t@C
//#define FILENAME_IN "../../bmp256/fruits1.bmp"
#define FILENAME_IN "../../bmp256/vegetables1.bmp"
//#define FILENAME_IN "../../bmp256/s[}1.bmp"

#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../bmpLoadSave.h"

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void drawPlate();
void setTexture();
void special(int key, int x, int y);

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
//EChẼTCY
int width  = 800;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int qy0;//
//VF[_vO
GLuint program;
float deltaHue = 30.0;
float deltaChroma = 0.1;
float deltaValue = 0.1;
//wvL[tO
bool flagHelp = false;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGB);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_QualityTransformHSV");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
	initGlsl(&program, "hsv.vert", "hsv.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteProgram(program);
  return 0;
}

void init(void)
{
  //wiF
  glClearColor(0.2, 0.2, 0.2, 1.0);
	//J[摜̎擾
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	setTexture();

  printf("}EX/L[̐ɂ'H'L[vbV \n");
}


void setTexture()
{
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);//NEAREST);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);//NEAREST);
}

void display(void)
{
  //Ԍv
  LARGE_INTEGER freq, time1, time2;
	DWORD pTime;
	memset(&freq,  0x00, sizeof freq);
	memset(&time1, 0x00, sizeof time1);
	memset(&time2, 0x00, sizeof time2);
	pTime = 0;

	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &time1);

	//J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);

  // VF[_vO̓Kp 
	glUseProgram(program);
	GLint imageLoc = glGetUniformLocation(program, "image");
	glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint imgWidthLoc = glGetUniformLocation(program, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint hueLoc = glGetUniformLocation(program, "deltaHue");
	glUniform1f(hueLoc, deltaHue);
	GLint chromaLoc = glGetUniformLocation(program, "deltaChroma");
	glUniform1f(chromaLoc, deltaChroma);
	GLint valueLoc = glGetUniformLocation(program, "deltaValue");
	glUniform1f(valueLoc, deltaValue);

	qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;

	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	drawPlate();
	glPopMatrix();
  // VF[_vỎ 
  glUseProgram(0);

	QueryPerformanceCounter( &time2);
	pTime = (DWORD)((time2.QuadPart - time1.QuadPart) * 1000000 / freq.QuadPart);
	printf(" = %d[s] \n", pTime);

	if(flagHelp)
  {
		printf("[F1]L[FF̕ύX \n");
		printf("[F2]L[Fʓx̕ύX \n");
		printf("[F3]L[Fx̕ύX \n");
		flagHelp = false;
  }
  //I
	glFlush();
}

void drawPlate()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth, 0);
		glVertex2i(imgWidth, imgHeight);
		glVertex2i(0, imgHeight);
	glEnd();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒ
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, image);
		saveBitmap24(imgWidth, imgHeight, image, FILENAME_OUT); 
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) deltaHue += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	deltaHue -= 1.0;  
		printf("F = %f \n", deltaHue); 
	}
	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) deltaChroma += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	deltaChroma -= 0.05;  
		printf("ʓx = %f \n", deltaChroma); 
	}
	if(key == GLUT_KEY_F3) 
	{
	  if(glutGetModifiers() == 0) deltaValue += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	deltaValue -= 0.05;  
		printf("x = %f \n", deltaValue); 
	}

	display();
}
