/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

FUCNi\GCGj
__zu
OpenGL + GLSL
*/
//摜t@C
//#define FILENAME_IN "../../bmp/Px1.bmp"
//#define FILENAME_IN "../../bmp256/matumae256-1.bmp"
//#define FILENAME_IN "../../bmp256/Lenna.bmp"
//#define FILENAME_IN "../../bmp512/child1.bmp"
//#define FILENAME_IN "../../bmp256/flower1.bmp"
#define FILENAME_IN "../../bmp256/dog3-2.bmp"

//o͉摜t@C
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include <math.h>
#include "../../myGlsl.h"
#include "../../bmpLoadSave.h"
#define NUM_GEN_MAX  MAX_IMG_HEIGHT * MAX_IMG_WIDTH / 16
#define M_PI 3.14159265358979323846

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void drawPlate();
void levelTrans();
void setTexture();
void setTextureVoronoi();
void setTextureRandomVoronoi();
void makeUniformRandom();
void makeVoronoi(short* posX, short* posY, float* red, float* green, float* blue);
void makeRandomVoronoi(short* posX, short* posY, float* red, float* green, float* blue);
double random(double minV, double maxV);

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte image2[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageVoronoi[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageRandom[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
//EChẼTCY
int width  = 800;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int qy0;//
int size = 10;//~̃TCY
int interval = 4;//_Ԋu
int numGen = 1000;//_
float th = 1.5;//GbW\l
int nLevel = 8;//K
float gamma = 2.0;//Px̃K}l

//VF[_vO
GLuint program;
//texture object
GLuint texName[3];
//wvL[tO
bool flagHelp = false;
//Ԍv
LARGE_INTEGER freq, time1, time2;
DWORD pTime;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGB | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_ColorPaper2");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
	initGlsl(&program, "colorPaper.vert", "colorPaper.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteProgram(program);
  return 0;
}

void init(void)
{
	glEnable(GL_DEPTH_TEST);	
	//wiF
  glClearColor(0.2, 0.2, 0.2, 1.0);
	//J[摜̎擾
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	glGenTextures(3, texName);//eNX`IuWFNg̖Ot
}

void setTextureVoronoi()
{
  glBindTexture(GL_TEXTURE_2D, texName[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,imageVoronoi);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}
void setTextureRandomVoronoi()
{
  glBindTexture(GL_TEXTURE_2D, texName[1]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,imageRandom);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}
void display(void)
{
  //Ԍv
  LARGE_INTEGER freq, time1, time2;
	DWORD pTime;
	memset(&freq,  0x00, sizeof freq);
	memset(&time1, 0x00, sizeof time1);
	memset(&time2, 0x00, sizeof time2);
	pTime = 0;

	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &time1);

	//_̈ʒuƐF̃m
	short *posX, *posY;
	float *red, *green, *blue;
	posX = (short*)malloc(numGen * sizeof(short));
	posY = (short*)malloc(numGen * sizeof(short));
	red = (float*)malloc(numGen * sizeof(float));
	green = (float*)malloc(numGen * sizeof(float));
	blue = (float*)malloc(numGen * sizeof(float));
	if(posX == NULL || posY == NULL || red == NULL || green == NULL || blue == NULL)
	{
		printf("_̃mۂł܂ \n");
		return;
	}

	srand(0);
	levelTrans();
	//VoronoiMapeNX`摜쐬
	makeVoronoi(posX, posY, red, green, blue);

	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	resize(width, height);
	qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;

	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	glColor3f(0.8, 0.95, 0.95);//䎆̐F
	drawPlate();
	double ran;
	srand(0);
	for(int k = 0; k < numGen; k++)
	{
		glColor3f(red[k], green[k], blue[k]);
		glPushMatrix();
		glTranslatef((float)posX[k], (float)posY[k], 0);
		ran = random(-10.0, 10.0);
		glutSolidCone(size+ran, size+ran, 6, 2);
//		glutSolidCone(size, size, 6, 2);
		glPopMatrix();
	}
	glPopMatrix();
	//t[obt@Ƀ_ÔeNX`摜Ƃ
 	glPixelStorei(GL_PACK_ALIGNMENT, 1);
	glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, imageVoronoi);
	setTextureVoronoi();

	//J[Voronoi摜
	makeRandomVoronoi(posX, posY, red, green, blue);
	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	srand(0);
	for(int k = 0; k < numGen; k++)
	{
		glColor3f(red[k], green[k], blue[k]);
		glPushMatrix();
		glTranslatef((float)posX[k], (float)posY[k], 0);
		ran = random(-10.0, 10.0);
		glutSolidCone(size+ran, size+ran, 6, 2);
//		glutSolidCone(size, size, 6, 2);
		glPopMatrix();
	}
	glPopMatrix();
	//t[obt@Ƀ_ÔeNX`摜Ƃ
 	glPixelStorei(GL_PACK_ALIGNMENT, 1);
	glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, imageRandom);
	setTextureRandomVoronoi();

	//VF[_ŃeNX`摜\
	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	resize(width, height);

  glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);
  glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, texName[1]);
  glActiveTexture(GL_TEXTURE2);
  glBindTexture(GL_TEXTURE_2D, texName[2]);

  // VF[_vO̓Kp 
	glUseProgram(program);

	GLint image0Loc = glGetUniformLocation(program, "imageVoronoi");
	glUniform1i(image0Loc, 0);//GL_TEXTURE0Kp

	GLint image1Loc = glGetUniformLocation(program, "imageRandom");
	glUniform1i(image1Loc, 1);//GL_TEXTURE1Kp
	GLint imgWidthLoc = glGetUniformLocation(program, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint thLoc = glGetUniformLocation(program, "th");
	glUniform1f(thLoc, th);

//	qy0 = height - imgHeight- py0;
//	if(qy0 < 0) qy0 = 0;
	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	drawPlate();
	glPopMatrix();

	// VF[_vỎ 
  glUseProgram(0);

	QueryPerformanceCounter( &time2);
	pTime = (DWORD)((time2.QuadPart - time1.QuadPart) * 1000 / freq.QuadPart);
	printf(" = %d[ms] \n", pTime);
	if(flagHelp)
  {
		printf("[F1]L[F_numGen̕ύX \n");
		printf("[F2]L[F~TCYsize̕ύX \n");
		printf("[F3]L[FGbW\lth̕ύX \n");
		printf("[F4]L[FK}lgammȃ \n");
		printf("[F5]L[FKnLevel̑ \n");
		flagHelp = false;
  }
  //I
	glFlush();
	free(posX);
	free(posY);
	free(red);
	free(green);
	free(blue);
}

void levelTrans()
{//ZxxϊƊK팸
	int i, j, k, m, n;
	double zStep = 255.0 / float(nLevel-1);

	for(m = 0; m < 3; m++)
	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			k = i + j * imgWidth;
			//Px
			image2[k][m] = (GLubyte)(pow((double)image[k][m]/255.0, (double)gamma) * 255.0);
			//Kጸ
			n = floor((double)image2[k][m] / zStep + 0.5);
			image2[k][m] = (GLubyte)(zStep * n);
		}
	}
}

void makeVoronoi(short* posX, short* posY, float* red, float* green, float* blue)
{
	int k, n;

	//_̈ʒuƐF
	for(k = 0; k < numGen; k++){
		posX[k] = (short)(random(2.0, (double)(imgWidth-2)));  
		posY[k] = (short)(random(2.0, (double)(imgHeight-2))); 
		n = posX[k] + posY[k] * imgWidth;
		red[k]   = (float)image2[n][0] / 255.0 ;
		green[k] = (float)image2[n][1] / 255.0 ;
		blue[k]  = (float)image2[n][2] / 255.0 ;
	}
}

double random(double minV, double maxV)
{//minV`maxV̈l
	return( (maxV - minV) * (double)rand() / (double)RAND_MAX ) + minV;
}
void makeRandomVoronoi(short* posX, short* posY, float* red, float* green, float* blue)
{
	int k;

	for(k = 0; k < numGen; k++)
	{
	  red[k]   = random(0.0, 1.0);
	  green[k] = random(0.0, 1.0);
	  blue[k]  = random(0.0, 1.0);
	}
}

void drawPlate()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth, 0);
		glVertex2i(imgWidth, imgHeight);
		glVertex2i(0, imgHeight);
	glEnd();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒ
//	gluOrtho2D(0.0, w, 0.0, h);
	glOrtho(0.0, w, 0.0, h, -size-50, 50);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, image);
		saveBitmap24(imgWidth, imgHeight, image, FILENAME_OUT); 
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}


void special(int key, int x, int y)
{
	
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) numGen += 50;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	numGen -= 50;  
		if(numGen > MAX_IMG_HEIGHT * MAX_IMG_WIDTH / 16) numGen = MAX_IMG_HEIGHT * MAX_IMG_WIDTH / 16;
		printf("numGen = %d \n", numGen);
	}
	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) size += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	size -= 1;  
		printf("size = %d \n", size);
	}
	if(key == GLUT_KEY_F3) 
	{
	  if(glutGetModifiers() == 0) th += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	th -= 0.05; 
		if(th < 0.0) th = 0.0;
		//if(th > 1.0) th = 1.0;
		printf("th = %f \n", th); 
	}

	if(key == GLUT_KEY_F4) 
	{
	  if(glutGetModifiers() == 0) gamma += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	gamma -= 0.05;  
		if(gamma < 0.1) gamma = 0.1;
		printf("K}lgamma = %f \n", gamma);
	}	

	if(key == GLUT_KEY_F5) 
	{
	  if(glutGetModifiers() == 0) nLevel += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	nLevel -= 1;  
		if(nLevel < 2) nLevel = 2;
		else if(nLevel == 17) nLevel = 32;
		else if(nLevel == 33) nLevel = 64;
		else if(nLevel == 65) nLevel = 128;
		else if(nLevel == 129) nLevel = 256;
		else if(nLevel >= 256) nLevel = 256;
		else if(nLevel == 255) nLevel = 128;
		else if(nLevel == 127) nLevel = 64;
		else if(nLevel == 63) nLevel = 32;
		else if(nLevel == 31) nLevel = 16;
		printf("KnLevel = %d \n", nLevel);
	}

	display();
}


