/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

M
OpenGL + GLSL
ڂGLSL
*/
//摜t@C
//#define FILENAME_IN "../../bmp/Px1.bmp"
//#define FILENAME_IN "../../bmp/O.bmp"
//#define FILENAME_IN "../../bmp256/matumae256-1.bmp"
#define FILENAME_IN "../../bmp256/Lenna.bmp"
//#define FILENAME_IN "../../bmp256/boat.bmp"

//o͉摜t@C
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <math.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../bmpLoadSave.h"
#define M_PI  3.14159265358979

//֐̃vg^Cv錾
void init();
void display();
void special(int key, int x, int y);
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void drawPlate();
void drawStroke();
double random(double minV, double maxV);
void prewitt(float* dx, float* dy);
void getImageEdge();
void levelTrans();
void gaussian();
void setTexture();

//O[oϐ
//摜̃TCYƔz
int imgWidth, imgHeight;
GLubyte imageGray[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte imageGray2[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte imageOut[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte imageEdge[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLbyte edgeDirX[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLbyte edgeDirY[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];

//EChẼTCY
int width  = 600;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int qx0, qy0;//
enum TypeStroke {S_HATCH_R, S_HATCH_L, S_EDGE};
TypeStroke typeStroke = S_HATCH_R;
enum ModeRender {M_STROKE, M_EDGE, M_BOTH};
ModeRender modeRender = M_BOTH;
float gamma = 1.0;      //`Zxϊ̃K}l
int nLevel = 8;         //K
int lengthStroke = 3;   //Xg[NiБj
int widthStroke = 2;    //Xg[N̕
float depthStroke = 0.05;//Xg[N̔Z(̕j
float probStroke = 0.1; //mx
float minGray = 0.3;    //Zxŏx
int size = 3;           //Gaussian filter̃TCY
//VF[_vO
GLuint program;

bool flagHelp = false;
//bool flagEdge = false;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGBA);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_GrayPencil");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
	initGlsl(&program, "gaussian.vert", "gaussian.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteProgram(program);
  return 0;
}

void init(void)
{
  //wiF
  glClearColor(0.2, 0.2, 0.2, 1.0);
	loadGrayData(imageGray, &imgWidth, &imgHeight, FILENAME_IN);
  printf("}EX/L[̐ɂ'H'L[vbV \n");
}

void setTexture()
{
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_LUMINANCE,GL_UNSIGNED_BYTE,imageOut);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
}

void display(void)
{
  //Ԍv
  LARGE_INTEGER freq, time1, time2;
	DWORD pTime;
	memset(&freq,  0x00, sizeof freq);
	memset(&time1, 0x00, sizeof time1);
	memset(&time2, 0x00, sizeof time2);
	pTime = 0;

	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &time1);

	//PxƊKጸ
	levelTrans();
	//GbW摜ƃGbW̎擾
	getImageEdge();

 //J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);
	//̈ʒu
	qx0= px0;
	qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;
	if(modeRender == M_EDGE || modeRender == M_BOTH)
	{
		glRasterPos2i(qx0, qy0);
		glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
		glDrawPixels(imgWidth, imgHeight, GL_LUMINANCE, GL_UNSIGNED_BYTE, imageEdge);
	}
	if(modeRender == M_STROKE || modeRender == M_BOTH)
	{
		glPushMatrix();
		glTranslatef(qx0, qy0, 0.0);
		if(modeRender == M_STROKE) drawPlate();//
		drawStroke();
		glPopMatrix();
	}

	//ڂGLSLōs
	//܂ŕ`摜擾eNX`摜imageƂėp
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RED, GL_UNSIGNED_BYTE, imageOut);
	
	setTexture();
	glUseProgram(program);
	GLint imageLoc = glGetUniformLocation(program, "image");
	glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint imgWidthLoc = glGetUniformLocation(program, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint sizeLoc = glGetUniformLocation(program, "size");
	glUniform1i(sizeLoc, size);

	glPushMatrix();
	glTranslatef(px0, qy0, 0.0);
	drawPlate();
	glPopMatrix();
	// VF[_vỎ 
	glUseProgram(0);

	QueryPerformanceCounter( &time2);
	pTime = (DWORD)((time2.QuadPart - time1.QuadPart) * 1000 / freq.QuadPart);
	printf(" = %d[ms] \n", pTime);

	if(flagHelp)
  {
		printf("[F1]L[FtB^TCYsizȇ \n");
		printf("[F2]L[F`Zxϊ̃K}lgammȃ \n");
		printf("[F3]L[FKnLevel̑ \n");
		printf("[F4]L[FXg[NlengthStrokȇ \n");
		printf("[F5]L[FXg[NwidthStrokȇ  \n");
		printf("[F6]L[FXg[NZxdepthStrokȇ \n");
		printf("[F7]L[FmxprobStrokȇ \n");
		printf("[F8]L[FXg[N^CvtypeStroke̕ύX\n");
		printf("[F9]L[F`惂[hmodeRender̕ύX \n");
		printf("[F10]L[FGbWZxxminGray̑ \n");
		flagHelp = false;
  }

	//I
  glFlush();
}

void levelTrans()
{//ZxxϊƊK팸
	int i, j, k, kk;
	double zStep = 255.0 / float(nLevel-1);

	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			k = i + j * imgWidth;
			//`Zxϊ
			imageGray2[k] = (GLubyte)(pow((double)imageGray[k]/255.0, (double)gamma) * 255.0);
			//posterization
			kk = floor((double)imageGray2	[k] / zStep + 0.5);
			imageGray2[k] = (GLubyte)(zStep * kk);
		}
	}
}

void prewitt(float* dx, float* dy)
{
	int i, j, k, m, ii, jj;
	float prewittX[9] = {-1.0, 0.0, 1.0, -1.0, 0.0, 1.0, -1.0, 0.0, 1.0};
	float prewittY[9] = {-1.0,-1.0,-1.0,  0.0, 0.0, 0.0,  1.0, 1.0, 1.0};
	double gray;

	//R{[V
	for(j = 1; j < imgHeight-1; j++)
	{
		for(i = 1; i < imgWidth-1; i++)
		{
			k = i + j * imgWidth;
			dx[k] = 0.0;
			dy[k] = 0.0;
			for(jj = -1; jj <= 1; jj++)
			{
				for(ii = -1; ii <= 1; ii++)
				{
					m = 1+ii + (1+jj) * 3;
					dx[k] += (float)imageGray[i+ii + (j+jj) * imgWidth] * prewittX[m];
					dy[k] += (float)imageGray[i+ii + (j+jj) * imgWidth] * prewittY[m];
				}
			}
			gray =  255.0 - sqrt(dx[k]*dx[k] + dy[k]*dy[k]);//]
			if(gray > 255.0) imageEdge[k] = 255;
			else if(gray < minGray * 255.0) imageEdge[k] = (GLubyte)(minGray * 255.0);
			else imageEdge[k] = (GLubyte)gray;

		}
	}
}

void getImageEdge()
{
	int i, j, k;
	double dxx, dyy, mag;
	double c = 0.5 / sin(M_PI/8.0);

	float *dx, *dy;//l
	dx = (float*)malloc(imgWidth * imgHeight * sizeof(float));
	dy = (float*)malloc(imgWidth * imgHeight * sizeof(float));
	if(dx == NULL || dy == NULL) {
		printf("dx, dy ̃mۂł܂ \n");
		return;
	}

	prewitt(dx, dy);

	for(j = 1; j < imgHeight-1; j++)
	{
		for(i = 1; i < imgWidth - 1; i++)
		{
			k = i + j * imgWidth;
			dxx = (double)dx[k];
			dyy = (double)dy[k];
			mag = sqrt(dxx*dxx + dyy*dyy);//z̑傫
			if(mag < 30)
			{//ẑ₩ȕ͉E->̃nb`Ƃ
				edgeDirX[k] = 1;
				edgeDirY[k] = 1;
				continue;
			}
			//edge̕
			edgeDirY[k] = (GLbyte)floor( (dxx/mag) * c + 0.5) ;//zxGbWy
			edgeDirX[k] =-(GLbyte)floor( (dyy/mag) * c + 0.5) ;//zyGbWx
		}
	}
	free(dx);
	free(dy);
}

double random(double minV, double maxV)
{//minV`maxV̈l
	return( (maxV - minV) * (double)rand() / (double)RAND_MAX ) + minV;
}

void drawStroke()
{
	int i, j, k;
	float gg;

	//
  glLineWidth(widthStroke);

	if(lengthStroke == 0) return;
	for(j = 0; j < imgHeight; j++)
		for(i = 0; i < imgWidth; i++)
		{
			k = i + j * imgWidth;
			//M̔Z摜̖邳ɂقڈv
			gg =  (float)imageGray2[k] / 255.0 + random(-depthStroke, depthStroke);
			if(gg < minGray) gg = minGray;
			glColor3f(gg, gg, gg);
	
			//Â̊m
			if(random(0.0, 1.0) > 1.0 - probStroke + 0.1 * (float)imageGray2[k] / 255.0)
			{
				glBegin(GL_LINES);
					if(typeStroke == S_HATCH_R) 
					{
						glVertex2i( i - lengthStroke, j - lengthStroke);
						glVertex2i( i + lengthStroke, j + lengthStroke);
					}
					else if(typeStroke == S_HATCH_L)
					{
						glVertex2i( i + lengthStroke, j - lengthStroke);
						glVertex2i( i - lengthStroke, j + lengthStroke);
					}
					else
					{
						glVertex2i( i - lengthStroke*edgeDirX[k], j - lengthStroke*edgeDirY[k]);
						glVertex2i( i + lengthStroke*edgeDirX[k], j + lengthStroke*edgeDirY[k]);
					}
				glEnd();
			}
		}
}

void drawPlate()
{
  glColor3f(1.0, 1.0, 1.0);
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth, 0);
		glVertex2i(imgWidth, imgHeight);
		glVertex2i(0, imgHeight);
	glEnd();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒieϊj
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}


void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

		case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RED, GL_UNSIGNED_BYTE, imageOut);
		saveBitmap8(imgWidth, imgHeight, imageOut, FILENAME_OUT); 
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) size += 2;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	size -= 2;  
		if(size < 1) size = 1;
		if(size > 9) size = 9;
		printf("tB^TCY = %d \n", size);
	}	

	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) gamma += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	gamma -= 0.05;  
		if(gamma < 0.1) gamma = 0.1;
		printf("K}lgamma = %f \n", gamma);
	}	

	if(key == GLUT_KEY_F3) 
	{
	  if(glutGetModifiers() == 0) nLevel += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	nLevel -= 1;  
		if(nLevel < 2) nLevel = 2;
		else if(nLevel == 17)  nLevel = 32;
		else if(nLevel == 33)  nLevel = 64;
		else if(nLevel == 65)  nLevel = 128;
		else if(nLevel == 129) nLevel = 256;
		else if(nLevel >= 256) nLevel = 256;
		else if(nLevel == 255) nLevel = 128;
		else if(nLevel == 127) nLevel = 64;
		else if(nLevel == 63)  nLevel = 32;
		else if(nLevel == 31)  nLevel = 16;
		printf("xK = %d \n", nLevel); 
	}

	if(key == GLUT_KEY_F4) 
	{
	  if(glutGetModifiers() == 0) lengthStroke += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	lengthStroke -= 1;  
		if(lengthStroke < 0) lengthStroke = 0;
		printf("Xg[NlengthStroke = %d \n", lengthStroke);
	}

	if(key == GLUT_KEY_F5) 
	{
	  if(glutGetModifiers() == 0) widthStroke += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	widthStroke -= 1;  
		if(widthStroke < 0) widthStroke = 0;
		printf("Xg[NwidthStroke = %d \n", widthStroke);
	}
	if(key == GLUT_KEY_F6) 
	{
	  if(glutGetModifiers() == 0) depthStroke += 0.01;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	depthStroke -= 0.01;  
		if(depthStroke < 0) depthStroke = 0;
		printf("Xg[NZxdepthStroke = %f \n", depthStroke);
	}

	if(key == GLUT_KEY_F7) 
	{
	  if(glutGetModifiers() == 0) probStroke += 0.01;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	probStroke -= 0.01;  
		if(probStroke < 0.0) probStroke = 0.0;
		printf("mxprobStroke = %f \n", probStroke);
	}	

	if(key == GLUT_KEY_F8) 
	{
		if(typeStroke == S_HATCH_R) {
			typeStroke = S_HATCH_L; printf("nb` \n");}
		else if(typeStroke == S_HATCH_L) {
			typeStroke = S_EDGE; printf("GbW \n");}
		else if(typeStroke == S_EDGE){
			typeStroke = S_HATCH_R; printf("Enb` \n");}
	}	

	if(key == GLUT_KEY_F9) 
	{
		if(modeRender == M_BOTH){
			modeRender = M_STROKE ; printf("Xg[N` \n");}
		else if(modeRender == M_STROKE) {
			modeRender = M_EDGE; printf("GbW` \n");}
		else if(modeRender == M_EDGE) {
			modeRender = M_BOTH ; printf("摜` \n");}
	}

	if(key == GLUT_KEY_F10) 
	{
	  if(glutGetModifiers() == 0) minGray += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	minGray -= 0.05;  
		if(minGray < 0.0) minGray = 0.0;
		if(minGray > 1.0) minGray = 1.0;
		printf("Zxŏl = %f \n", minGray);
	}	

	display();
}

