/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

VoronoïXg[NƂʉ
embossǉ
KI_zu
OpenGL + GLSL

*/
//摜t@C
#define FILENAME_IN "../../bmp/Px1.bmp"
//#define FILENAME_IN "../../bmp256/lenna.bmp"
//#define FILENAME_IN "../../bmp256/dog3-2.bmp"

//o͉摜t@C
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include <math.h>
#include "../../myGlsl.h"
#include "../../bmpLoadSave.h"
#define NUM_GEN_MAX  MAX_IMG_HEIGHT * MAX_IMG_WIDTH / 16
#define M_PI 3.14159265358979323846

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void drawPlate();
void levelTrans();
void setTexture();
void setTextureVoronoi();
void makeVoronoi(short* posX, short* posY, float* red, float* green, float* blue, float *prob);
void makeRandomVoronoi(short* posX, short* posY, float* red, float* green, float* blue);
double random(double minV, double maxV);
void gaussian();
void sobel(float* dx, float* dy);
void canny();
void makeProbability(float *prob);
void setFramebuffer();
void setTextureFBO();

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte image2[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageGray[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte imageCanny[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte distMap[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];//ϊ}bv
GLubyte imageVoronoi[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageRandom[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
//EChẼTCY
int width  = 800;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int qy0;//
int size = 70;//~̃TCY
int interval = 4;//ŏ_Ԋu
int numGen;//_
float alpha = 0.2;//摜
float delta = 0.15;//_F
int nLevel = 8;//K
float gamma = 1.0;//Px̃K}l
int filterSize = 3;//ŕpltB^TCY

//Canny filter
double thUpp = 50.0;
double thLow = 30.0;
//emboss filter
int dir = 0;//G{X
float coef = 0.2;//G{XW

int posGeneration[MAX_IMG_HEIGHT * MAX_IMG_WIDTH / 16][2];
float colGeneration[MAX_IMG_HEIGHT * MAX_IMG_WIDTH / 16][3];
//VF[_vO
GLuint program1;
GLuint program2;
//texture object
GLuint texName[4];
//framebuffer object
GLuint fbName;
//wvL[tO
bool flagHelp = false;
//Ԍv
LARGE_INTEGER freq, time1, time2;
DWORD pTime;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGB | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_OilVoronoi");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
	glewInit();//glew.hɎĂ
  init();
	initGlsl(&program1, "oil.vert", "oil.frag");
	initGlsl(&program2, "emboss.vert", "emboss.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteTextures(4, texName);
	glDeleteFramebuffersEXT(1, &fbName);
	glDeleteProgram(program1);
	glDeleteProgram(program2);
  return 0;
}

void init(void)
{
	glEnable(GL_DEPTH_TEST);	
	//wiF
  glClearColor(0.2, 0.2, 0.2, 1.0);
	//J[摜̎擾
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	loadGrayData(imageGray, &imgWidth, &imgHeight, FILENAME_IN);//Cannyp
	glGenTextures(4, texName);//eNX`IuWFNg̖Ot
	setTexture();
	setTextureFBO();
	setFramebuffer();
}

void setTexture()
{
  glBindTexture(GL_TEXTURE_2D, texName[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image2);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setTextureVoronoi()
{
  glBindTexture(GL_TEXTURE_2D, texName[1]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,imageVoronoi);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setTextureRandom()
{
  glBindTexture(GL_TEXTURE_2D, texName[2]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,imageRandom);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setFramebuffer(void)
{
	glGenFramebuffersEXT( 1, &fbName );
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbName );
  //textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT,
	                                           GL_TEXTURE_2D, texName[3], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void setTextureFBO()
{
  glBindTexture(GL_TEXTURE_2D, texName[3]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,0);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void display(void)
{
  //Ԍv
  LARGE_INTEGER freq, time1, time2;
	DWORD pTime;
	memset(&freq,  0x00, sizeof freq);
	memset(&time1, 0x00, sizeof time1);
	memset(&time2, 0x00, sizeof time2);
	pTime = 0;

	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &time1);

	//_̈ʒuƐF̃m
	short *posX, *posY;
	float *red, *green, *blue;
	posX = (short*)malloc(NUM_GEN_MAX * sizeof(short));
	posY = (short*)malloc(NUM_GEN_MAX * sizeof(short));
	red = (float*)malloc(NUM_GEN_MAX * sizeof(float));
	green = (float*)malloc(NUM_GEN_MAX * sizeof(float));
	blue = (float*)malloc(NUM_GEN_MAX * sizeof(float));
	if(posX == NULL || posY == NULL || red == NULL || green == NULL || blue == NULL)
	{
		printf("_̃mۂł܂ \n");
		return;
	}

	float *probMap;
	probMap = (float*)malloc(imgWidth * imgHeight * sizeof(float));//m}bv
	if(probMap == NULL) {
		printf("probMap̃mۂł܂ \n");
		return;
	}
  srand(0);//nŒ肵Ƃ
	//step1:PxCKጸ
	levelTrans();
	setTexture();

	//step2:CannyGbW𗘗pm}bv쐬
	canny();
	makeProbability(probMap);
	//step3:VoronoiMapeNX`摜쐬
	makeVoronoi(posX, posY, red, green, blue, probMap);
	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	resize(width, height);
	qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;

	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	glColor3f(0.95, 0.9, 0.8);//䎆̐F
	drawPlate();
	for(int k = 0; k < numGen; k++)
	{
		glColor3f(red[k], green[k], blue[k]);
		glPushMatrix();
		glTranslatef(posX[k], posY[k], 0);
		glutSolidCone(size, size, 24, 2);
		glPopMatrix();
	}
	glPopMatrix();
	//t[obt@Ƀ_ÔeNX`摜Ƃ
 	glPixelStorei(GL_PACK_ALIGNMENT, 1);
	glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, imageVoronoi);
	setTextureVoronoi();

	//step4:J[Voronoi摜
	makeRandomVoronoi(posX, posY, red, green, blue);
	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	for(int k = 0; k < numGen; k++)
	{
		glColor3f(red[k], green[k], blue[k]);
		glPushMatrix();
		glTranslatef(posX[k], posY[k], 0);
		glutSolidCone(size, size, 24, 2);
		glPopMatrix();
	}
	glPopMatrix();
	//t[obt@Ƀ_ÔeNX`摜Ƃ
 	glPixelStorei(GL_PACK_ALIGNMENT, 1);
	glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, imageRandom);
	setTextureRandom();

	//step5:VF[_ŃeNX`摜\
	//framebuffer objectL
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbName );

  glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);
  glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, texName[1]);
  glActiveTexture(GL_TEXTURE2);
  glBindTexture(GL_TEXTURE_2D, texName[2]);
	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	int width0 = width;//Window̃TCYۑ
	int height0 = height;
	resize(imgWidth, imgHeight);
	width = width0;//WindowTCYɖ߂
	height = height0;

  // VF[_vO̓Kp 
	glUseProgram(program1);
	GLint image0Loc = glGetUniformLocation(program1, "image");
	glUniform1i(image0Loc, 0);//GL_TEXTURE0Kp
	GLint image1Loc = glGetUniformLocation(program1, "imageVoronoi");
	glUniform1i(image1Loc, 1);//GL_TEXTURE1Kp

	GLint image2Loc = glGetUniformLocation(program1, "imageRandom");
	glUniform1i(image2Loc, 2);//GL_TEXTURE2Kp
	GLint imgWidthLoc = glGetUniformLocation(program1, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program1, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint sizeLoc = glGetUniformLocation(program1, "size");
	glUniform1i(sizeLoc, filterSize);
	GLint alphaLoc = glGetUniformLocation(program1, "alpha");
	glUniform1f(alphaLoc, alpha);
	GLint deltaLoc = glGetUniformLocation(program1, "delta");
	glUniform1f(deltaLoc, delta);
	GLint nLevelLoc = glGetUniformLocation(program1, "nLevel");
	glUniform1i(nLevelLoc, nLevel);
	drawPlate();
	// VF[_vỎ 
  glUseProgram(0);
  glBindTexture(GL_TEXTURE_2D, 0);
  //framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );

	//step6:emboss filter
	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	resize(width, height);
	glActiveTexture(GL_TEXTURE3);
  glBindTexture(GL_TEXTURE_2D, texName[3]);

  // VF[_vO̓Kp 
  glUseProgram(program2);
  GLint imageLoc = glGetUniformLocation(program2, "image");
  glUniform1i(imageLoc, 3);//GL_TEXTURE3Kp
	imgWidthLoc = glGetUniformLocation(program2, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	imgHeightLoc = glGetUniformLocation(program2, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint dirLoc = glGetUniformLocation(program2, "dir");
	glUniform1i(dirLoc, dir);
	GLint coefLoc = glGetUniformLocation(program2, "coef");
	glUniform1f(coefLoc, coef);

	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	drawPlate();
	glPopMatrix();
  // VF[_vỎ 
  glUseProgram(0);
  glBindTexture(GL_TEXTURE_2D, 0);

	QueryPerformanceCounter( &time2);
	pTime = (DWORD)((time2.QuadPart - time1.QuadPart) * 1000 / freq.QuadPart);
	printf(" = %d[ms] \n", pTime);
	if(flagHelp)
  {
		printf("[F1]L[Fŏ_Ԋuinterval̕ύX \n");
		printf("[F2]L[F~TCYsize̕ύX \n");
		printf("[F3]L[F摜uhalpha̕ύX \n");
		printf("[F4]L[F_Fuhdelta̕ύX \n");
		printf("[F5]L[FtB^TCYfilterSize̕ύX \n");
		printf("[F6]L[FG{Xdir̕ύX \n");
		printf("[F7]L[FG{XWcoef̕ύX \n");
		printf("[F8]L[FK}lgammȃ \n");
		printf("[F9]L[FKnLevel̑ \n");
		flagHelp = false;
  }
  //I
	free(posX);
	free(posY);
	free(red);
	free(green);
	free(blue);
	free(probMap);
	glFlush();
}

void levelTrans()
{//ZxxϊƊK팸
	int i, j, k, m, n;
	double zStep = 255.0 / float(nLevel-1);

	for(m = 0; m < 3; m++)
	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			k = i + j * imgWidth;
			//Px
			image2[k][m] = (GLubyte)(pow((double)image[k][m]/255.0, (double)gamma) * 255.0);
			//Kጸ
			n = floor((double)image2[k][m] / zStep + 0.5);
			image2[k][m] = (GLubyte)(zStep * n);
		}
	}
}

void makeVoronoi(short* posX, short* posY, float* red, float* green, float* blue, float *probMap)
{
	int i, j, ii, jj, k;
	//int xx, yy, d;
	int space;//_ԊuiБj
	//_߂ꂽȂC̑O㍶Espace̊Ԃɂ͕_ݒ肵Ȃ

	numGen = 0;
	for(j = 0; j < imgHeight; j++)
		for(i = 0; i < imgWidth; i++)
		{
			if(random(0.0, 1.0) < probMap[i + j * imgWidth])
			{
			k = i + j * imgWidth;
				posX[numGen] = i;
				posY[numGen] = j;
				space = distMap[k] / 2 ;
				if(space < interval) space = interval ;
				for(jj = j - space; jj < j + space; jj++)
					for(ii = i - space; ii < i + space; ii++)
					{
						if(ii >= 0 && ii < imgWidth && jj > 0 && jj < imgHeight) 
							probMap[ii+jj*imgWidth] = 0.0;
					}
				red[numGen]   = (float)image2[k][0] / 255.0;
				green[numGen] = (float)image2[k][1] / 255.0;
				blue[numGen]  = (float)image2[k][2] / 255.0;
				numGen ++;
			}
		}
printf("numGen = %d \n", numGen);
}

double random(double minV, double maxV)
{//minV`maxV̈l
	return( (maxV - minV) * (double)rand() / (double)RAND_MAX ) + minV;
}

void makeRandomVoronoi(short* posX, short* posY, float* red, float* green, float* blue)
{
	int k;

	for(k = 0; k < numGen; k++)
	{
	  red[k]   = random(0.0, 1.0);
	  green[k] = random(0.0, 1.0);
	  blue[k]  = random(0.0, 1.0);
	}
}

void drawPlate()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth, 0);
		glVertex2i(imgWidth, imgHeight);
		glVertex2i(0, imgHeight);
	glEnd();
}

void gaussian()
{
	//Gaussian filter  parameter
	int sizeFilter = 5;
	float sigma = 5.0;
	float weight[25];

	int i, j, k, ii, jj;

	for(jj = 0; jj < sizeFilter; jj++)		
	{
		j = -(sizeFilter-1)/2 + jj;
		for(ii = 0; ii < sizeFilter; ii++)
		{ 
			i = -(sizeFilter-1)/2 + ii;
			weight[ii + jj * sizeFilter] = exp(-double(i*i + j*j) / (2.0 * sigma * sigma));
		}
	}
	float sum = 0.0;
	for(k = 0; k < sizeFilter * sizeFilter; k++) sum += weight[k];
	for(k = 0; k < sizeFilter * sizeFilter; k++) weight[k] /= sum;//2.0 * 3.141592 * sigma * sigma;//sum;//d
//for(k = 0; k < sizeFilter * sizeFilter; k++) printf("k=%d weight=%f \n", k, weight[k]);

	//R{[V
	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			if(j < (sizeFilter-1)/2 || j >= imgHeight - (sizeFilter-1)/2 || i < (sizeFilter-1)/2 || i >= imgWidth - (sizeFilter-1)/2)
			{ imageCanny[i + j * imgWidth] = imageGray[i + j * imgWidth]; }
			else
			{
				sum = 0.0;
				for(jj = -(sizeFilter-1)/2; jj <= (sizeFilter-1)/2; jj++)
				{
					for(ii = -(sizeFilter-1)/2; ii <= (sizeFilter-1)/2; ii++)
					{
						k = (sizeFilter-1)/2+ii + ((sizeFilter-1)/2+jj) * sizeFilter;
						sum += (float)imageGray[i+ii + (j+jj) * imgWidth] * weight[k];
					}
				}
				imageCanny[i + j * imgWidth] = (GLubyte)sum;
			}
		}
	}
}

void sobel(float* dx, float* dy)
{
	int i, j, k, ii, jj;
	float sobelX[9] = {-1.0, 0.0, 1.0, -2.0, 0.0, 2.0, -1.0, 0.0, 1.0};
	float sobelY[9] = {-1.0,-2.0,-1.0,  0.0, 0.0, 0.0,  1.0, 2.0, 1.0};

	//R{[V
	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			dx[i + j * imgWidth] = 0.0;
			dy[i + j * imgWidth] = 0.0;
			for(jj = -1; jj <= 1; jj++)
			{
				for(ii = -1; ii <= 1; ii++)
				{
					k = 1+ii + (1+jj) * 3;
					dx[i + j * imgWidth] += (float)imageCanny[i+ii + (j+jj) * imgWidth] * sobelX[k];
					dy[i + j * imgWidth] += (float)imageCanny[i+ii + (j+jj) * imgWidth] * sobelY[k];
				}
			}
		}
	}
}

void canny()
{
	int i, j, k, kk[4];
	double th;
	double mag, fwd, bck;//l̑傫
	double dxx, dyy;
	int offsetX, offsetY;
	double c = 0.5 / sin(M_PI/8.0);
	GLubyte result;//o͒l

	float *dx, *dy;
	dx = (float*)malloc(imgWidth * imgHeight * sizeof(float));//m}bv
	dy = (float*)malloc(imgWidth * imgHeight * sizeof(float));//m}bv
	if(dx == NULL || dy == NULL) {
		printf("dx, dy ̃mۂł܂ \n");
		return;
	}

	gaussian();
	sobel(dx, dy);

	//o͉摜imageCanny[]GbWƂăNAiGbW͍,	fl0j
	for(j = 0; j < imgHeight; j++)
		for(i = 0; i < imgWidth; i++) imageCanny[i + j * imgWidth] = 255;

	for(j = 1; j < imgHeight-1; j++)
	{
		th = thUpp;
		for(i = 1; i < imgWidth - 1; i++)
		{

			//܂ł̏ōŋߖT1łedgeł΂l
			//BMPt@Cj=0͍ŉsɒ
			kk[0] = i-1 + (j-1)*imgWidth;//
			kk[1] = i + (j-1)*imgWidth;//^
			kk[2] = i+1 +(j-1)*imgWidth;//E
			kk[3] = i-1 + j * imgWidth;//
			if(imageCanny[kk[0]] == 0 || imageCanny[kk[1]] == 0 ||
				 imageCanny[kk[2]] == 0 || imageCanny[kk[3]] == 0) th = thLow;

			//ړ_̌z̑傫
			k = i + j * imgWidth;
			dxx = (double)dx[k];
			dyy = (double)dy[k];
			mag = sqrt(dxx*dxx + dyy*dyy);//z̑傫

			if(mag < th) {result = 255; th = thUpp; }//non edge
			else 
			{
				//z
				offsetX = (int)floor( (dxx/mag) * c + 0.5) ;
				offsetY = (int)floor( (dyy/mag) * c + 0.5) ;
//printf("mag=%f,dx=%f,dy=%f,offsetX=%d,offsetY=%d \n",mag,dxx,dyy,offsetX,offsetY);
				k = i + offsetX + (j + offsetY) * imgWidth;//O
				dxx = (double)dx[k];
				dyy = (double)dy[k];
				fwd = sqrt(dxx*dxx + dyy*dyy);//Ǒz̑傫
				k = i - offsetX + (j - offsetY) * imgWidth;//
				dxx = (double)dx[k];
				dyy = (double)dy[k];
				bck = sqrt(dxx*dxx + dyy*dyy);//̌z̑傫
				if(mag > fwd && mag > bck) {result = 0;}//edge
				else {result = 255; th = thUpp;}//non edge
			}
			imageCanny[i + j*imgWidth] = (GLubyte)result;
		}
	}
	free(dx);
	free(dy);
}

void makeProbability(float *probMap)
{
	//GbW܂ł̋ϊŋ߁C_zum
	int i, j, k, k1, k2;
	int *s, *d;
	s = (int*)malloc(imgWidth * imgHeight * sizeof(int));
	d = (int*)malloc(imgWidth * imgHeight * sizeof(int));
	if(s == NULL || d == NULL){
		printf("s ܂g̃sĂ܂ \n");
	}

	for(j = 0; j < imgHeight; j++)
		for(i = 0; i < imgWidth; i++){
			s[i + j*imgWidth] = 255; 
			d[i + j*imgWidth] = 255;
		}

	//X^
	for(j = 1; j < imgHeight; j++)
		for(i = 1; i < imgWidth; i++){
			k = i + j * imgWidth; k1 = k - 1; k2 = i + (j-1) * imgWidth;
			s[k] = min(min(imageCanny[k], s[k1]+1), s[k2]+1);
		}

	//tX^
	for(j = imgHeight-2; j >= 0; j--)
		for(i = imgWidth-2; i >= 0; i--){
			k = i + j * imgWidth; k1 = k + 1; k2 = i + (j+1) * imgWidth;
			d[k] = min(min(s[k], d[k1]+1), d[k2]+1);
		}
	
	for(j = 1; j < imgHeight; j++)
		for(i = 1; i < imgWidth; i++)
		{
			k = i + j * imgWidth;
			distMap[k] = (GLubyte)d[k];
			if(d[k] <= 2) probMap[k] = 0.0;
			else probMap[k] = 9.0 / (float)(d[k] * d[k]);
//if(j > 50 && j < 60)
//printf("distMap=%d probMap=%f \n", distMap[k], probMap[k]);
		}

	free(d);
	free(s);
}
/*
void makeProbability(float *probMap)
{
	int i, j;
	int *s, *g;
	s = (int*)malloc(imgWidth * imgHeight * sizeof(int));
	g = (int*)malloc(imgWidth * imgHeight * sizeof(int));
	if(s == NULL || g == NULL){
		printf("s ܂g̃sĂ܂ \n");
		return;
	}

	for(j = 0; j < imgHeight; j++)
		for(i = 0; i < imgWidth; i++){
//			f[ij] = imageCanny[i + j * imgWidth];
			s[i + j*imgWidth] = 255; g[i + j*imgWidth] = 255;//distMap[i + j*imgWidth] = 0;
//			if(j==100) printf("i=%d, f[i][j] = %d \n", i, f[i][j]);
		}

	//X^
	for(j = 1; j < imgHeight; j++)
		for(i = 1; i < imgWidth; i++){
//			s[i][j] = min(min(f[i][j], s[i-1][j]+1), s[i][j-1]+1);
			s[i + j*imgWidth] = min(min(imageCanny[i + j * imgWidth], s[i-1 + j*imgWidth]+1), s[i + (j-1)*imgWidth]+1);
//			if(j==100) printf("i=%d, s[i][j] = %d \n", i, s[i][j]);
		}

	//tX^
	for(j = imgHeight-2; j >= 0; j--)
		for(i = imgWidth-2; i >= 0; i--){
			g[i + j*imgWidth] = min(min(s[i + j*imgWidth], g[i+1 + j * imgWidth]+1), g[i + (j+1)*imgWidth]+1);
//			if(j==100) printf("i=%d, g[i][j] = %d \n", i, g[i + j*imgWidth]);
			distMap[i + j*imgWidth] = (GLubyte)min(g[i + j*imgWidth], 255);
		}
	
	for(j = 1; j < imgHeight; j++)
		for(i = 1; i < imgWidth; i++)
		{
			if(distMap[i + j * imgWidth] <= 2) probMap[i + j * imgWidth] = 0.0;
			else probMap[i + j * imgWidth] = 4.0 / (float)(distMap[i + j * imgWidth] * distMap[i + j * imgWidth]);
		}

	free(g);
	free(s);
}
*/

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒ
	glOrtho(0.0, w, 0.0, h, -100, 100);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, image);
		saveBitmap24(imgWidth, imgHeight, image, FILENAME_OUT); 
		loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}


void special(int key, int x, int y)
{
	
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) interval += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	interval -= 1;  
		if(interval < 2) interval = 2;
		printf("interval = %d \n", interval);
	}
	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) size += 1;//~
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	size -= 1;  
		printf("size = %d \n", size);
	}
	if(key == GLUT_KEY_F3) 
	{
	  if(glutGetModifiers() == 0) alpha += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	alpha -= 0.05; 
		if(alpha < 0.0) alpha = 0.0;
		if(alpha > 1.0) alpha = 1.0;
		printf("摜uhalpha = %f \n", alpha); 
	}
	if(key == GLUT_KEY_F4) 
	{
	  if(glutGetModifiers() == 0) delta += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	delta -= 0.05; 
		if(delta < 0.0) delta = 0.0;
		if(delta > 1.0) delta = 1.0;
		printf("_Fuhdelta = %f \n", delta); 
	}

	if(key == GLUT_KEY_F5) 
	{
	  if(glutGetModifiers() == 0) filterSize += 2;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	filterSize -= 2;  
		if(filterSize < 1) filterSize = 1;
		if(filterSize > 13) filterSize = 13;
		printf("tB^TCYfilterSize = %d \n", filterSize);
	}	

	if(key == GLUT_KEY_F6) 
	{
		dir += 45;
		if(dir >= 360) dir = 0;
		printf("G{Xdir = %d@\n", dir);
	}
	if(key == GLUT_KEY_F7) 
	{
	  if(glutGetModifiers() == 0) coef += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	coef -= 0.1;  
		if(coef < 0.0) coef = 0.0;
		printf("G{XWcoef = %f \n", coef); 
	}

	if(key == GLUT_KEY_F8) 
	{
	  if(glutGetModifiers() == 0) gamma += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	gamma -= 0.05;  
		if(gamma < 0.1) gamma = 0.1;
		printf("K}lgamma = %f \n", gamma);
	}	

	if(key == GLUT_KEY_F9) 
	{
	  if(glutGetModifiers() == 0) nLevel += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	nLevel -= 1;  
		if(nLevel < 2) nLevel = 2;
		else if(nLevel == 17) nLevel = 32;
		else if(nLevel == 33) nLevel = 64;
		else if(nLevel == 65) nLevel = 128;
		else if(nLevel == 129) nLevel = 256;
		else if(nLevel >= 256) nLevel = 256;
		else if(nLevel == 255) nLevel = 128;
		else if(nLevel == 127) nLevel = 64;
		else if(nLevel == 63) nLevel = 32;
		else if(nLevel == 31) nLevel = 16;
		printf("KnLevel = %d \n", nLevel);
	}


	display();
}


