
uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform int type;
uniform float eps;
varying vec2 pos;//eNX`W

const float pi = 3.14159265;
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{	
	//S̈ʒu
	vec2 center;
	center.x = float(imgWidth / 2) ;
	center.y = float(imgHeight / 2) ;

	if(type == 0)//xCyƂɊgEk
	{
		pos = (pos - center) * (1.0 - eps) + center;		
	}
	else if(type == 1)//x܂yk
	{
		if(eps >= 0.0)
			pos.y = (pos.y - center.y) * (1.0 + eps) + center.y;		
		else
			pos.x = (pos.x - center.x) * (1.0 - eps) + center.x;		
	}
  else if(type == 2)//yW̒SقǊgEkiہE^j
  {
    float a = sin(3.141592 * pos.y / float(imgHeight));
		if(eps >= 0.0)
			pos.x = (pos.x - center.x) * (1.0 + eps - eps * a) + center.x;
		else
			pos.x = (pos.x - center.x) * (1.0 - eps * a) + center.x;
  }
	else if(type == 3)//㕔܂͉gEk(`j
	{
		if(eps > 0.0)
			pos.x = (pos.x - center.x) / (1.0 - eps * pos.y / float(imgHeight)) + center.x;
		else
			pos.x = (pos.x - center.x) / (1.0 + eps *(1.0 -  pos.y / float(imgHeight))) + center.x;
  }
	else if(type == 4)//]
	{
		vec2 pp = pos - center;
		float theta = eps * pi;
		mat2 m = mat2(cos(theta), sin(theta), -sin(theta), cos(theta));
		pos = m * pp + center;
  }
	else if(type == 5)//Q^
	{
		vec2 pp = pos - center;
		float dis = length(pp);//distance(pos, center);
		float theta = eps * (1.0 - dis / float(imgHeight/2)) * pi;
		mat2 m = mat2(cos(theta), sin(theta), -sin(theta), cos(theta));
		pos = m * pp +center;
  }
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 col = texture2D(image, texCoord).rgb;

	gl_FragColor = vec4(col, 1.0);		
}
