
varying vec2 pos;
uniform int imgWidth, imgHeight;
uniform int type;
uniform float eps;
uniform float freq;
const float pi = 3.14159265;

void main(void)
{
  pos = gl_Vertex.xy + vec2(float(imgWidth) / 2.0, float(imgHeight) / 2.0);

  //geometryό`
	if(type == 0)//xCyƂɊgEk
	{
		gl_Vertex.xy = gl_Vertex.xy / (1.0 - eps);		
	}
	else if(type == 1)//x܂yk
	{
		if(eps >= 0.0)
			gl_Vertex.y = gl_Vertex.y / (1.0 + eps);		
		else
			gl_Vertex.x = gl_Vertex.x / (1.0 - eps);		
	}
  else if(type == 2)//yW̒SقǊgEkiہE^j
  {
    float a = sin(pi * (gl_Vertex.y / float(imgHeight) + 0.5));
		if(eps >= 0.0)
			gl_Vertex.x = gl_Vertex.x / (1.0 + eps - eps * a);
		else
			gl_Vertex.x = gl_Vertex.x / (1.0 - eps * a);
  }
	else if(type == 3)//㕔܂͉gEk(`j
	{
		if(eps > 0.0)
			gl_Vertex.x = gl_Vertex.x * (1.0 - eps * (gl_Vertex.y / float(imgHeight) + 0.5));
		else
			gl_Vertex.x = gl_Vertex.x * (1.0 + eps *(0.5 -  gl_Vertex.y / float(imgHeight)));
  }
	else if(type == 4)//]
	{
		float theta = eps * pi;
		mat2 m = mat2(cos(theta), -sin(theta), sin(theta), cos(theta));
		gl_Vertex.xy = m * gl_Vertex.xy;
  }
	else if(type == 5)//ribbon
	{
	  gl_Vertex.x -= eps * float(imgWidth)* sin(2.0 * pi * freq * gl_Vertex.y/float(imgHeight));
		gl_Vertex.x = gl_Vertex.x / (1.0 + 2.0*abs(eps));//̑傫𒴂Ȃ悤ɏk		
  }
  gl_Position = ftransform();
}
