varying vec2 texCoord;
uniform int type;
uniform float eps;
uniform float freq;
const float pi = 3.14159265;
float phi0 = pi * 0.8;
float theta0 = pi * 0.8;
const float r0 = 0.5;

void main(void)
{
	//ʓe
	float r = sqrt(r0 * r0 - gl_Vertex.z * gl_Vertex.z);
	float phi = acos(gl_Vertex.x / r);
	float as = 1.0 / (1.0 - 2.0 * phi0 / pi);
	texCoord.s = as * (phi - phi0) / pi;
	float theta = acos(gl_Vertex.z / r0);
	float at = 1.0 / (1.0 - 2.0 * theta0 / pi);
	texCoord.t = at * (theta - theta0) / pi;

	vec2 pos = gl_Vertex.xz;
  //geometryό`
	if(type == 0)//㕔܂͉gEk(`EOp`j
	{
		if(eps > 0.0)
			gl_Vertex.x = pos.s * (1.0 - eps * (pos.t + 0.5));
		else
			gl_Vertex.x = pos.s * (1.0 + eps *(0.5 -  pos.t));
  }  
	else if(type == 1)//ribbon
	{
	  pos.x -= eps * sin(2.0 * pi * freq * pos.t);
	  //̑傫𒴂Ȃ悤ɏk
		gl_Vertex.x = pos.x / (1.0 + 2.0*abs(eps));		
  }

  gl_Position = ftransform();
}
