
uniform sampler2D imageRandom;
uniform int imgWidth, imgHeight;
uniform float eta;
varying vec2 pos;//eNX`W
varying vec3 P;
varying vec3 N;
varying vec2 texCoord;
 //eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
  texCoord = gl_Vertex.xy + vec2(0.5, 0.5);
  //}bv
	float hh = texture2D(imageRandom, texCoord).r;
  //s,tWɂ鍂}bv̔	
	float deltaS = texture2D(imageRandom, texCoord + vec2(dx, 0.0)).r - texture2D(imageRandom, texCoord - vec2(dx, 0.0)).r;
	float deltaT = texture2D(imageRandom, texCoord + vec2(0.0, dy)).r - texture2D(imageRandom, texCoord - vec2(0.0, dy)).r;
	//s,tW̒PʃxNg
	vec3 As = vec3(1.0, 0.0, 0.0);//x
	vec3 At = vec3(0.0, 1.0, 0.0);//y

	gl_Vertex.z += hh * eta;
  P = vec3(gl_ModelViewMatrix * gl_Vertex);
  N = normalize(gl_NormalMatrix * gl_Normal).xyz;
  N -= As * deltaS + At * deltaT;

  gl_Position = ftransform();
}
