/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg


3UCN
KI_zu
OpenGL + GLSL

*/
//摜t@C
//#define FILENAME_IN "../../bmp256/matumae256-1.bmp"
//#define FILENAME_IN "../../bmp256/Lenna.bmp"
#define FILENAME_IN "../../bmp256/dog3-2.bmp"

//o͉摜t@C
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include <math.h>
#include "../../myGlsl.h"
#include "../../myPrimitive3.h"
#include "../../bmpLoadSave.h"
#define NUM_GEN_MAX  MAX_IMG_HEIGHT * MAX_IMG_WIDTH / 16

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void draw();
void drawPlate();
void levelTrans();
void setTexture();
void setTextureVoronoi();
void makeVoronoi(short* posX, short* posY, float* red, float* green, float* blue, float *prob);
void makeRandomVoronoi(short* posX, short* posY, float* red, float* green, float* blue);
double random(double minV, double maxV);
void gaussian();
void sobel(float* dx, float* dy);
void canny();
void makeProbability(float *prob);
void setLight();
void idle();
void viewPos();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void resizePlate(int w, int h);
void makeImageVoronoiAndRandom();

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte image2[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageGray[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte imageCanny[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte distMap[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];//ϊ}bv
GLubyte imageVoronoi[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageRandom[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
//affineϊpϐ
struct Object
{
	float pos[3], angle[3], scale[3];
};
//l
Object obj = {
	0.0, 0.0, 0.0,//pos
  0.0, 0.0, 0.0,//angle
  1.0, 1.0, 1.0 //scale
};
Object obj0 = obj;//lۑ

//
float lightPos[]  = {15.0, 20.0, 30.0, 1.0};//ʒu
float lightPos0[] = {15.0, 20.0, 30.0, 1.0};//ʒu(l)

//JƎ̐
struct View
{
  //J
	float pos[3];//ʒui_j
	float cnt[3];//_
  float dist;  //_王_܂ł̋
  float theta; //piʂƂ̕Ίpj
  float phi;   //ʊp
  //̐
  float fovY;  //p
  float nearZ; //ONbv(ߕ)
  float farZ;  //Nbv()
};
//l
View view = { 
	0.0, 0.0, 0.0,//pos
  0.0, 0.0, 0.0,//cnt 
	3.0, 0.0, 0.0,//dist, theta, phi
	30.0, 0.1, 100.0//fovY,nearZ, farZ
};
View view0 = view;//lۑ
//Window̃TCYi摜TCY傫邱)
int width = 512;
int height = 512;
//AtBϊ
enum SELECT_KEY {ROTATE, SCALE, TRANSLATE, LIGHT};
SELECT_KEY sKey = ROTATE;
//}EX
int xStart, yStart;
bool flagMouse = false;
//wvL[tO
bool flagHelp = false;
//ʒuύXtO
bool flagLight = false;

int size = 70;//~̃TCY
int interval = 8;//ŏ_Ԋu
int numGen;//_
float alpha = 0.5;//摜W
int nLevel = 8;//K
float gamma = 1.0;//Px̃K}l
float eta = 0.05;//і@ϓ
double thUpp = 20;//50.0;
double thLow = 10;//30.0;
//VF[_vO
GLuint program;
//texture object
GLuint texName[3];
//Ԍv
LARGE_INTEGER freq, time1, time2;
DWORD pTime;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_Adaptive3D");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
	initGlsl(&program, "adaptive3D.vert", "adaptive3D.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteTextures(3, texName);
	glDeleteProgram(program);
  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{	
  glClearColor(0.2, 0.2, 0.2, 1.0);//wiF
  setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
  printf("}EX/L[̐ɂ'H'L[vbV \n");
	//J[摜̎擾
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	loadGrayData(imageGray, &imgWidth, &imgHeight, FILENAME_IN);//Cannyp
	glGenTextures(3, texName);//eNX`IuWFNg̖Ot
	setTexture();
  viewPos();//_߂
	makeImageVoronoiAndRandom();
}

void setTexture()
{
  glBindTexture(GL_TEXTURE_2D, texName[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image2);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setTextureVoronoi()
{
  glBindTexture(GL_TEXTURE_2D, texName[1]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,imageVoronoi);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setTextureRandom()
{
  glBindTexture(GL_TEXTURE_2D, texName[2]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,imageRandom);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void makeImageVoronoiAndRandom()
{
	//_̈ʒuƐF̃m
	short *posX, *posY;
	float *red, *green, *blue;
	posX = (short*)malloc(NUM_GEN_MAX * sizeof(short));
	posY = (short*)malloc(NUM_GEN_MAX * sizeof(short));
	red = (float*)malloc(NUM_GEN_MAX * sizeof(float));
	green = (float*)malloc(NUM_GEN_MAX * sizeof(float));
	blue = (float*)malloc(NUM_GEN_MAX * sizeof(float));
	if(posX == NULL || posY == NULL || red == NULL || green == NULL || blue == NULL)
	{
		printf("_̃mۂł܂ \n");
		return;
	}

	float *probMap;
	probMap = (float*)malloc(imgWidth * imgHeight * sizeof(float));//m}bv
	if(probMap == NULL) {
		printf("probMap̃mۂł܂ \n");
		return;
	}

	//step1:PxCKጸ
	levelTrans();
	setTexture();
	//step2:CannyGbW𗘗pm}bv쐬
	canny();
	makeProbability(probMap);

  glDisable(GL_LIGHTING);
	//step3:VoronoiMapeNX`摜쐬
	makeVoronoi(posX, posY, red, green, blue, probMap);

	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	resizePlate(width, height);	
	glColor3f(0.95, 0.9, 0.85);//䎆̐F
	drawPlate();
	for(int k = 0; k < numGen; k++)
	{
		glColor3f(red[k], green[k], blue[k]);
		glPushMatrix();
		glTranslatef(posX[k], posY[k], 0);
		glutSolidCone(size, size, 24, 2);
		glPopMatrix();
	}
	//̃obt@Ƀ_ÔeNX`摜Ƃ
 	glPixelStorei(GL_PACK_ALIGNMENT, 1);
	glReadPixels(0, 0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, imageVoronoi);
	setTextureVoronoi();

	//step4:J[Voronoi摜̍쐬
	makeRandomVoronoi(posX, posY, red, green, blue);
	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	for(int k = 0; k < numGen; k++)
	{
		glColor3f(red[k], green[k], blue[k]);
		glPushMatrix();
		glTranslatef(posX[k], posY[k], 0);
		glutSolidCone(size, size, 24, 2);
		glPopMatrix();
	}
	//t[obt@Ƀ_ÔeNX`摜Ƃ
 	glPixelStorei(GL_PACK_ALIGNMENT, 1);
	glReadPixels(0, 0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, imageRandom);
	setTextureRandom();

	free(posX);
	free(posY);
	free(red);
	free(green);
	free(blue);
	free(probMap);
}
void display(void)
{
  //Ԍv
  LARGE_INTEGER freq, time1, time2;
	DWORD pTime;
	memset(&freq,  0x00, sizeof freq);
	memset(&time1, 0x00, sizeof time1);
	memset(&time2, 0x00, sizeof time2);
	pTime = 0;

	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &time1);

	setLight();

	//step5FVF[_ŃeNX`摜\
	resize(width, height);	
	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();//_ςƂ͂̈ʒuɕKv
  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, 1.0, 0.0);
  else
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, -1.0, 0.0);

  //ݒ//'l'ʒu
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);
  glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);
  glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, texName[1]);
  glActiveTexture(GL_TEXTURE2);
  glBindTexture(GL_TEXTURE_2D, texName[2]);

  // VF[_vO̓Kp 
	glUseProgram(program);
	GLint image0Loc = glGetUniformLocation(program, "image");
	glUniform1i(image0Loc, 0);//GL_TEXTURE0Kp
	GLint image1Loc = glGetUniformLocation(program, "imageVoronoi");
	glUniform1i(image1Loc, 1);//GL_TEXTURE1Kp

	GLint image2Loc = glGetUniformLocation(program, "imageRandom");
	glUniform1i(image2Loc, 2);//GL_TEXTURE2Kp
	GLint imgWidthLoc = glGetUniformLocation(program, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint alphaLoc = glGetUniformLocation(program, "alpha");
	glUniform1f(alphaLoc, alpha);
	GLint etaLoc = glGetUniformLocation(program, "eta");
	glUniform1f(etaLoc, eta);

	draw();

	// VF[_vỎ 
  glUseProgram(0);

	QueryPerformanceCounter( &time2);
	pTime = (DWORD)((time2.QuadPart - time1.QuadPart) * 1000 / freq.QuadPart);
//	printf(" = %d[ms] \n", pTime);
	if(flagHelp)
  {
		printf("L[ɂAtBϊ/ړ \n");
		printf("@,Fx \n");
		printf("@,Fy \n");
		printf("@[Shift]{,Fz \n");
		printf("@'R':] \n");
		printf("@'T':sړ \n");
		printf("@'S':ݸ \n");
		printf("@'L'Aʒüړ \n");
		printf("}EXŎ_ύX \n");
		printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
		printf("  panFщEE{^NbNŒ_Eɕω \n");
		printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
		printf("  tumbleFEɃhbOƎ_Eɕω \n");
		printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
		printf("  zoomFE{^NbNŃY[C \n");
		printf("        EE{^NbNŃY[AEg \n");
		printf("[Shift]+'R'ŃZbg \n");
		printf("[F1]L[Fŏ_Ԋuinterval̕ύX \n");
		printf("[F2]L[F~TCYsize̕ύX \n");
		printf("[F3]L[F摜uhWalpha̕ύX \n");
		printf("[F4]L[FWetȃ \n");
		printf("[F5]L[FK}lgammȃ \n");
		printf("[F6]L[FKnLevel̑ \n");
		flagHelp = false;
  }
  //I
	glutSwapBuffers();
}

void draw(void)
{
  float ambient[] = { 0.3, 0.3, 0.3, 1.0};
  float diffuse[] = { 0.7, 0.7, 0.7, 1.0};
  float specular[]= { 1.0, 1.0, 1.0, 1.0};

  glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
  glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
  glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
  glMaterialf(GL_FRONT,GL_SHININESS,100);

  glPushMatrix();
  glTranslatef(obj.pos[0], obj.pos[1], obj.pos[2]);
  glRotatef(obj.angle[1], 0.0, 1.0, 0.0);//y]
  glRotatef(obj.angle[0], 1.0, 0.0, 0.0);//x]
  glRotatef(obj.angle[2], 0.0, 0.0, 1.0);//z]
  glScalef(obj.scale[0], obj.scale[1], obj.scale[2]);

	drawGridPlate(1.0, (float)imgHeight/(float)imgWidth, 500, 500);
  glPopMatrix();
}

void levelTrans()
{//ZxxϊƊK팸
	int i, j, k, m, n;
	double zStep = 255.0 / float(nLevel-1);

	for(m = 0; m < 3; m++)
	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			k = i + j * imgWidth;
			//Px
			image2[k][m] = (GLubyte)(pow((double)image[k][m]/255.0, (double)gamma) * 255.0);
			//Kጸ
			n = floor((double)image2[k][m] / zStep + 0.5);
			image2[k][m] = (GLubyte)(zStep * n);
		}
	}
}

void makeVoronoi(short* posX, short* posY, float* red, float* green, float* blue, float *probMap)
{
	int i, j, ii, jj, k;
	int space;//_Ԋu(Бj
	//_߂ꂽȂC̑O㍶Espace̊Ԃɂ͕_ݒ肵Ȃ

	numGen = 0;
	for(j = 0; j < imgHeight; j++)
		for(i = 0; i < imgWidth; i++)
		{
			if(random(0.0, 1.0) < probMap[i + j * imgWidth])
			{
				k = i + j * imgWidth;
				posX[numGen] = i;
				posY[numGen] = j;
				space = distMap[k] / 2 ;
				if(space < interval) space = interval;
				for(jj = j - space; jj < j + space; jj++)
					for(ii = i - space; ii < i + space; ii++)
					{
						if(ii >= 0 && ii < imgWidth && jj > 0 && jj < imgHeight) 
							probMap[ii+jj*imgWidth] = 0.0;
					}
				red[numGen]   = (float)image2[k][0] / 255.0;
				green[numGen] = (float)image2[k][1] / 255.0;
				blue[numGen]  = (float)image2[k][2] / 255.0;
				numGen ++;
			}
		}
//printf("numGen = %d \n", numGen);
}

double random(double minV, double maxV)
{//minV`maxV̈l
	return( (maxV - minV) * (double)rand() / (double)RAND_MAX ) + minV;
}

void makeRandomVoronoi(short* posX, short* posY, float* red, float* green, float* blue)
{
	int k;

	for(k = 0; k < numGen; k++)
	{
	  red[k]   = random(0.0, 1.0);
	  green[k] = random(0.0, 1.0);
	  blue[k]  = random(0.0, 1.0);
	}
}

void drawPlate()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth, 0);
		glVertex2i(imgWidth, imgHeight);
		glVertex2i(0, imgHeight);
	glEnd();
}

void gaussian()
{
	//Gaussian filter  parameter
	int sizeFilter = 5;
	float sigma = 5.0;
	float weight[25];

	int i, j, k, ii, jj;

	for(jj = 0; jj < sizeFilter; jj++)		
	{
		j = -(sizeFilter-1)/2 + jj;
		for(ii = 0; ii < sizeFilter; ii++)
		{ 
			i = -(sizeFilter-1)/2 + ii;
			weight[ii + jj * sizeFilter] = exp(-double(i*i + j*j) / (2.0 * sigma * sigma));
		}
	}
	float sum = 0.0;
	for(k = 0; k < sizeFilter * sizeFilter; k++) sum += weight[k];
	for(k = 0; k < sizeFilter * sizeFilter; k++) weight[k] /= sum;//2.0 * 3.141592 * sigma * sigma;//sum;//d
//for(k = 0; k < sizeFilter * sizeFilter; k++) printf("k=%d weight=%f \n", k, weight[k]);

	//R{[V
	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			if(j < (sizeFilter-1)/2 || j >= imgHeight - (sizeFilter-1)/2 || i < (sizeFilter-1)/2 || i >= imgWidth - (sizeFilter-1)/2)
			{ imageCanny[i + j * imgWidth] = imageGray[i + j * imgWidth]; }
			else
			{
				sum = 0.0;
				for(jj = -(sizeFilter-1)/2; jj <= (sizeFilter-1)/2; jj++)
				{
					for(ii = -(sizeFilter-1)/2; ii <= (sizeFilter-1)/2; ii++)
					{
						k = (sizeFilter-1)/2+ii + ((sizeFilter-1)/2+jj) * sizeFilter;
						sum += (float)imageGray[i+ii + (j+jj) * imgWidth] * weight[k];
					}
				}
				imageCanny[i + j * imgWidth] = (GLubyte)sum;
			}
		}
	}
}

void sobel(float* dx, float* dy)
{
	int i, j, k, ii, jj;
	float sobelX[9] = {-1.0, 0.0, 1.0, -2.0, 0.0, 2.0, -1.0, 0.0, 1.0};
	float sobelY[9] = {-1.0,-2.0,-1.0,  0.0, 0.0, 0.0,  1.0, 2.0, 1.0};

	//R{[V
	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			dx[i + j * imgWidth] = 0.0;
			dy[i + j * imgWidth] = 0.0;
			for(jj = -1; jj <= 1; jj++)
			{
				for(ii = -1; ii <= 1; ii++)
				{
					k = 1+ii + (1+jj) * 3;
					dx[i + j * imgWidth] += (float)imageCanny[i+ii + (j+jj) * imgWidth] * sobelX[k];
					dy[i + j * imgWidth] += (float)imageCanny[i+ii + (j+jj) * imgWidth] * sobelY[k];
				}
			}
		}
	}
}

void canny()
{
	int i, j, k, kk[4];
	double th;
	double mag, fwd, bck;//l̑傫
	double dxx, dyy;
	int offsetX, offsetY;
	double c = 0.5 / sin(M_PI/8.0);
	GLubyte result;//o͒l

	float *dx, *dy;
	dx = (float*)malloc(imgWidth * imgHeight * sizeof(float));//m}bv
	dy = (float*)malloc(imgWidth * imgHeight * sizeof(float));//m}bv
	if(dx == NULL || dy == NULL) {
		printf("dx, dy ̃mۂł܂ \n");
		return;
	}

	gaussian();
	sobel(dx, dy);


	//o͉摜imageCanny[]GbWƂăNAiGbW͍,	fl0j
	for(j = 0; j < imgHeight; j++)
		for(i = 0; i < imgWidth; i++) imageCanny[i + j * imgWidth] = 255;

	for(j = 1; j < imgHeight-1; j++)
	{
		th = thUpp;
		for(i = 1; i < imgWidth - 1; i++)
		{

			//܂ł̏ōŋߖT1łedgeł΂l
			//BMPt@Cj=0͍ŉsɒ
			kk[0] = i-1 + (j-1)*imgWidth;//
			kk[1] = i + (j-1)*imgWidth;//^
			kk[2] = i+1 +(j-1)*imgWidth;//E
			kk[3] = i-1 + j * imgWidth;//
			if(imageCanny[kk[0]] == 0 || imageCanny[kk[1]] == 0 ||
				 imageCanny[kk[2]] == 0 || imageCanny[kk[3]] == 0) th = thLow;

			//ړ_̌z̑傫
			k = i + j * imgWidth;
			dxx = (double)dx[k];
			dyy = (double)dy[k];
			mag = sqrt(dxx*dxx + dyy*dyy);//z̑傫

			if(mag < th) {result = 255; th = thUpp; }//non edge
			else 
			{
				//z
				offsetX = (int)floor( (dxx/mag) * c + 0.5) ;
				offsetY = (int)floor( (dyy/mag) * c + 0.5) ;
				k = i + offsetX + (j + offsetY) * imgWidth;//O
				dxx = (double)dx[k];
				dyy = (double)dy[k];
				fwd = sqrt(dxx*dxx + dyy*dyy);//Ǒz̑傫
				k = i - offsetX + (j - offsetY) * imgWidth;//
				dxx = (double)dx[k];
				dyy = (double)dy[k];
				bck = sqrt(dxx*dxx + dyy*dyy);//̌z̑傫
				if(mag > fwd && mag > bck) {result = 0;}//edge
				else {result = 255; th = thUpp;}//non edge
			}
			imageCanny[i + j*imgWidth] = (GLubyte)result;
		}
	}
	free(dx);
	free(dy);
}

void makeProbability(float *probMap)
{
	//GbW܂ł̋ϊŋ߁C_zum
	int i, j, k, k1, k2;
	int *s, *d;
	s = (int*)malloc(imgWidth * imgHeight * sizeof(int));
	d = (int*)malloc(imgWidth * imgHeight * sizeof(int));
	if(s == NULL || d == NULL){
		printf("s ܂g̃sĂ܂ \n");
	}

	for(j = 0; j < imgHeight; j++)
		for(i = 0; i < imgWidth; i++){
			s[i + j*imgWidth] = 255; 
			d[i + j*imgWidth] = 255;
		}

	//X^
	for(j = 1; j < imgHeight; j++)
		for(i = 1; i < imgWidth; i++){
			k = i + j * imgWidth; k1 = k - 1; k2 = i + (j-1) * imgWidth;
			s[k] = min(min(imageCanny[k], s[k1]+1), s[k2]+1);
		}

	//tX^
	for(j = imgHeight-2; j >= 0; j--)
		for(i = imgWidth-2; i >= 0; i--){
			k = i + j * imgWidth; k1 = k + 1; k2 = i + (j+1) * imgWidth;
			d[k] = min(min(s[k], d[k1]+1), d[k2]+1);
		}
	
	for(j = 1; j < imgHeight; j++)
		for(i = 1; i < imgWidth; i++)
		{
			k = i + j * imgWidth;
			distMap[k] = (GLubyte)d[k];
			if(d[k] <= 2) probMap[k] = 0.0;
			else probMap[k] = 9.0 / (float)(d[k] * d[k]);
//if(j > 50 && j < 60)
//printf("distMap=%d probMap=%f \n", distMap[k], probMap[k]);
		}

	free(d);
	free(s);
}

void resizePlate(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒ
	glOrtho(0.0, w, 0.0, h, -size, 50);
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎w
  glMatrixMode(GL_PROJECTION);
  //vWFNVs̏
  glLoadIdentity();
  //es̐ݒieϊj
  gluPerspective(view.fovY, (double)w/(double)h, view.nearZ, view.farZ);
	//fr[s̐錾
  glMatrixMode(GL_MODELVIEW);
  //\EBhẼTCY
  width = w;
  height = h;
}

void setLight()
{
  float lightAmbient0[] = {0.5, 0.5, 0.5, 1.0}; //
  float lightDiffuse0[] = {1.0, 1.0, 1.0, 1.0}; //gU
  float lightSpecular0[] = {1.0, 1.0, 1.0, 1.0};//ʌ
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightAmbient0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightDiffuse0);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightSpecular0);
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'r':
	  sKey = ROTATE;
	  break;
  case 's':
	  sKey = SCALE;
	  break;
  case 't':
	  sKey = TRANSLATE;
	  break;
  case 'R'://resetilɖ߂)
		obj = obj0;
	  view = view0;
	  viewPos();
		for(int i = 0 ; i < 3; i++) lightPos[i] = lightPos0[i];
	  break;
  case 'l':
	  sKey = LIGHT;
	  break;

  case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(0, 0, width, height, GL_RGB, GL_UNSIGNED_BYTE, image);
		saveBitmap24(width, height, image, FILENAME_OUT); 
		loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}


void special(int key, int x, int y)
{
  if(sKey == TRANSLATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  obj.pos[0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://-x
		  obj.pos[0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) obj.pos[1] += 0.1;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.pos[2] -= 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) obj.pos[1] -= 0.1;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.pos[2] += 0.1; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == ROTATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x]
		  obj.angle[0] += 10.0;
		  break;
	  case GLUT_KEY_LEFT://-x]
		  obj.angle[0] -= 10.0;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) obj.angle[1] += 10;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.angle[2] += 10; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) obj.angle[1] -= 10;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.angle[2] -= 10; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == SCALE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://xg
		  obj.scale[0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://xk
		  obj.scale[0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) obj.scale[1] += 0.1;//yg
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.scale[2] += 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) obj.scale[1] -= 0.1;//yk
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.scale[2] -= 0.1; //z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == LIGHT)
  {
		float d = 1.0;
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  lightPos[0] += d;
		  break;
	  case GLUT_KEY_LEFT:
		  lightPos[0] -= d;//-x
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) lightPos[1] += d;//y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] -= d;//z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) lightPos[1] -= d;//-y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] += d;//-z
		  break;
	  default:
		  break;
	  }
  }
	
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) interval += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	interval -= 1;  
		if(interval < 4) interval = 4;;
		printf("interval = %d \n", interval);
		makeImageVoronoiAndRandom();
	}
	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) size += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	size -= 1;  
		printf("size = %d \n", size);
		makeImageVoronoiAndRandom();
	}
	if(key == GLUT_KEY_F3) 
	{
	  if(glutGetModifiers() == 0) alpha += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	alpha -= 0.05; 
		if(alpha < 0.0) alpha = 0.0;
		if(alpha > 1.0) alpha = 1.0;
		printf("alpha = %f \n", alpha); 
	}

	if(key == GLUT_KEY_F4) 
	{
	  if(glutGetModifiers() == 0) eta += 0.01;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	eta -= 0.01; 
		if(eta < 0.0) eta = 0.0;
		printf("ϓ eta = %f \n", eta); 
	}

	if(key == GLUT_KEY_F5) 
	{
	  if(glutGetModifiers() == 0) gamma += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	gamma -= 0.05;  
		if(gamma < 0.1) gamma = 0.1;
		printf("K}lgamma = %f \n", gamma);
		makeImageVoronoiAndRandom();
	}	

	if(key == GLUT_KEY_F6) 
	{
	  if(glutGetModifiers() == 0) nLevel += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	nLevel -= 1;  
		if(nLevel < 2) nLevel = 2;
		else if(nLevel == 17) nLevel = 32;
		else if(nLevel == 33) nLevel = 64;
		else if(nLevel == 65) nLevel = 128;
		else if(nLevel == 129) nLevel = 256;
		else if(nLevel >= 256) nLevel = 256;
		else if(nLevel == 255) nLevel = 128;
		else if(nLevel == 127) nLevel = 64;
		else if(nLevel == 63) nLevel = 32;
		else if(nLevel == 31) nLevel = 16;
		printf("KnLevel = %d \n", nLevel);
		makeImageVoronoiAndRandom();
	}

	display();
}

//ȉ̂R̊֐̓}EXɂ鎋_̕ύXɕKv
void mouse(int button, int state, int x, int y)
{
  double pp = M_PI / 180.0;

  if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
  {
	  xStart = x; yStart = y;
	  flagMouse = true;
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist -= 0.1; //߂Â
	  }
  }
  else if(button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
  {
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist += 0.1; //
	  }
	  else if(( x < width/4 || x > 3*width/4) && (y > height/4 && y < 3*height/4))//pan
	  {
		  if(x < width/4 ) view.phi -= 1.0;
		  else view.phi += 1.0;
		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.phi) * cos(pp * view.theta);
		  view.cnt[0] = view.pos[0] - view.dist * sin(pp * view.phi) * cos(pp * view.theta);
	  }
	  else if((x > width/4 && x < 3*width/4) && (y < height/4 || y > 3*height/4))//tilt
	  {
		  if( y < height/4)
			  view.theta += 1.0; 
		  else
			  view.theta -= 1.0;

		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.theta) * cos(pp * view.phi);
		  view.cnt[0] = view.pos[0] - view.dist * cos(pp * view.theta) * sin(pp * view.phi);
		  view.cnt[1] = view.pos[1] - view.dist * sin(pp * view.theta);
	  }
	  else if(x < width/8 && y > 7*height/8) view.fovY -= 1.0;//zoom in
	  else if(x > 7*width/8 && y > 7*height/8) view.fovY += 1.0;//zoom out
  }
  else flagMouse = false;
  if(state == GLUT_DOWN) viewPos();
}

void motion(int x, int y)
{
  if(!flagMouse) return;
  if(cos(M_PI * view.theta /180.0) >= 0.0)
	view.phi -= 0.5 * (float)(x - xStart) ;//tumble
  else
	view.phi += 0.5 * (float)(x - xStart) ;//tumble

  view.theta += 0.5 * (float)(y - yStart) ;//crane

  viewPos();
  xStart = x;
  yStart = y;
}

void viewPos()
{
  double pp = M_PI / 180.0;
  view.pos[2] = view.cnt[2] + view.dist * cos(pp * view.theta) * cos(pp * view.phi);//z
  view.pos[0] = view.cnt[0] + view.dist * cos(pp * view.theta) * sin(pp * view.phi);//x
  view.pos[1] = view.cnt[1] + view.dist * sin(pp * view.theta);//y
  //printf("view.posX=%f, view.posY=%f, view.posZ=%f \n", view.pos[0], view.pos[1], view.pos[2]);
  //printf("cntX=%f, cntY=%f, cntZ=%f \n", view.cnt[0], view.cnt[1], view.cnt[2]);
  //printf("phi=%f, theta=%f, fovY=%f \n", view.phi, view.theta, view.fovY);
	resize(width, height);
}


