varying vec3 P;
varying vec3 N;
varying vec2 texPos;
varying float posY;
uniform float reductH;//Zk
uniform float reductV;//cZk
uniform float rTop;
const float pi = 3.14159265;
const float phi0 = pi * reductH;
const float rBottom = 0.5;
const float h = 1.0;

void main(void)
{
  P = vec3(gl_ModelViewMatrix * gl_Vertex);
  N = normalize(gl_NormalMatrix * gl_Normal).xyz;

	//~ʓe
	float r = rTop + (rBottom - rTop) * (0.5  - gl_Vertex.z / h);
	float phi = acos(gl_Vertex.x / r);
	float as = 1.0 / (1.0 - 2.0 * phi0 / pi);
	texPos.s = as * (phi - phi0) / pi;
	float len = sqrt(h * h + (rBottom -rTop) * (rBottom - rTop));
	float at = 1.0 / ((1.0 - 2.0 * reductV) * len);
	texPos.t = at * (gl_Vertex.z + 0.5*h - reductV) * len / h;

	//eNX`폜Ɏgp
	posY = gl_Vertex.y;//+ymapping
  gl_Position = ftransform();
}
