varying vec3 P;
varying vec3 N;
varying vec2 texPos;
varying float posY;
uniform float reductH;//Zk
uniform float reductV;//cZk
const float pi = 3.14159265;
float phi0 = pi * reductH;
float theta0 = pi * reductV;
const float r0 = 0.5;

void main(void)
{
  P = vec3(gl_ModelViewMatrix * gl_Vertex);
  N = normalize(gl_NormalMatrix * gl_Normal).xyz;

	//ʓe
	float r = sqrt(r0 * r0 - gl_Vertex.z * gl_Vertex.z);
	float phi = acos(gl_Vertex.x / r);
	float as = 1.0 / (1.0 - 2.0 * phi0 / pi);
	texPos.s = as * (phi - phi0) / pi;
	float theta = acos(gl_Vertex.z / r0);
	float at = 1.0 / (1.0 - 2.0 * theta0 / pi);
	texPos.t = at * (theta - theta0) / pi;
	texPos.t = 1.0 - texPos.t;//㉺]

	//eNX`폜Ɏgp
	posY = gl_Vertex.y;//+ymapping
  gl_Position = ftransform();
}
