uniform sampler2D image;
uniform int imgWidth, imgHeight;
varying vec2 pos;

void main(void)
{
	vec2 texCoord = vec2(pos.x / float(imgWidth), pos.y / float(imgHeight));
	vec4 col = texture2D(image, texCoord);
	gl_FragColor.rgb = vec3(1.0) - col.rgb;
}