uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform int nPixel;//ubNs(jf
uniform int type;
varying vec2 pos;

void main(void)
{
	int I = floor(pos.x / float(nPixel));//ubNԍ
	int J = floor(pos.y / float(nPixel));//cubNԍ
	vec2 texCoord;
  if(type == 0)
  {
		//ϒl
		int i, j;
		vec4 sum = vec4(0.0);
		int cnt = 0;
		for(int j = J*nPixel; j < J*nPixel + nPixel ; j++)
			for(int i = I*nPixel; i < I*nPixel + nPixel; i++)
			{
				texCoord = vec2(float(i) / float(imgWidth), float(j) / float(imgHeight));
				sum += texture2D(image, texCoord);
				cnt ++;
			}
		gl_FragColor.rgb = sum.rgb / (float(cnt));
	}

	else
	{
		//\_
		texCoord = vec2(float(I * nPixel) / float(imgWidth), float(J * nPixel) / float(imgHeight));
		vec4 col = texture2D(image, texCoord);
		gl_FragColor.rgb = col.rgb;
	}
}