uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform int nPixel;//1block̉i܂͏cjf
uniform vec2 posMouse;
uniform float radius;
varying vec2 pos;

void main(void)
{
	int I = floor(pos.x / float(nPixel));//ubNԍỉfԍj
	int J = floor(pos.y / float(nPixel));//cubNԍỉfԍj
	posMouse.y = float(imgHeight) - posMouse.y;
	float dist = distance(pos, posMouse);
	vec2 texCoord;
	vec4 col;
	if(dist < radius)
	{
		//\_
		texCoord = vec2(float(I * nPixel) / float(imgWidth), float(J * nPixel) / float(imgHeight));
		col = vec4(1.0) - texture2D(image, texCoord);
	}
	else
	{
		texCoord = vec2(pos.x / float(imgWidth), pos.y / float(imgWidth));
		col = texture2D(image, texCoord);
	}
	gl_FragColor.rgb = col.rgb;
}