uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform int nLevel;//o͉摜̊K
varying vec2 pos;
const float maxV = 255.0;//fl̍ől

void main(void)
{
	float zStep = maxV / float(nLevel-1);//ZxXebv
	vec2 texCoord = vec2(pos.x / float(imgWidth), pos.y / float(imgHeight));
	vec4 col = texture2D(image, texCoord) * maxV;
	vec3 k = floor(col.rgb / zStep + vec3(0.5));
	col.rgb = zStep * k;
	gl_FragColor.rgb = col.rgb / maxV ;
}
