/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

TCYgk
OpenGL + GLSL
*/

//摜t@C
//#define FILENAME_IN "../../bmp64/Barbara64.bmp"
#define FILENAME_IN "../../bmp64/Lenna64.bmp"
//o͉摜t@C
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../bmpLoadSave.h"

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void drawPlate();
void setTexture();
void special(int key, int x, int y);

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
int newWidth, newHeight;//VTCY
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
//EChẼTCY
int width  = 800;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int qy0;//
//VF[_vO
GLuint program;
//g嗦
float ratio = 1.0;
int type = 0;//NEAREST
float grad = 1.0;//BiLinearŎgpzW
//wvL[tO
bool flagHelp = false;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGB);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_Scaling");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
	initGlsl(&program, "scaling.vert", "scaling.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteProgram(program);
  return 0;
}

void init(void)
{
  //wiF
  glClearColor(0.2, 0.2, 0.2, 1.0);
	//J[摜̎擾
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	//TCYϊ̉摜TCY
	newWidth = int((float)imgWidth * ratio);
	newHeight = int((float)imgHeight * ratio);
	if(newWidth > MAX_IMG_WIDTH || newHeight > MAX_IMG_HEIGHT)
	{
		printf("ϊ̃TCY傫܂ \n");
		exit;
	}
	printf("ratio= %f, imgWidth = %d,  newWidth = %d \n", ratio, imgWidth, newWidth);

	setTexture();
	printf("}EX/L[̐ɂ'H'L[vbV \n");
}


void setTexture()
{
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);//NEAREST);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);//NEAREST);
}

void display(void)
{
	//J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);

	//摜
  // VF[_vO̓Kp 
  glUseProgram(program);
  GLint imageLoc = glGetUniformLocation(program, "image");
  glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint imgWidthLoc = glGetUniformLocation(program, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint ratioLoc = glGetUniformLocation(program, "ratio");
	glUniform1f(ratioLoc, ratio);
	GLint typeLoc = glGetUniformLocation(program, "type");
	glUniform1i(typeLoc, type);
	GLint gradLoc = glGetUniformLocation(program, "g");
	glUniform1f(gradLoc, grad);
	
	qy0 = height - newHeight- py0;
	if(qy0 < 0) qy0 = 0;

	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	drawPlate();
	glPopMatrix();
  // VF[_vỎ 
  glUseProgram(0);

	if(flagHelp)
  {
		printf("[F1]L[Fg/kratio̕ύX(0.1`, 0.05݁j \n");
		printf("[F2]L[Fg/ktype̕ύX \n");
		printf("[F3]L[Fo3Ԃ̂Ƃ̌zWg̕ύX(0.1`, 0.05݁j \n");
		flagHelp = false;
  }
  //I
	glFlush();
}

void drawPlate()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(newWidth, 0);
		glVertex2i(newWidth, newHeight);
		glVertex2i(0, newHeight);
	glEnd();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒ
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(px0, qy0, newWidth, newHeight, GL_RGB, GL_UNSIGNED_BYTE, image);
		saveBitmap24(newWidth, newHeight, image, FILENAME_OUT); 
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) ratio += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	ratio -= 0.05;  
		if(ratio < 0.2) ratio = 0.1;
		newWidth = ratio * imgWidth;
		newHeight = ratio * imgHeight;
		printf("g/k = %f \n", ratio);
	}	
	if(key == GLUT_KEY_F2) 
	{
		type ++;
		if(type == 3) type = 0;
		if(type == 0) printf("ŋߖT \n");
		else if(type == 1) printf("o` \n");
		else printf("o3 \n");
	}	
	if(key == GLUT_KEY_F3) 
	{
	  if(glutGetModifiers() == 0) grad += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	grad -= 0.1;  
		if(grad < 0.5) grad = 0.5;
		printf("zW = %f \n", grad);
	}	
	
	display();
}
