/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

ŋߗוωiGrayScale)
ŒVF[_iOpenGL onlyj

*/
//摜t@C
#define FILENAME_IN "../../bmp256/matumaeNoise1.bmp"
//#define FILENAME_IN "../../bmp256/flower1.bmp"
//#define FILENAME_IN "../../bmp/Px1.bmp"
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <math.h>
#include <windows.h>
#include <GL/glut.h>
#include "../../bmpLoadSave.h"

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void nearest();

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte imageOut[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
//EChẼTCY
int width  = 800;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int size = 5;//only 5
bool flagHelp = false;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGBA);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("GL_NearestGray");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
  //Cxg[vɓ
  glutMainLoop();
  return 0;
}

void init(void)
{
  //wiF
  glClearColor(0.2, 0.2, 0.2, 1.0);
	//mN摜̎擾
	loadGrayData(image, &imgWidth, &imgHeight, FILENAME_IN);
}

void display(void)
{
  //J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);

	nearest();
	//̈ʒu
	int qx0= px0;
	int qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;
	glRasterPos2i(qx0, qy0);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glDrawPixels(imgWidth, imgHeight, GL_LUMINANCE, GL_UNSIGNED_BYTE, imageOut);

//I
  glFlush();
}

void nearest()
{
	int i, j, k, m, n;
	GLubyte gray[25];
	double abso[25];//ړ_Ƃ̍̐Βl
	int kNum = 12;
	double mean;//ϒl
	int Size = size*size;
	int ss = (size - 1) / 2;//SБɃTCY

	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			if(i < ss || i >= imgWidth - ss - 1 || j < ss || j >= imgHeight - ss - 1) 
			{
				imageOut[i + j * imgWidth] = image[i + j * imgWidth];
				continue;
			}

			n = 0;
			for(m = -ss; m <= ss; m++)
			{
				for(k = -ss; k <= ss; k++)
				{
					gray[n] = image[(i + k) + (j + m) * imgWidth];
					n++;
				}
			}
			//ړ_Ƃ̍̐Βl
			for(k = 0; k < Size; k++) 
			{
				abso[k] = abs((double)gray[k] - (double)gray[12]);
			}

			//ёւ
			double ab;
			GLubyte gr;
			for(k = 0; k < kNum; k++)
			{
				ab = abso[k];
				gr = gray[k];
				for(m = k+1; m < Size; m++)
				{
					if(ab > abso[m])
					{
						abso[k] = abso[m];
						abso[m] = ab;
						ab = abso[k];
						gray[k] = gray[m];
						gray[m] = gr;
						gr = gray[k];
					}
				}//m
			}//k

			//ϒl
			mean = 0.0;
			for(k = 0; k < kNum; k++)
			{
			  mean += (double)gray[k];
			}
			mean /= (double)kNum;
			imageOut[i + j * imgWidth] = (GLubyte)mean;
		}//i
	}//j
}


void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒieϊj
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 's')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		saveBitmap8(imgWidth, imgHeight, imageOut, FILENAME_OUT); 
	  break;

	default:
	  break;
  }
}

