/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

Canny edge detectoriGrayScale)
ŒVF[_iOpenGL onlyj

*/
//摜t@C
//#define FILENAME_IN "../../bmp256/matumae256-1.bmp"
//#define FILENAME_IN "../../bmp256/Lenna.bmp"
#define FILENAME_IN "../../bmp/Px2.bmp"

#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glut.h>
#include <math.h>
#include "../../bmpLoadSave.h"
#define M_PI  3.14159265358979

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void gaussian();
void sobel(float* dx, float* dy);
void canny();


//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte imageOut[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
//EChẼTCY
int width  = 800;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;

//int type = 0;//max
int size = 7;//GaussiañTCY
double thUpp = 50.0;
double thLow = 40.0;
bool flagHelp = false;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGBA);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("GL_Canny");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
  //Cxg[vɓ
  glutMainLoop();
  return 0;
}

void init(void)
{
  //wiF
  //glClearColor(0.2, 0.2, 0.2, 1.0);
	//mN摜̎擾
	loadGrayData(image, &imgWidth, &imgHeight, FILENAME_IN);
  printf("}EX/L[̐ɂ'H'L[vbV \n");
}

void display(void)
{
  //Ԍv
  LARGE_INTEGER freq, time1, time2;
	DWORD pTime;
	memset(&freq,  0x00, sizeof freq);
	memset(&time1, 0x00, sizeof time1);
	memset(&time2, 0x00, sizeof time2);
	pTime = 0;

	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &time1);

	//J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);

	canny();

	//̈ʒu
	int qx0= px0;
	int qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;
	glRasterPos2i(qx0, qy0);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glDrawPixels(imgWidth, imgHeight, GL_LUMINANCE, GL_UNSIGNED_BYTE, imageOut);

	QueryPerformanceCounter( &time2);
	pTime = (DWORD)((time2.QuadPart - time1.QuadPart) * 1000000 / freq.QuadPart);
	printf(" = %d[s] \n", pTime);

	if(flagHelp)
  {
		printf("[F1]L[FtB^TCYsize̕ύX \n");
		printf("[F2]L[FʂlthHigh̕ύX \n");
		printf("[F3]L[FʂlthLow̕ύX \n");
		flagHelp = false;
  }
//I
  glFlush();
}

void gaussian()
{
	//Gaussian filter  parameter
	float sigma = 1.0;
	float weight[81];

	int i, j, k, ii, jj;

	for(jj = 0; jj < size; jj++)		
	{
		j = -(size-1)/2 + jj;
		for(ii = 0; ii < size; ii++)
		{ 
			i = -(size-1)/2 + ii;
			weight[ii + jj * size] = exp(-double(i*i + j*j) / (2.0 * sigma * sigma));
		}
	}
	float sum = 0.0;
	for(k = 0; k < size * size; k++) sum += weight[k];
	for(k = 0; k < size * size; k++) weight[k] /= sum;//2.0 * 3.141592 * sigma * sigma;//sum;//d
//for(k = 0; k < size * size; k++) printf("k=%d weight=%f \n", k, weight[k]);

	//R{[V
	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			if(j < (size-1)/2 || j >= imgHeight - (size-1)/2 || i < (size-1)/2 || i >= imgWidth - (size-1)/2)
			{ imageOut[i + j * imgWidth] = image[i + j * imgWidth]; }
			else
			{
				sum = 0.0;
				for(jj = -(size-1)/2; jj <= (size-1)/2; jj++)
				{
					for(ii = -(size-1)/2; ii <= (size-1)/2; ii++)
					{
						k = (size-1)/2+ii + ((size-1)/2+jj) * size;
						sum += (float)image[i+ii + (j+jj) * imgWidth] * weight[k];
					}
				}
				imageOut[i + j * imgWidth] = (GLubyte)sum;
			}
		}
	}
}

void sobel(float* dx, float* dy)
{
	int i, j, k, ii, jj;
//	float dx, dy;
	float sobelX[9] = {-1.0, 0.0, 1.0, -2.0, 0.0, 2.0, -1.0, 0.0, 1.0};
	float sobelY[9] = {-1.0,-2.0,-1.0,  0.0, 0.0, 0.0,  1.0, 2.0, 1.0};

	//R{[V
	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			dx[i + j * imgWidth] = 0.0;
			dy[i + j * imgWidth] = 0.0;
			for(jj = -1; jj <= 1; jj++)
			{
				for(ii = -1; ii <= 1; ii++)
				{
					k = 1+ii + (1+jj) * 3;
					dx[i + j * imgWidth] += (float)imageOut[i+ii + (j+jj) * imgWidth] * sobelX[k];
					dy[i + j * imgWidth] += (float)imageOut[i+ii + (j+jj) * imgWidth] * sobelY[k];
				}
			}
		}
	}
}

void canny()
{
	int i, j, k, kk[4];
	double th;
	double mag, fwd, bck;//l̑傫
	double dxx, dyy;
	int offsetX, offsetY;
	double c = 0.5 / sin(M_PI/8.0);
	GLubyte result;//o͒l

	float *dx, *dy;
	dx = (float*)malloc(imgWidth * imgHeight * sizeof(float));
	dy = (float*)malloc(imgWidth * imgHeight * sizeof(float));
	if(dx == NULL || dy == NULL) {
		printf("dx, dy ̃mۂł܂ \n");
		return;
	}

	gaussian();
	sobel(dx, dy);

	//o͉摜imageOut[]GbWƂăNAiGbW͍,	fl0j
	for(j = 0; j < imgHeight; j++)
		for(i = 0; i < imgWidth; i++) imageOut[i + j * imgWidth] = 255;

	for(j = 1; j < imgHeight-1; j++)
	{
		th = thUpp;
		for(i = 1; i < imgWidth - 1; i++)
		{

			//܂ł̏ōŋߖT1łedgeł΂l
			//BMPt@Cj=0͍ŉsɒ
			kk[0] = i-1 + (j-1)*imgWidth;//
			kk[1] = i + (j-1)*imgWidth;//^
			kk[2] = i+1 +(j-1)*imgWidth;//E
			kk[3] = i-1 + j * imgWidth;//
			if(imageOut[kk[0]] == 0 || imageOut[kk[1]] == 0 ||
				 imageOut[kk[2]] == 0 || imageOut[kk[3]] == 0) th = thLow;

			//ړ_̌z̑傫
			k = i + j * imgWidth;
			dxx = (double)dx[k];
			dyy = (double)dy[k];
			mag = sqrt(dxx*dxx + dyy*dyy);//z̑傫

			if(mag < th) {result = 255; th = thUpp; }//non edge
			else 
			{
				//z
				offsetX = (int)floor( (dxx/mag) * c + 0.5) ;
				offsetY = (int)floor( (dyy/mag) * c + 0.5) ;
//printf("mag=%f,dx=%f,dy=%f,offsetX=%d,offsetY=%d \n",mag,dxx,dyy,offsetX,offsetY);
				k = i + offsetX + (j + offsetY) * imgWidth;//O
				dxx = (double)dx[k];
				dyy = (double)dy[k];
				fwd = sqrt(dxx*dxx + dyy*dyy);//Ǒz̑傫
				k = i - offsetX + (j - offsetY) * imgWidth;//
				dxx = (double)dx[k];
				dyy = (double)dy[k];
				bck = sqrt(dxx*dxx + dyy*dyy);//̌z̑傫
				if(mag > fwd && mag > bck) {result = 0;}//edge
				else {result = 255; th = thUpp;}//non edge
			}
			imageOut[i + j*imgWidth] = (GLubyte)result;
		}
	}
	free(dx);
	free(dy);
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒieϊj
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 's')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		saveBitmap8(imgWidth, imgHeight, imageOut, FILENAME_OUT); 
	  break;

	case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

	default:
	  break;
  }
}

void special(int key, int x, int y)
{
	
	if(key == GLUT_KEY_F1) 
	{
		size += 2;
		if(size > 9) size = 3;
		printf("size = %d \n", size);
	}

  if(key == GLUT_KEY_F2) 
  {
	  if(glutGetModifiers() == 0) thUpp += 0.5;
	  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) thUpp -= 0.5; 
		//if(thUpp > 250.0) thUpp = 250.0;
		if(thUpp < thLow) thUpp = thLow;
		printf("thUpp = %f \n", thUpp);
	}  

  if(key == GLUT_KEY_F3) 
  {
	  if(glutGetModifiers() == 0) thLow += 0.5;
	  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) thLow -= 0.5; 
		if(thLow > thUpp) thLow = thUpp;
		if(thLow < 0.0) thLow = 0.0;
		printf("thLow = %f \n", thLow);
	}  

	//loadGrayData(image, &imgWidth, &imgHeight, FILENAME_IN);
	display();
}

