/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

ZeroCrossiGrayScale)
ŒVF[_iOpenGL onlyj

*/
//摜t@C
//#define FILENAME_IN "../../bmp256/matumae256-1.bmp"
//#define FILENAME_IN "../../bmp256/boat.bmp"
#define FILENAME_IN "../../bmp/Px2.bmp"
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glut.h>
#include <math.h>
#include "../../bmpLoadSave.h"

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void gaussian();
//void copyData();
//void sobel();
void sobelLaplacian();
void zeroCrossing();


//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte imageOut[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
float grad[MAX_IMG_WIDTH * MAX_IMG_HEIGHT];//Sobel operator ̌ʂۑ
float lap[MAX_IMG_WIDTH * MAX_IMG_HEIGHT];//laplacian operator ̌ʂۑ
//EChẼTCY
int width  = 800;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
//int type = 0;//max
int size = 3;//GaussiañTCY
float th = 30.0;//70.0;
bool flagHelp = false;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGBA);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("GL_ZeroCross");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
  //Cxg[vɓ
  glutMainLoop();
  return 0;
}

void init(void)
{
  //wiF
  //glClearColor(0.2, 0.2, 0.2, 1.0);
	//mN摜̎擾
	loadGrayData(image, &imgWidth, &imgHeight, FILENAME_IN);
  printf("}EX/L[̐ɂ'H'L[vbV \n");
}

void display(void)
{
  //J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);

	gaussian();
	sobelLaplacian();
	zeroCrossing();

	//̈ʒu
	int qx0= px0;
	int qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;
	glRasterPos2i(qx0, qy0);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glDrawPixels(imgWidth, imgHeight, GL_LUMINANCE, GL_UNSIGNED_BYTE, imageOut);

	if(flagHelp)
  {
		printf("[F1]L[FtB^TCYsize̕ύX \n");
		flagHelp = false;
  }
//I
  glFlush();
}

void gaussian()
{
	//Gaussian filter  parameter
	float sigma = 1.0;
	float weight[49];

	int i, j, k, ii, jj;

	for(jj = 0; jj < size; jj++)		
	{
		j = -(size-1)/2 + jj;
		for(ii = 0; ii < size; ii++)
		{ 
			i = -(size-1)/2 + ii;
			weight[ii + jj * size] = exp(-double(i*i + j*j) / (2.0 * sigma * sigma));
		}
	}
	float sum = 0.0;
	for(k = 0; k < size * size; k++) sum += weight[k];
	for(k = 0; k < size * size; k++) weight[k] /= sum;//d

	//R{[V
	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			if(j < (size-1)/2 || j >= imgHeight - (size-1)/2 || i < (size-1)/2 || i >= imgWidth - (size-1)/2)
			{ imageOut[i + j * imgWidth] = image[i + j * imgWidth]; }
			else
			{
				sum = 0.0;
				for(jj = -(size-1)/2; jj <= (size-1)/2; jj++)
				{
					for(ii = -(size-1)/2; ii <= (size-1)/2; ii++)
					{
						k = (size-1)/2+ii + ((size-1)/2+jj) * size;
						sum += (float)image[i+ii + (j+jj) * imgWidth] * weight[k];
					}
				}
				imageOut[i + j * imgWidth] = (GLubyte)sum;
			}
		}
	}
}

void sobelLaplacian()
{
	int i, j, k, kk, ii, jj;
	float dx, dy;
	float sobelX[9] = {-1.0, 0.0, 1.0, -2.0, 0.0, 2.0, -1.0, 0.0, 1.0};
	float sobelY[9] = {-1.0,-2.0,-1.0,  0.0, 0.0, 0.0,  1.0, 2.0, 1.0};
	float laplace[9] = { 0.0, 1.0, 0.0, 
		                  1.0,-4.0, 1.0, 
											0.0, 1.0, 0.0 };
	float sum;

	for(j = 1; j < imgHeight-1; j++)
		for(i = 1; i < imgWidth - 1; i++)
		{
			dx = 0.0;
			dy = 0.0;
			sum = 0.0;
			for(jj = -1; jj <= 1; jj++)
				for(ii = -1; ii <= 1; ii++)
				{
					k = 1+ii + (1+jj) * 3;
					kk = i+ii + (j+jj) * imgWidth;
					dx += (float)imageOut[kk] * sobelX[k];
					dy += (float)imageOut[kk] * sobelY[k];
					sum += (float)imageOut[kk] * laplace[k];
				}
				grad[i + j * imgWidth] = (float)sqrt(dx*dx + dy*dy);
				lap[i + j * imgWidth] = sum;
		}
}

void zeroCrossing()
{
	//edgeƂďo
	int i, j;
	GLubyte result;

	for(j = 0; j < imgHeight-1; j++)
		for(i = 0; i < imgWidth-1; i++)
		{
			if(grad[i + j * imgWidth] < th) 
			{
				result = 255;//edgeł͂Ȃ
			}
			else
			{
				if(lap[i+j*imgWidth] * lap[i+1+j*imgWidth] < 0.0  ||
					 lap[i+j*imgWidth] * lap[i+(j+1)*imgWidth] < 0.0) result = 0;
				else result = 255;
			}
			imageOut[i + j * imgWidth] = result;
		}
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒieϊj
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 's')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		saveBitmap8(imgWidth, imgHeight, imageOut, FILENAME_OUT); 
	  break;

	case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

	default:
	  break;
  }
}

void special(int key, int x, int y)
{
	
	if(key == GLUT_KEY_F1) 
	{
		size += 2;
		if(size > 7) size = 3;
		printf("size = %d \n", size);
	}

  if(key == GLUT_KEY_F2) 
  {
	  if(glutGetModifiers() == 0) th += 10.0;
	  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) th -= 10.0; 
		if(th > 200.0) th = 200.0;
		if(th < 10.0) th = 10.0;
		printf("th = %f \n", th);
	}  

	//loadGrayData(image, &imgWidth, &imgHeight, FILENAME_IN);
	display();
}

