/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

Canny edge detectoriGrayScale)
OpenGL + GLSL

*/
//摜t@C
//#define FILENAME_IN "../../bmp256/matumae256-1.bmp"
//#define FILENAME_IN "../../bmp256/boat.bmp"
#define FILENAME_IN "../../bmp/Px1.bmp"

#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include <math.h>
#include "../../bmpLoadSave.h"
#define M_PI  3.14159265358979

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void setTexture();
void drawPlate();
void setTextureFBO();
void setFramebuffer();

//ϐ
//VF[_vO
GLuint program1, program2;

//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte imageOut[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];

//EChẼTCY
int width  = 800;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int qy0;//

int size = 3;//GaussiañTCY
double thUpp = 30.0;
double thLow = 10.0;
float sigma = 0.5;
float th = 0.1;
bool flagHelp = false;
//framebuffer object
GLuint texName[2];//texture object
GLuint fbName;//framebuffer object

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGBA);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_Canny");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
	glewInit();//glew.hɎĂ
  init();
	initGlsl(&program1, "gaussGrad.vert", "gaussGrad.frag");
	initGlsl(&program2, "canny.vert", "canny.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteTextures(2, texName);
	glDeleteFramebuffersEXT(1, &fbName);
	glDeleteProgram(program1);
	glDeleteProgram(program2);
  return 0;
}

void init(void)
{
  //wiF
  //glClearColor(0.2, 0.2, 0.2, 1.0);
	//mN摜̎擾
	loadGrayData(image, &imgWidth, &imgHeight, FILENAME_IN);
	glGenTextures(2, texName);//eNX`IuWFNg̖Ot
	setTexture();
	setTextureFBO();
	setFramebuffer();

  printf("}EX/L[̐ɂ'H'L[vbV \n");
}

void setFramebuffer(void)
{
	glGenFramebuffersEXT( 1, &fbName );
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbName );
  //textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT,
	                                           GL_TEXTURE_2D, texName[1], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}


void setTexture()
{
  //eNX`IuWFNg̍쐬
  glBindTexture(GL_TEXTURE_2D, texName[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_LUMINANCE,imgWidth,imgHeight,0,GL_LUMINANCE,GL_UNSIGNED_BYTE,image);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}


void setTextureFBO()
{
  glBindTexture(GL_TEXTURE_2D, texName[1]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,0);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void display(void)
{
  //Ԍv
  LARGE_INTEGER freq, time1, time2;
	DWORD pTime;
	memset(&freq,  0x00, sizeof freq);
	memset(&time1, 0x00, sizeof time1);
	memset(&time2, 0x00, sizeof time2);
	pTime = 0;

	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &time1);

	//Step1:Gaussian Graduent
	//framebuffer objectL
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbName );
  glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);
	//J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);
	resize(width, height);

  glUseProgram(program1);
  GLint imageLoc = glGetUniformLocation(program1, "image");
  glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint imgWidthLoc = glGetUniformLocation(program1, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program1, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint sizeLoc = glGetUniformLocation(program1, "size");
	glUniform1i(sizeLoc, size);
	GLint sigmaLoc = glGetUniformLocation(program1, "sigma");
	glUniform1f(sigmaLoc, sigma);

	drawPlate();
  // VF[_vỎ 
  glUseProgram(0);
  glBindTexture(GL_TEXTURE_2D, 0);
  //framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );

	//step2:nonmaximal suppresion
  glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, texName[1]);

	//J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);
	resize(width, height);
  glUseProgram(program2);
  GLint samplerGradLoc = glGetUniformLocation(program2, "samplerGrad");
  glUniform1i(samplerGradLoc, 1);//GL_TEXTURE1Kp
	imgWidthLoc = glGetUniformLocation(program2, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	imgHeightLoc = glGetUniformLocation(program2, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint threshLoc = glGetUniformLocation(program2, "thresh");
	glUniform1f(threshLoc, th);

	qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;

	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	drawPlate();
	glPopMatrix();
  // VF[_vỎ 
  glUseProgram(0);
  glBindTexture(GL_TEXTURE_2D, 0);

	QueryPerformanceCounter( &time2);
	pTime = (DWORD)((time2.QuadPart - time1.QuadPart) * 1000000 / freq.QuadPart);
	printf(" = %d[s] \n", pTime);

	if(flagHelp)
  {
		printf("[F1]L[FtB^TCYsize̕ύX \n");
		printf("[F2]L[FKEVAtB^̕W΍sigma̕ύX \n");
		printf("[F3]L[FCannytB^̂lth̕ύX \n");
		flagHelp = false;
  }
//I
  glFlush();
}

void drawPlate()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth, 0);
		glVertex2i(imgWidth, imgHeight);
		glVertex2i(0, imgHeight);
	glEnd();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒieϊj
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 's')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
//		glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, imageOut);
//		saveBitmap24(imgWidth, imgHeight, imageOut, FILENAME_OUT); 
		glReadPixels(px0, qy0, imgWidth, imgHeight, GL_LUMINANCE, GL_UNSIGNED_BYTE, image);
		saveBitmap8(imgWidth, imgHeight, image, FILENAME_OUT); 
	  break;

	case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

	default:
	  break;
  }
}

void special(int key, int x, int y)
{
	
	if(key == GLUT_KEY_F1) 
	{
		size += 2;
		if(size > 5) size = 3;
		printf("size = %d \n", size);
	}

  if(key == GLUT_KEY_F2) 
  {
	  if(glutGetModifiers() == 0) sigma += 0.05;
	  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) sigma -= 0.05; 
		if(sigma < 0.1) sigma = 0.1;
		printf("sigma = %f \n", sigma);
	}  

  if(key == GLUT_KEY_F3) 
  {
	  if(glutGetModifiers() == 0) th += 0.01;
	  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) th -= 0.01; 
		if(th , 0.0) th = 0.0;
		printf("th = %f \n", th);
	}  
	//loadGrayData(image, &imgWidth, &imgHeight, FILENAME_IN);
	display();
}

