uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform int dir;//̕(deg)
uniform float coef;
uniform int type;
varying vec2 pos;//eNX`W
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);
const int size = 3;

void main(void)
{
	int i, j, k, l;
	float weight[9];
	vec2 offset[9];
	//offseťvZ
	for(int j = 0; j < size; j++)
		for(int i = 0; i < size; i++)
		{ 
			offset[i+j*3] = vec2(float(-(size-1)/2 + i) * dx, float(-(size-1)/2 + j) * dy) ;
		}

	if(dir == 0)
	{
		weight[0] = -1.0; weight[1] = 0.0; weight[2] = 1.0;
		weight[3] = -1.0; weight[4] = 0.0; weight[5] = 1.0;
		weight[6] = -1.0; weight[7] = 0.0; weight[8] = 1.0;
	}
	else if(dir == 45)
	{
		weight[0] = -1.0; weight[1] =-1.0; weight[2] = 0.0;
		weight[3] = -1.0; weight[4] = 0.0; weight[5] = 1.0;
		weight[6] =  0.0; weight[7] = 1.0; weight[8] = 1.0;
	}
	else if(dir == 90)
	{
		weight[0] = -1.0; weight[1] =-1.0; weight[2] =-1.0;
		weight[3] =  0.0; weight[4] = 0.0; weight[5] = 0.0;
		weight[6] =  1.0; weight[7] = 1.0; weight[8] = 1.0;
	}
	else if(dir == 135)
	{
		weight[0] =  0.0; weight[1] =-1.0; weight[2] =-1.0;
		weight[3] =  1.0; weight[4] = 0.0; weight[5] =-1.0;
		weight[6] =  1.0; weight[7] = 1.0; weight[8] = 0.0;
	}
	else if(dir == 180)
	{
		weight[0] =  1.0; weight[1] = 0.0; weight[2] =-1.0;
		weight[3] =  1.0; weight[4] = 0.0; weight[5] =-1.0;
		weight[6] =  1.0; weight[7] = 0.0; weight[8] =-1.0;
	}
	else if(dir == 225)
	{
		weight[0] =  1.0; weight[1] = 1.0; weight[2] = 0.0;
		weight[3] =  1.0; weight[4] = 0.0; weight[5] =-1.0;
		weight[6] =  0.0; weight[7] =-1.0; weight[8] =-1.0;
	}
	else if(dir == 270)
	{
		weight[0] =  1.0; weight[1] = 1.0; weight[2] = 1.0;
		weight[3] =  0.0; weight[4] = 0.0; weight[5] = 0.0;
		weight[6] = -1.0; weight[7] =-1.0; weight[8] =-1.0;
	}
	else if(dir == 315)
	{
		weight[0] =  0.0; weight[1] = 1.0; weight[2] = 1.0;
		weight[3] = -1.0; weight[4] = 0.0; weight[5] = 1.0;
		weight[6] = -1.0; weight[7] =-1.0; weight[8] = 0.0;
	}
	
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 col = vec3(0.0);
	//ݍ݉Z
	for(j = 0; j < size*size; j++) 
		col += texture2D(image, texCoord + offset[j]).rgb * weight[j];
	col *= coef;
	if(type == 0)//ʏ̃G{X
		col += vec3(0.5);//Ԓlǉ
	else//sharpening
		col += texture2D(image, texCoord).rgb;
	gl_FragColor = vec4(col, 1.0);		
}
