
uniform sampler2D image;
uniform int imgWidth, imgHeight;
uniform int size;

varying vec2 pos;
//1f̋
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	int i, j, m, n;
	int s0 = (size-1) / 2;//Ǐ̈̒S
	float weight;
	vec2 offset;

	//eNX`W̒ړ_
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
  //W΍摜̖邢Ƃő傫
	vec3 col = texture2D(image, texCoord).rgb;
	float sigma = 0.1 + col.r * 5.0;
	 
	col = vec3(0.0);
	float sum = 0.0;//weight̑a
	for(j = 0; j < size; j++)
	{
		n = -s0 + j;
		for(i = 0; i < size; i++)
		{
			m = -s0 + i;
			offset = vec2(float(m) * dx, float(n) * dy) ;
			weight = exp(-float(m*m + n*n) / (2.0 * sigma * sigma));
			sum += weight;
			col += texture2D(image, texCoord + offset).rgb * weight;			
		}
	}
	col /= sum;//K
	gl_FragColor = vec4(col, 1.0) ;	
}
