/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

CXg摜̍쐬
HSVɂ|X^[[V
RGB->HSV(HSVꂼƗɊK팸j->RGB
OpenGL + GLSL
*/

//摜t@C
//#define FILENAME_IN "../../bmp256/fruits1.bmp"
//#define FILENAME_IN "../../bmp256/vegetables1.bmp"
//#define FILENAME_IN "../../bmp256/girl.bmp"
//#define FILENAME_IN "../../bmp256/dog3-2.bmp"
#define FILENAME_IN "../../bmp/Px1.bmp"

#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../bmpLoadSave.h"

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void drawPlate();
void setTexture();
void special(int key, int x, int y);

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
//EChẼTCY
int width  = 800;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int qy0;//
//VF[_vO
GLuint program;
//o͉摜̊K
int nLevelH = 4;//F̊K
int nLevelS = 4;//ʓx̊K
int nLevelV = 4;//x̊K
//1K̂Ƃ̐FCēxCxŒl
float hue = 180.0;
float chroma = 0.5;
float value = 0.5;
//`Zxϊ
float gamma = 1.0;
//Prewitt filter̂Ql̂l
float threshEdge = 0.7;
//`惂[h
int modeRender = 0;//ׂ

//wvL[tO
bool flagHelp = false;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGB);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_Illustration");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
	initGlsl(&program, "illustration.vert", "illustration.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteProgram(program);
  return 0;
}

void init(void)
{
  //wiF
  glClearColor(0.2, 0.2, 0.2, 1.0);
	//J[摜̎擾
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	setTexture();

  printf("}EX/L[̐ɂ'H'L[vbV \n");
}

void setTexture()
{
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);//NEAREST);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);//NEAREST);
}

void display(void)
{
  //Ԍv
  LARGE_INTEGER freq, time1, time2;
	DWORD pTime;
	memset(&freq,  0x00, sizeof freq);
	memset(&time1, 0x00, sizeof time1);
	memset(&time2, 0x00, sizeof time2);
	pTime = 0;

	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &time1);

	//J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);

  // VF[_vO̓Kp 
	glUseProgram(program);
	GLint imageLoc = glGetUniformLocation(program, "image");
	glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint imgWidthLoc = glGetUniformLocation(program, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint levelHLoc = glGetUniformLocation(program, "nLevelH");
	glUniform1i(levelHLoc, nLevelH);
	GLint levelSLoc = glGetUniformLocation(program, "nLevelS");
	glUniform1i(levelSLoc, nLevelS);
	GLint levelVLoc = glGetUniformLocation(program, "nLevelV");
	glUniform1i(levelVLoc, nLevelV);
	GLint gammaLoc = glGetUniformLocation(program, "gamma");
	glUniform1f(gammaLoc, gamma);
	GLint hueLoc = glGetUniformLocation(program, "hue");
	glUniform1f(hueLoc, hue);
	GLint chromaLoc = glGetUniformLocation(program, "chroma");
	glUniform1f(chromaLoc, chroma);
	GLint valueLoc = glGetUniformLocation(program, "value");
	glUniform1f(valueLoc, value);
	GLint threshEdgeLoc = glGetUniformLocation(program, "threshEdge");
	glUniform1f(threshEdgeLoc, threshEdge);
	GLint modeLoc = glGetUniformLocation(program, "modeRender");
	glUniform1i(modeLoc, modeRender);

	qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;

	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	drawPlate();
	glPopMatrix();
  // VF[_vỎ 
  glUseProgram(0);

	QueryPerformanceCounter( &time2);
	pTime = (DWORD)((time2.QuadPart - time1.QuadPart) * 1000000 / freq.QuadPart);
	printf(" = %d[s] \n", pTime);

	if(flagHelp)
  {
		printf("[F1]L[FFK̕ύX \n");
		printf("[F2]L[FʓxK̕ύX \n");
		printf("[F3]L[FxK̕ύX \n");
		printf("[F4]L[FFŒl̕ύX \n");
		printf("[F5]L[FʓxŒl̕ύX \n");
		printf("[F6]L[FxŒl̕ύX \n");
		printf("[F7]L[FPxK}l̕ύX \n");
		printf("[F8]L[F2ll̕ύX \n");
		printf("[F9]L[F`惂[h̕ύX \n");
		flagHelp = false;
  }
  //I
	glFlush();
}

void drawPlate()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth, 0);
		glVertex2i(imgWidth, imgHeight);
		glVertex2i(0, imgHeight);
	glEnd();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒ
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, image);
		saveBitmap24(imgWidth, imgHeight, image, FILENAME_OUT); 
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) nLevelH += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	nLevelH -= 1;  
		if(nLevelH < 1) nLevelH = 1;
		else if(nLevelH == 17)  nLevelH = 32;
		else if(nLevelH == 33)  nLevelH = 64;
		else if(nLevelH == 65)  nLevelH = 128;
		else if(nLevelH == 129) nLevelH = 256;
		else if(nLevelH >= 256) nLevelH = 256;
		else if(nLevelH == 255) nLevelH = 128;
		else if(nLevelH == 127) nLevelH = 64;
		else if(nLevelH == 63)  nLevelH = 32;
		else if(nLevelH == 31)  nLevelH = 16;
		printf("FK = %d \n", nLevelH); 
	}
	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) nLevelS += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	nLevelS -= 1;  
		if(nLevelS < 1) nLevelS = 1;
		else if(nLevelS == 17)  nLevelS = 32;
		else if(nLevelS == 33)  nLevelS = 64;
		else if(nLevelS == 65)  nLevelS = 128;
		else if(nLevelS == 129) nLevelS = 256;
		else if(nLevelS >= 256) nLevelS = 256;
		else if(nLevelS == 255) nLevelS = 128;
		else if(nLevelS == 127) nLevelS = 64;
		else if(nLevelS == 63)  nLevelS = 32;
		else if(nLevelS == 31)  nLevelS = 16;
		printf("ʓxK = %d \n", nLevelS); 
	}
	if(key == GLUT_KEY_F3) 
	{
	  if(glutGetModifiers() == 0) nLevelV += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	nLevelV -= 1;  
		if(nLevelV < 1) nLevelV = 1;
		else if(nLevelV == 17)  nLevelV = 32;
		else if(nLevelV == 33)  nLevelV = 64;
		else if(nLevelV == 65)  nLevelV = 128;
		else if(nLevelV == 129) nLevelV = 256;
		else if(nLevelV >= 256) nLevelV = 256;
		else if(nLevelV == 255) nLevelV = 128;
		else if(nLevelV == 127) nLevelV = 64;
		else if(nLevelV == 63)  nLevelV = 32;
		else if(nLevelV == 31)  nLevelV = 16;
		printf("xK = %d \n", nLevelV); 
	}
	if(key == GLUT_KEY_F4) 
	{
	  if(glutGetModifiers() == 0) hue += 10.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	hue -= 10.0;  
		if(hue < 0.0) hue = 0.0;
		if(hue > 360.0) hue = 360.0;
		printf("FŒlhue = %f \n", hue); 
	}
	if(key == GLUT_KEY_F5) 
	{
	  if(glutGetModifiers() == 0) chroma += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	chroma -= 0.05;  
		if(chroma < 0.0) chroma = 0.0;
		if(chroma > 1.0) chroma = 1.0;
		printf("ʓxŒlchroma = %f \n", chroma); 
	}
	if(key == GLUT_KEY_F6) 
	{
	  if(glutGetModifiers() == 0) value += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	value -= 0.05;  
		if(value < 0.0) value = 0.0;
		if(value > 10) value = 1.0;
		printf("xŒlvalue = %f \n", value); 
	}
	if(key == GLUT_KEY_F7) 
	{
	  if(glutGetModifiers() == 0) gamma += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	gamma -= 0.05;  
		if(gamma < 0.1) gamma = 0.1;
		printf("Pxgamma = %f \n", gamma); 
	}
	if(key == GLUT_KEY_F8) 
	{
	  if(glutGetModifiers() == 0) threshEdge += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	threshEdge -= 0.05;  
		if(threshEdge < 0.1) threshEdge = 0.1;
		printf("GbW2llthreshEdge = %f \n", threshEdge); 
	}
	if(key == GLUT_KEY_F9) 
	{
		modeRender ++;
		if(modeRender == 3) modeRender = 0;
		if(modeRender == 0) printf("摜 \n");
		else if(modeRender == 1) printf("K팸摜 \n");
		else printf("GbWo摜 \n");
	}


	display();
}
