/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

ʉ
OpenGL+GLSL
*/

//摜t@C
//#define FILENAME_IN "../../bmp/Px1.bmp"
#define FILENAME_IN "../../bmp/O.bmp"
//#define FILENAME_IN "../../bmp256/matumae256-1.bmp"
//#define FILENAME_IN "../../bmp256/Lenna.bmp"
//#define FILENAME_IN "../../bmp256/boat.bmp"

//o͉摜t@C
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include <math.h>
#include "../../myGlsl.h"
#include "../../bmpLoadSave.h"
#define M_PI  3.14159265358979

//֐̃vg^Cv錾
void init();
void display();
void special(int key, int x, int y);
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void drawPlate();
void drawStroke();
double random(double minV, double maxV);
void makePoint();
void prewitt(float* dx, float* dy);
void getEdgeDir();
void levelTrans();
void setTexture();
void setFramebuffer();
void setTextureFBO();

//O[oϐ
//摜̃TCYƔz
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageGray[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte image2[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageOut[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLbyte edgeDirX[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLbyte edgeDirY[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];

//EChẼTCY
int width  = 600;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int qx0, qy0;//
float gamma = 1.0;      //`Zxϊ̃K}l
int nLevel = 16;        //K
int widthStroke = 3;    //Xg[N̕
int lengthStroke = 3;   //Xg[N(Б)
float probStroke = 0.02;//Xg[N
float depthStroke = 0.05;//Xg[N̔Z
//modal filter size
int size = 3;
int dir = 0;//emboss̕
float coef = 0.2;//embossW
//VF[_vO
GLuint program1, program2;
//texture object
GLuint texName[2];
//framebuffer object
GLuint fbName;

bool flagHelp = false;
bool flagOriginal = true;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGBA);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_OilPaint");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
	glewInit();//glew.hɎĂ
  init();
	initGlsl(&program1, "modal.vert", "modal.frag");
	initGlsl(&program2, "emboss.vert", "emboss.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteTextures(2, texName);
	glDeleteFramebuffersEXT(1, &fbName);
	glDeleteProgram(program1);
	glDeleteProgram(program2);
  return 0;
}

void init(void)
{
  //wiF
  glClearColor(0.2, 0.2, 0.2, 1.0);
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	loadGrayData(imageGray, &imgWidth, &imgHeight, FILENAME_IN);
	glGenTextures(2, texName);//eNX`IuWFNg̖Ot
	setTexture();
	setTextureFBO();
	setFramebuffer();
}

void setTexture()
{
  glBindTexture(GL_TEXTURE_2D, texName[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,imageOut);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setFramebuffer(void)
{
	glGenFramebuffersEXT( 1, &fbName );
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbName );
  //textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT,
	                                           GL_TEXTURE_2D, texName[1], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void setTextureFBO()
{
  glBindTexture(GL_TEXTURE_2D, texName[1]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,0);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void display(void)
{
  //Ԍv
  LARGE_INTEGER freq, time1, time2;
	DWORD pTime;
	memset(&freq,  0x00, sizeof freq);
	memset(&time1, 0x00, sizeof time1);
	memset(&time2, 0x00, sizeof time2);
	pTime = 0;

	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &time1);

	levelTrans();//ZxϊEK팸
	getEdgeDir();//GbWistroke쐬ɕKvj
 
	//ZxϊEK팸ꂽ摜`
	//J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);
	//̈ʒu
	qx0= px0;
  qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;
	if(flagOriginal)
	{
		glRasterPos2i(qx0, qy0);
		glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
		glDrawPixels(imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, image2);
	}
	//Xg[N`
	glPushMatrix();
	glTranslatef(qx0, qy0, 0.0);
	drawStroke();
	glPopMatrix();
  //̃obt@Ƀ_Oꂽ摜ǂݍ
	glPixelStorei(GL_PACK_ALIGNMENT, 1);
	glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, imageOut);
	setTexture();

	//framebuffer objectL
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbName );
  glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);
	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	int width0 = width;//Window̃TCYۑ
	int height0 = height;
	resize(imgWidth, imgHeight);
	width = width0;//WindowTCYɖ߂
	height = height0;

	glUseProgram(program1);
	GLint imageLoc = glGetUniformLocation(program1, "image");
	glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint imgWidthLoc = glGetUniformLocation(program1, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program1, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint sizeLoc = glGetUniformLocation(program1, "size");
	glUniform1i(sizeLoc, size);
	GLint nLevelLoc = glGetUniformLocation(program1, "nLevel");
	glUniform1i(nLevelLoc, nLevel);

	drawPlate();
	// VF[_vỎ 
	glUseProgram(0);

  glBindTexture(GL_TEXTURE_2D, 0);
  //framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );

	//emboss filter
	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	resize(width, height);
	glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, texName[1]);

  // VF[_vO̓Kp 
  glUseProgram(program2);
  imageLoc = glGetUniformLocation(program2, "image");
  glUniform1i(imageLoc, 1);//GL_TEXTURE1Kp
	imgWidthLoc = glGetUniformLocation(program2, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	imgHeightLoc = glGetUniformLocation(program2, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint dirLoc = glGetUniformLocation(program2, "dir");
	glUniform1i(dirLoc, dir);
	GLint coefLoc = glGetUniformLocation(program2, "coef");
	glUniform1f(coefLoc, coef);

	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	drawPlate();
	glPopMatrix();
  // VF[_vỎ 
  glUseProgram(0);
  glBindTexture(GL_TEXTURE_2D, 0);

	QueryPerformanceCounter( &time2);
	pTime = (DWORD)((time2.QuadPart - time1.QuadPart) * 1000 / freq.QuadPart);
	printf(" = %d[ms] \n", pTime);

	if(flagHelp)
  {
		printf("[F1]L[FŕpltB^TCYsizȇ \n");
		printf("[F2]L[F`Zxϊ̃K}lgammȃ \n");
		printf("[F3]L[FKnLevel̑ \n");
		printf("[F4]L[FXg[NlengthStrokȇ \n");
		printf("[F5]L[FXg[NwidthStrokȇ  \n");
		printf("[F6]L[FXg[NZxdepthStrokȇ \n");
		printf("[F7]L[FmxprobStrokȇ \n");
		printf("[F8]L[FG{Xdir̕ύX \n");
		printf("[F9]L[FG{XWcoef̑ \n");
		printf("[F10]L[F摜\/\ؑ \n");
		flagHelp = false;
  }

	//I
  glFlush();
}

void levelTrans()
{//ZxxϊƊK팸
	int i, j, k, m, n;
	double zStep = 255.0 / float(nLevel-1);

	for(m = 0; m < 3; m++)
	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			k = i + j * imgWidth;
			//Px
			image2[k][m] = (GLubyte)(pow((double)image[k][m]/255.0, (double)gamma) * 255.0);
			//Kጸ
			n = floor((double)image2[k][m] / zStep + 0.5);
			image2[k][m] = (GLubyte)(zStep * n);
		}
	}
}

void prewitt(float* dx, float* dy)
{
	int i, j, k, m, ii, jj;
	float prewittX[9] = {-1.0, 0.0, 1.0, -1.0, 0.0, 1.0, -1.0, 0.0, 1.0};
	float prewittY[9] = {-1.0,-1.0,-1.0,  0.0, 0.0, 0.0,  1.0, 1.0, 1.0};

	//R{[V
	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			k = i + j * imgWidth;
			dx[k] = 0.0;
			dy[k] = 0.0;
			for(jj = -1; jj <= 1; jj++)
			{
				for(ii = -1; ii <= 1; ii++)
				{
					m = 1+ii + (1+jj) * 3;
					dx[k] += (float)imageGray[i+ii + (j+jj) * imgWidth] * prewittX[m];
					dy[k] += (float)imageGray[i+ii + (j+jj) * imgWidth] * prewittY[m];
				}
			}
		}
	}
}

void getEdgeDir()
{
	int i, j, k, m;
	double dxx, dyy, mag;
	double c = 0.5 / sin(M_PI/8.0);

	float *dx, *dy;
	dx = (float*)malloc(imgWidth * imgHeight * sizeof(float));
	dy = (float*)malloc(imgWidth * imgHeight * sizeof(float));
	if(dx == NULL || dy == NULL) {
		printf("dx, dy ̃mۂł܂ \n");
		return;
	}

	prewitt(dx, dy);

	for(m = 0; m < 3; m++)
		for(j = 1; j < imgHeight-1; j++)
			for(i = 1; i < imgWidth - 1; i++)
			{
				k = i + j * imgWidth;
				dxx = (double)dx[k];
				dyy = (double)dy[k];
				mag = sqrt(dxx*dxx + dyy*dyy);//z̑傫
				mag = sqrt(dxx*dxx + dyy*dyy);//z̑傫
				if(mag < 10.0) {//ẑ₩ȕ͐nb`Ƃ
					edgeDirX[k] = 1;
					edgeDirY[k] = 0;
					//continue;
				}
				else{
					//edge̕
					edgeDirY[k] = (GLbyte)floor( (dxx/mag) * c + 0.5) ;//zxGbWy
					edgeDirX[k] = - (GLbyte)floor( (dyy/mag) * c + 0.5) ;//zyGbWx
//if(j == 100)printf("i=%d edgeDirX=%d edgeDirY=%d \n", i, edgeDirX[k], edgeDirY[k]);
				}
			}
	free(dx);
	free(dy);
}

double random(double minV, double maxV)
{//minV`maxV̈l
	return( (maxV - minV) * (double)rand() / (double)RAND_MAX ) + minV;
}

void drawStroke()
{
	int i, j, k, m;
	float gg[3];
  //
  glLineWidth(widthStroke);

	if(lengthStroke == 0) return;
	for(j = 0; j < imgHeight; j++)
		for(i = 0; i < imgWidth; i++)
		{
			k = i + j * imgWidth;
			//stroke̔Z摜̔Zxɂقڈv
			for(m = 0; m < 3; m++) 
				gg[m] = image2[k][m] / 255.0 + random(-depthStroke, depthStroke);
			
			glColor3f(gg[0], gg[1], gg[2]);

			if(random(0.0, 1.0) > 1.0 - probStroke )
			{
				glBegin(GL_LINES);
					glVertex2i( i - lengthStroke*edgeDirX[k], j - lengthStroke*edgeDirY[k]);
					glVertex2i( i + lengthStroke*edgeDirX[k], j + lengthStroke*edgeDirY[k]);
				glEnd();	
			}
		}
}

void drawPlate()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth, 0);
		glVertex2i(imgWidth, imgHeight);
		glVertex2i(0, imgHeight);
	glEnd();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒieϊj
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}


void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

		case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(qx0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, imageOut);
		saveBitmap24(imgWidth, imgHeight, imageOut, FILENAME_OUT); 
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) size += 2;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	size -= 2;  
		if(size < 1) size = 1;
		if(size > 13) size = 13;
		printf("TCYsize = %d \n", size);
	}	

	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) gamma += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	gamma -= 0.05;  
		if(gamma < 0.1) gamma = 0.1;
		printf("K}lgamma = %f \n", gamma);
	}	

	if(key == GLUT_KEY_F3) 
	{
	  if(glutGetModifiers() == 0) nLevel += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	nLevel -= 1;  
		if(nLevel < 2) nLevel = 2;
		else if(nLevel == 17) nLevel = 32;
		else if(nLevel == 33) nLevel = 64;
		else if(nLevel == 65) nLevel = 128;
		else if(nLevel == 129) nLevel = 256;
		else if(nLevel >= 256) nLevel = 256;
		else if(nLevel == 255) nLevel = 128;
		else if(nLevel == 127) nLevel = 64;
		else if(nLevel == 63) nLevel = 32;
		else if(nLevel == 31) nLevel = 16;
		printf("KnLevel = %d \n", nLevel);
	}

	if(key == GLUT_KEY_F4) 
	{
	  if(glutGetModifiers() == 0) lengthStroke += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	lengthStroke -= 1;  
		if(lengthStroke < 0) lengthStroke = 0;
		printf("Xg[NlengthStroke = %d \n", lengthStroke);
	}

	if(key == GLUT_KEY_F5) 
	{
	  if(glutGetModifiers() == 0) widthStroke += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	widthStroke -= 1;  
		if(widthStroke < 0) widthStroke = 0;
		printf("Xg[NwidthStroke = %d \n", widthStroke);
	}
	if(key == GLUT_KEY_F6) 
	{
	  if(glutGetModifiers() == 0) depthStroke += 0.01;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	depthStroke -= 0.01;  
		if(depthStroke < 0) depthStroke = 0;
		printf("Xg[NZxdepthStroke = %f \n", depthStroke);
	}

	if(key == GLUT_KEY_F7) 
	{
	  if(glutGetModifiers() == 0) probStroke += 0.002;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	probStroke -= 0.002;  
		if(probStroke < 0.0) probStroke = 0.0;
		printf("mxprobStroke = %f \n", probStroke);
	}	

	if(key == GLUT_KEY_F8) 
	{
		dir += 45;
		if(dir >= 360) dir = 0;
		printf("dir = %d@\n", dir);
	}
	if(key == GLUT_KEY_F9) 
	{
	  if(glutGetModifiers() == 0) coef += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	coef -= 0.1;  
		if(coef < 0.0) coef = 0.0;
		printf("Wcoef = %f \n", coef); 
	}
	if(key == GLUT_KEY_F10) 
	{
		if(flagOriginal == false) {
			flagOriginal = true; printf("摜\ \n"); }
		else {flagOriginal = false; printf("摜\ \n");}
	}

	display();
}

