/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

VoronoiMap쐬iColor)
__zu
OpenGL + GLSL

*/
//o͉摜t@C
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include <math.h>
#include "../../myGlsl.h"
#include "../../bmpLoadSave.h"

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void drawPlate();
void setTexture();
void setTextureVoronoi();
void makeGenerator(short* posX, short* posY, float* red, float* green, float* blue);
void makeRandomVoronoi(short* posX, short* posY, float* red, float* green, float* blue);
double random(double minV, double maxV);

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte imageGen[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageRandom[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
//EChẼTCY
int width  = 800;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int qy0;//
int size = 250;//~̃TCY
int numGen = 20;//50;//_
float alpha = 0.5;
int seed = 0;//̎
//VF[_vO
GLuint program;
//texture object
GLuint texName[2];
//wvL[tO
bool flagHelp = false;
//Ԍv
LARGE_INTEGER freq, time1, time2;
DWORD pTime;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGB | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_VoronoiDiagram");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
	initGlsl(&program, "voronoi.vert", "voronoi.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteProgram(program);
  return 0;
}

void init(void)
{
	glEnable(GL_DEPTH_TEST);	
	//wiF
  glClearColor(0.0, 0.0, 0.0, 1.0);
	imgWidth  = 512;
	imgHeight = 512;
	glGenTextures(2, texName);//eNX`IuWFNg̖Ot
	setTexture();
}

void setTexture()
{
  glBindTexture(GL_TEXTURE_2D, texName[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,imageGen);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setTextureRandomVoronoi()
{
  glBindTexture(GL_TEXTURE_2D, texName[1]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,imageRandom);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}
void display(void)
{
 	//_̈ʒuƐF̃m
	short *posX, *posY;
	float *red, *green, *blue;
	posX = (short*)malloc(numGen * sizeof(short));
	posY = (short*)malloc(numGen * sizeof(short));
	red = (float*)malloc(numGen * sizeof(float));
	green = (float*)malloc(numGen * sizeof(float));
	blue = (float*)malloc(numGen * sizeof(float));
	if(posX == NULL || posY == NULL || red == NULL || green == NULL || blue == NULL)
	{
		printf("_̃mۂł܂ \n");
		return;
	}

  srand(seed);

	//Ԍv
  LARGE_INTEGER freq, time1, time2;
	DWORD pTime;
	memset(&freq,  0x00, sizeof freq);
	memset(&time1, 0x00, sizeof time1);
	memset(&time2, 0x00, sizeof time2);
	pTime = 0;

	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &time1);

	//VoronoiMapeNX`摜image쐬
	makeGenerator(posX, posY, red, green, blue);
	setTexture();

	qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;

	//J[Voronoi摜
	makeRandomVoronoi(posX, posY, red, green, blue);
	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  resize(width, height);
	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	for(int k = 0; k < numGen; k++)
	{
		glColor3f(red[k], green[k], blue[k]);
		glPushMatrix();
		glTranslatef(posX[k], posY[k], 0);
		glutSolidCone(size, size, 24, 2);
		glPopMatrix();
	}
	glPopMatrix();

	//t[obt@Ƀ_ÔeNX`摜Ƃ
 	glPixelStorei(GL_PACK_ALIGNMENT, 1);
	glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, imageRandom);
	setTextureRandomVoronoi();

	//VF[_ŃeNX`摜\
	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	resize(width, height);

  glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);
  glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, texName[1]);

  // VF[_vO̓Kp 
	glUseProgram(program);
	GLint image0Loc = glGetUniformLocation(program, "imageGen");
	glUniform1i(image0Loc, 0);//GL_TEXTURE0Kp
	GLint image2Loc = glGetUniformLocation(program, "imageRandom");
	glUniform1i(image2Loc, 1);//GL_TEXTURE1Kp
	GLint imgWidthLoc = glGetUniformLocation(program, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);

	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	drawPlate();
	glPopMatrix();

	// VF[_vỎ 
  glUseProgram(0);

	QueryPerformanceCounter( &time2);
	pTime = (DWORD)((time2.QuadPart - time1.QuadPart) * 1000 / freq.QuadPart);
	printf(" = %d[ms] \n", pTime);
	if(flagHelp)
  {
		printf("[F1]L[F_numGen̕ύX \n");
		printf("[F2]L[F~TCYsize̕ύX \n");
		printf("[F3]L[F̎seed̕ύX \n");
		flagHelp = false;
  }
  //I
	glFlush();
	free(posX);
	free(posY);
	free(red);
	free(green);
	free(blue);
}

void makeGenerator(short* posX, short* posY, float* red, float* green, float* blue)
{//_肵C_ʒueNX`摜image쐬
	int i, j, k, n; 

	//Ŝ𔒂œhԂ
	for(k = 0; k < 3; k++)
		for(j = 0;j < imgHeight; j++)
			for(i = 0; i < imgWidth; i++) imageGen[i + j * imgWidth][k] = 255;

	for(k = 0; k < numGen; k++)
	{
		//_ʒulŌ߂
		posX[k] = (short)(random(2.0, (double)(imgWidth - 2)));  
		posY[k] = (short)(random(2.0, (double)(imgHeight- 2)));  
		//_ыߖT8f
		for(j = -1; j <= 1; j++)
			for(i = -1; i <= 1; i++)
			{
				n = posX[k]+i + (posY[k]+j) * imgWidth;
				imageGen[n][0] = 255;
				imageGen[n][1] = 0;
				imageGen[n][2] = 0;
			}
	}
}

double random(double minV, double maxV)
{//minV`maxV̈l
	return( (maxV - minV) * (double)rand() / (double)RAND_MAX ) + minV;
}

void makeRandomVoronoi(short* posX, short* posY, float* red, float* green, float* blue)
{//{mC̈̐F𗐐Ō߂
	int k;

	for(k = 0; k < numGen; k++)
	{
	  red[k]   = random(0.0, 1.0);
	  green[k] = random(0.0, 1.0);
	  blue[k]  = random(0.0, 1.0);
	}
}

void drawPlate()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth, 0);
		glVertex2i(imgWidth, imgHeight);
		glVertex2i(0, imgHeight);
	glEnd();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒ
	glOrtho(0.0, w, 0.0, h, -size, 10);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, imageGen);
		saveBitmap24(imgWidth, imgHeight, imageGen, FILENAME_OUT); 
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}


void special(int key, int x, int y)
{
	
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) numGen += 5;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	numGen -= 5;  
		if(numGen > MAX_IMG_HEIGHT * MAX_IMG_WIDTH / 16) numGen = MAX_IMG_HEIGHT * MAX_IMG_WIDTH / 16;
		printf("numGen = %d \n", numGen);
	}

	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) size += 10;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	size -= 10;  
		printf("size = %d \n", size);
	}

	if(key == GLUT_KEY_F3) 
	{
	  if(glutGetModifiers() == 0) seed += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	seed -= 1;  
		printf("seed = %d \n", seed);
	}

	display();
}


