/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

ʉ
OpenGL + GLSL
ڂ(bilateral filter)GLSL
*/

//摜t@C
//#define FILENAME_IN "../../bmp/Px1.bmp"
//#define FILENAME_IN "../../bmp/O.bmp"
//#define FILENAME_IN "../../bmp256/matumae256-1.bmp"
//#define FILENAME_IN "../../bmp256/Lenna.bmp"
//#define FILENAME_IN "../../bmp256/flower1.bmp"
#define FILENAME_IN "../../bmp512/matumae.bmp"

//o͉摜t@C
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <math.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../bmpLoadSave.h"
#define M_PI  3.14159265358979

//֐̃vg^Cv錾
void init();
void display();
void special(int key, int x, int y);
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void drawPlate();
void drawStroke();
double random(double minV, double maxV);
void setTexture();
void setTextureCanny();
void gaussian();
void sobel();
void canny();
void getImageEdge();
void levelTrans();
void synthesis();

//O[oϐ
//摜̃TCYƔz
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageGray[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte image2[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageCanny[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte imageOut[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLbyte edgeDirX[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLbyte edgeDirY[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];

//EChẼTCY
int width  = 600;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int qx0, qy0;//
int size = 3;           //bilateral filter̃TCY
float gamma = 0.7;      //`Zxϊ̃K}l
int nLevel = 16;         //K
int widthStroke = 4;    //Xg[N̕
int lengthStroke = 4;   //Xg[N(Б)
float depthStroke = 0.01;//Xg[N̔Z(̕j
float probStroke = 0.05;//Xg[N
float edgeGray = 0.2;   //GbW̔Zxx
float thUpp = 40.0;     //Canny filter ̏ʂl 
float thLow = 30.0;     //Canny filter ̉ʂl 
float sigmaD = 5.0;     //摜ԕW΍
float sigmaC = 0.3;    //FԕW΍

//VF[_vO
GLuint program;
//texture object
GLuint texName[2];

bool flagHelp = false;
int flagEdge = 0;


int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGBA);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_Watercolor2");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
	initGlsl(&program, "bilateral.vert", "bilateral.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteTextures(2, texName);
 	glDeleteProgram(program);
 return 0;
}

void init(void)
{
  //wiF
  glClearColor(0.2, 0.2, 0.2, 1.0);
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	loadGrayData(imageGray, &imgWidth, &imgHeight, FILENAME_IN);
	glGenTextures(2, texName);//eNX`IuWFNg̖Ot
}

void setTexture()
{
  glBindTexture(GL_TEXTURE_2D, texName[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,imageOut);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setTextureCanny()
{
  glBindTexture(GL_TEXTURE_2D, texName[1]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_LUMINANCE,imgWidth,imgHeight,0,GL_LUMINANCE,GL_UNSIGNED_BYTE,imageCanny);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void display(void)
{
  //Ԍv
  LARGE_INTEGER freq, time1, time2;
	DWORD pTime;
	memset(&freq,  0x00, sizeof freq);
	memset(&time1, 0x00, sizeof time1);
	memset(&time2, 0x00, sizeof time2);
	pTime = 0;

	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &time1);

	//PxƊKጸ
	levelTrans();
	//Canny edge  GbW
	canny();
	setTextureCanny();

 //J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);
	//̈ʒu
	qx0= px0;
	qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;
	//摜`
	glRasterPos2i(qx0, qy0);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glDrawPixels(imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, image2);

	//Xg[N`
	glPushMatrix();
	glTranslatef(qx0, qy0, 0.0);
	drawStroke();
	glPopMatrix();

	//ڂGLSLōs
	//܂ŕ`摜擾eNX`摜imageƂėp
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, imageOut);
	setTexture();

	glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);
	glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, texName[1]);
	glActiveTexture(GL_TEXTURE2);
  glBindTexture(GL_TEXTURE_2D, texName[2]);

	glUseProgram(program);
	GLint imageLoc = glGetUniformLocation(program, "image");
	glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint cannyLoc = glGetUniformLocation(program, "imageCanny");
	glUniform1i(cannyLoc, 1);//GL_TEXTURE1Kp
	GLint imgWidthLoc = glGetUniformLocation(program, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint sizeLoc = glGetUniformLocation(program, "size");
	glUniform1i(sizeLoc, size);
	GLint edgeLoc = glGetUniformLocation(program, "flagEdge");
	glUniform1i(edgeLoc, flagEdge);
	GLint sigmaDLoc = glGetUniformLocation(program, "sigmaD");
	glUniform1f(sigmaDLoc, sigmaD);
	GLint sigmaCLoc = glGetUniformLocation(program, "sigmaC");
	glUniform1f(sigmaCLoc, sigmaC);

	glPushMatrix();
	glTranslatef(px0, qy0, 0.0);
	drawPlate();
	glPopMatrix();
	// VF[_vỎ 
	glUseProgram(0);

	QueryPerformanceCounter( &time2);
	pTime = (DWORD)((time2.QuadPart - time1.QuadPart) * 1000 / freq.QuadPart);
	printf(" = %d[ms] \n", pTime);

	if(flagHelp)
  {
		printf("[F1]L[FtB^TCYsizȇ \n");
		printf("[F2]L[FK}lgammȃ \n");
		printf("[F3]L[FKnLevel̑ \n");
		printf("[F4]L[FXg[NlengthStrokȇ \n");
		printf("[F5]L[FXg[NwidthStrokȇ  \n");
		printf("[F6]L[FXg[NZxdepthStrokȇ \n");
		printf("[F7]L[FmxprobStrokȇ \n");
		printf("[F8]L[FGbW\/\̐؂ւ \n");
		printf("[F9]L[FGbWZxxedgeGray̑ \n");
		printf("[F10]L[FFԕW΍sigmaC̑ \n");
		flagHelp = false;
  }

	//I
  glFlush();
}

void levelTrans()
{//ZxxϊƊK팸
	int i, j, k, m, n;
	double zStep = 255.0 / float(nLevel-1);

	for(m = 0; m < 3; m++)
	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			k = i + j * imgWidth;
			//Px
			image2[k][m] = (GLubyte)(pow((double)image[k][m]/255.0, (double)gamma) * 255.0);
			//Kጸ
			n = floor((double)image2[k][m] / zStep + 0.5);
			image2[k][m] = (GLubyte)(zStep * n);
		}
	}
}

void gaussian()
{
	//Gaussian filter  parameter
	int sizeFilter = 5;
	float sigma = 5.0;
	float weight[25];

	int i, j, k, ii, jj;

	for(jj = 0; jj < sizeFilter; jj++)		
	{
		j = -(sizeFilter-1)/2 + jj;
		for(ii = 0; ii < sizeFilter; ii++)
		{ 
			i = -(sizeFilter-1)/2 + ii;
			weight[ii + jj * sizeFilter] = exp(-double(i*i + j*j) / (2.0 * sigma * sigma));
		}
	}
	float sum = 0.0;
	for(k = 0; k < sizeFilter * sizeFilter; k++) sum += weight[k];
	for(k = 0; k < sizeFilter * sizeFilter; k++) weight[k] /= sum;//2.0 * 3.141592 * sigma * sigma;//sum;//d
//for(k = 0; k < sizeFilter * sizeFilter; k++) printf("k=%d weight=%f \n", k, weight[k]);

	//R{[V
	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			if(j < (sizeFilter-1)/2 || j >= imgHeight - (sizeFilter-1)/2 || i < (sizeFilter-1)/2 || i >= imgWidth - (sizeFilter-1)/2)
			{ imageCanny[i + j * imgWidth] = imageGray[i + j * imgWidth]; }
			else
			{
				sum = 0.0;
				for(jj = -(sizeFilter-1)/2; jj <= (sizeFilter-1)/2; jj++)
				{
					for(ii = -(sizeFilter-1)/2; ii <= (sizeFilter-1)/2; ii++)
					{
						k = (sizeFilter-1)/2+ii + ((sizeFilter-1)/2+jj) * sizeFilter;
						sum += (float)imageGray[i+ii + (j+jj) * imgWidth] * weight[k];
					}
				}
				imageCanny[i + j * imgWidth] = (GLubyte)sum;
			}
		}
	}
}

void sobel(float* dx, float* dy)
{
	int i, j, k, ii, jj;
	float sobelX[9] = {-1.0, 0.0, 1.0, -2.0, 0.0, 2.0, -1.0, 0.0, 1.0};
	float sobelY[9] = {-1.0,-2.0,-1.0,  0.0, 0.0, 0.0,  1.0, 2.0, 1.0};

	//R{[V
	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			dx[i + j * imgWidth] = 0.0;
			dy[i + j * imgWidth] = 0.0;
			for(jj = -1; jj <= 1; jj++)
			{
				for(ii = -1; ii <= 1; ii++)
				{
					k = 1+ii + (1+jj) * 3;
					dx[i + j * imgWidth] += (float)imageCanny[i+ii + (j+jj) * imgWidth] * sobelX[k];
					dy[i + j * imgWidth] += (float)imageCanny[i+ii + (j+jj) * imgWidth] * sobelY[k];
				}
			}
		}
	}
}

void canny()
{
	int i, j, k, kk[4];
	double th;
	double mag, fwd, bck;//l̑傫
	double dxx, dyy;
	int offsetX, offsetY;
	double c = 0.5 / sin(M_PI/8.0);
	float result;//o͒l

	float *dx, *dy;
	dx = (float*)malloc(imgWidth * imgHeight * sizeof(float));
	dy = (float*)malloc(imgWidth * imgHeight * sizeof(float));
	if(dx == NULL || dy == NULL) {
		printf("dx, dy ̃mۂł܂ \n");
		return;
	}

	gaussian();
	sobel(dx, dy);

	//o͉摜imageCanny[]GbWƂăNAiGbW͍,	fl0j
	for(j = 0; j < imgHeight; j++)
		for(i = 0; i < imgWidth; i++) imageCanny[i + j * imgWidth] = 255;

	for(j = 1; j < imgHeight-1; j++)
	{
		th = thUpp;
		for(i = 1; i < imgWidth - 1; i++)
		{
			//܂ł̏ōŋߖT1łedgeł΂l
			//BMPt@Cj=0͍ŉsɒ
			kk[0] = i-1 + (j-1)*imgWidth;//
			kk[1] = i + (j-1)*imgWidth;//^
			kk[2] = i+1 +(j-1)*imgWidth;//E
			kk[3] = i-1 + j * imgWidth;//
			if(imageCanny[kk[0]] == 0 || imageCanny[kk[1]] == 0 ||
				 imageCanny[kk[2]] == 0 || imageCanny[kk[3]] == 0) th = thLow;

			//ړ_̌z̑傫
			k = i + j * imgWidth;
			dxx = (double)dx[k];
			dyy = (double)dy[k];
			mag = sqrt(dxx*dxx + dyy*dyy);//z̑傫

			//GbW̕߂
			if(mag < 10.0) 
			{//ẑ₩ȕ͐nb`Ƃ
					edgeDirX[k] = 1;
					edgeDirY[k] = 0;
			}
			else
			{
				//edge̕
				edgeDirY[k] = (GLbyte)floor( (dxx/mag) * c + 0.5) ;//zxGbWy
				edgeDirX[k] = -(GLbyte)floor( (dyy/mag) * c + 0.5) ;//zyGbWx
			}

			//GbW߂
			if(mag < th) {result = 1.0; th = thUpp; }//non edge
			else 
			{
				//z
				offsetX = (int)floor( (dxx/mag) * c + 0.5) ;
				offsetY = (int)floor( (dyy/mag) * c + 0.5) ;
				k = i + offsetX + (j + offsetY) * imgWidth;//O
				dxx = (double)dx[k];
				dyy = (double)dy[k];
				fwd = sqrt(dxx*dxx + dyy*dyy);//Ǒz̑傫
				k = i - offsetX + (j - offsetY) * imgWidth;//
				dxx = (double)dx[k];
				dyy = (double)dy[k];
				bck = sqrt(dxx*dxx + dyy*dyy);//̌z̑傫
				if(mag > fwd && mag > bck) {result = edgeGray;}//edge
				else {result = 1.0; th = thUpp;}//non edge
			}
			imageCanny[i + j*imgWidth] = (GLubyte)(result * 255.0);
		}
	}
	free(dx);
	free(dy);
}

double random(double minV, double maxV)
{//minV`maxV̈l
	return( (maxV - minV) * (double)rand() / (double)RAND_MAX ) + minV;
}

void drawStroke()
{
	int i, j, k, m;
	float gg[3];

//	getImageEdge();
  //
  glLineWidth(widthStroke);

	if(lengthStroke == 0) return;
	for(j = 0; j < imgHeight; j++)
		for(i = 0; i < imgWidth; i++)
		{
			k = i + j * imgWidth;
			//M̔Z摜̔Zxɂقڈv
			for(m = 0; m < 3; m++) 
			{
				gg[m] = image2[k][m] / 255.0  + random(-depthStroke, depthStroke);
			}
			glColor3f(gg[0], gg[1], gg[2]);

			if(random(0.0, 1.0) > 1.0 - probStroke)
			{
				glBegin(GL_LINES);
					glVertex2i( i - lengthStroke*edgeDirX[k], j - lengthStroke*edgeDirY[k]);
					glVertex2i( i + lengthStroke*edgeDirX[k], j + lengthStroke*edgeDirY[k]);
				glEnd();	
			}
		}
}

void drawPlate()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth, 0);
		glVertex2i(imgWidth, imgHeight);
		glVertex2i(0, imgHeight);
	glEnd();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒieϊj
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}


void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

		case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, imageOut);
		saveBitmap24(imgWidth, imgHeight, imageOut, FILENAME_OUT); 
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) size += 2;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	size -= 2;  
		if(size < 1) size = 1;
		if(size > 13) size = 13;
		printf("tB^TCY = %d \n", size);
	}	

	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) gamma += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	gamma -= 0.05;  
		if(gamma < 0.1) gamma = 0.1;
		printf("K}lgamma = %f \n", gamma);
	}	

	if(key == GLUT_KEY_F3) 
	{
	  if(glutGetModifiers() == 0) nLevel += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	nLevel -= 1;  
		if(nLevel < 2) nLevel = 2;
		else if(nLevel == 17) nLevel = 32;
		else if(nLevel == 33) nLevel = 64;
		else if(nLevel == 65) nLevel = 128;
		else if(nLevel == 129) nLevel = 256;
		else if(nLevel >= 256) nLevel = 256;
		else if(nLevel == 255) nLevel = 128;
		else if(nLevel == 127) nLevel = 64;
		else if(nLevel == 63) nLevel = 32;
		else if(nLevel == 31) nLevel = 16;
		printf("KnLevel = %d \n", nLevel);
	}

	if(key == GLUT_KEY_F4) 
	{
	  if(glutGetModifiers() == 0) lengthStroke += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	lengthStroke -= 1;  
		if(lengthStroke < 0) lengthStroke = 0;
		printf("Xg[NlengthStroke = %d \n", lengthStroke);
	}

	if(key == GLUT_KEY_F5) 
	{
	  if(glutGetModifiers() == 0) widthStroke += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	widthStroke -= 1;  
		if(widthStroke < 0) widthStroke = 0;
		printf("Xg[NwidthStroke = %d \n", widthStroke);
	}

	if(key == GLUT_KEY_F6) 
	{
	  if(glutGetModifiers() == 0) depthStroke += 0.01;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	depthStroke -= 0.01;  
		if(depthStroke < 0.0) depthStroke = 0.0;
		printf("Xg[NZxdepthStroke = %f \n", depthStroke);
	}	
	if(key == GLUT_KEY_F7) 
	{
	  if(glutGetModifiers() == 0) probStroke += 0.002;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	probStroke -= 0.002;  
		if(probStroke < 0.0) probStroke = 0.0;
		printf("mxprobStroke = %f \n", probStroke);
	}	
	if(key == GLUT_KEY_F8)
	{
		flagEdge ++;
		if(flagEdge >= 2) flagEdge = 0;
		if(flagEdge == 0) printf("GbW\ \n");
		else              printf("GbW\ \n");
	}

	if(key == GLUT_KEY_F9) 
	{//l̍邭Ȃ
	  if(glutGetModifiers() == 0) edgeGray -= 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	edgeGray += 0.05;  
		if(edgeGray < 0.0) edgeGray = 0.0;
		if(edgeGray > 1.0) edgeGray = 1.0;
		printf("GbZx = %f \n", edgeGray);
	}	
	if(key == GLUT_KEY_F10) 
	{
	  if(glutGetModifiers() == 0) sigmaC += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	sigmaC -= 0.05;  
		if(sigmaC < 0.1) sigmaC = 0.1;
		printf("FԕW΍sigmaC = %f \n", sigmaC);
	}	

	display();
}

