/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

敗iǏ̈ό`j
OpenGL + GLSL

*/
//摜t@C
#define FILENAME_IN "../../bmp256/Lenna.bmp"
//#define FILENAME_IN "../../bmp256/dog3-2.bmp"

//o͉摜t@C
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../bmpLoadSave.h"

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void drawPlate();
void setTexture();
void special(int key, int x, int y);
void mouse(int button, int state, int x, int y);
void motion(int x, int y);

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
//EChẼTCY
int width  = 800;
int height = 600;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int qy0;//
//VF[_vO
GLuint program;
//ό`̎
int type = 0;
//ό`W
float eps = -0.5;
//}EX
float posMouse[] = {0.0, 0.0};
float radius = 50.0;
//O̕
float widthRing = 5.0;
//`Zxϊ
float gamma = 1.0;
//xK
int nLevelV = 4; 
//GbWQl̂l
float threshEdge = 0.5;

//wvL[tO
bool flagHelp = false;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGB);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_Cartoon");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
	initGlsl(&program, "cartoon.vert", "cartoon.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteProgram(program);
  return 0;
}

void init(void)
{
  //wiF
  glClearColor(0.2, 0.2, 0.2, 1.0);
	//J[摜̎擾
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	//GL_CLAMP[ĥƂC`kۂɋE̖͗lpă_O
	//邱ƂhߋE𔒐Fɂ(wiFƍDFɂȂj
	int i, j, k, m;
	for(m = 0; m < 3; m++)
		for(j = 0; j < imgHeight; j++)
			for(i = 0; i < imgWidth; i++)
			{
				k = i + j * imgWidth;
				if(i == 0 || j == 0 || i == imgWidth-1 || j == imgHeight-1) image[k][m] = 255;
			}

	//}EẌʒuŏl
	posMouse[0] = (float)imgWidth / 2.0;
	posMouse[1] = (float)imgHeight / 2.0;
	setTexture();
	printf("}EX/L[̐ɂ'H'L[vbV \n");
}


void setTexture()
{
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);//NEAREST);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);//NEAREST);
  //eNX`bv@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);//REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);//REPEAT);
}

void display(void)
{
	//J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);

  // VF[_vO̓Kp 
  glUseProgram(program);
  GLint imageLoc = glGetUniformLocation(program, "image");
  glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	GLint imgWidthLoc = glGetUniformLocation(program, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint typeLoc = glGetUniformLocation(program, "type");
	glUniform1i(typeLoc, type);
	GLint epsLoc = glGetUniformLocation(program, "eps0");
	glUniform1f(epsLoc, eps);
	GLint posMLoc = glGetUniformLocation(program, "posMouse");
	glUniform2fv(posMLoc, 1, posMouse);
	GLint radiusLoc = glGetUniformLocation(program, "radius");
	glUniform1f(radiusLoc, radius);
	GLint widthRingLoc = glGetUniformLocation(program, "widthRing");
	glUniform1f(widthRingLoc, widthRing);
	GLint gammaLoc = glGetUniformLocation(program, "gamma");
	glUniform1f(gammaLoc, gamma);
	GLint levelVLoc = glGetUniformLocation(program, "nLevelV");
	glUniform1i(levelVLoc, nLevelV);
	GLint threshEdgeLoc = glGetUniformLocation(program, "threshEdge");
	glUniform1f(threshEdgeLoc, threshEdge);
	
	qy0 = height - imgHeight- py0;
	if(qy0 < 0) qy0 = 0;

	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
	drawPlate();
	glPopMatrix();
  // VF[_vỎ 
  glUseProgram(0);

	if(flagHelp)
  {
		printf("[F1]L[Fό`type̕ύX \n");
		printf("[F2]L[Fό`Weps̕ύX \n");
		printf("[F3]L[F̈攼aradius̕ύX \n");
		printf("[F4]L[FO̕widthRing̕ύX \n");
		printf("[F5]L[FPxK}l̕ύX \n");
		printf("[F6]L[FxK̕ύX \n");
		printf("[F7]L[FGbW2ll̕ύX \n");
		flagHelp = false;
  }
  //I
	glFlush();
}

void drawPlate()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth, 0);
		glVertex2i(imgWidth, imgHeight);
		glVertex2i(0, imgHeight);
	glEnd();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒ
	gluOrtho2D(0.0, w, 0.0, h);

	width = w;
	height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, image);
		saveBitmap24(imgWidth, imgHeight, image, FILENAME_OUT); 
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) type ++;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	type --;
		if(type < 0) type = 0;
		if(type > 2) type = 2; 
		printf("type = %d \n", type);
	} 
	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) eps += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	eps -= 0.1;  
//		if(eps < -1.0) eps = -1.0;
		//if(eps > 1.0) eps = 1.0;
		printf("ό`Weps = %f \n", eps); 
	}
	if(key == GLUT_KEY_F3) 
	{
	  if(glutGetModifiers() == 0) radius += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	radius -= 1.0;  
		if(radius < 5.0) radius = 5.0;
		printf("a = %f \n", radius);
	}	
	if(key == GLUT_KEY_F4) 
	{
	  if(glutGetModifiers() == 0) widthRing += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	widthRing -= 1.0;  
		if(widthRing < 0.0) widthRing = 0.0;
		printf("O̕ = %f \n", widthRing);
	}	
	if(key == GLUT_KEY_F5) 
	{
	  if(glutGetModifiers() == 0) gamma += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	gamma -= 0.1;  
		if(gamma < 0.1) gamma = 0.1;
		printf("Pxgamma =  = %f \n", gamma); 
	}
	if(key == GLUT_KEY_F6) 
	{
	  if(glutGetModifiers() == 0) nLevelV += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	nLevelV -= 1;  
		if(nLevelV < 1) nLevelV = 1;
		else if(nLevelV == 17)  nLevelV = 32;
		else if(nLevelV == 33)  nLevelV = 64;
		else if(nLevelV == 65)  nLevelV = 128;
		else if(nLevelV == 129) nLevelV = 256;
		else if(nLevelV >= 256) nLevelV = 256;
		else if(nLevelV == 255) nLevelV = 128;
		else if(nLevelV == 127) nLevelV = 64;
		else if(nLevelV == 63)  nLevelV = 32;
		else if(nLevelV == 31)  nLevelV = 16;
		printf("xK = %d \n", nLevelV); 
	}
	if(key == GLUT_KEY_F7) 
	{
	  if(glutGetModifiers() == 0) threshEdge += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	threshEdge -= 0.05;  
		if(threshEdge < 0.0) threshEdge = 0.0;
		printf("GbW2llthreshEdge = %f \n", threshEdge); 
	}

	display();
}

//ȉ2̊֐̓}EXɕKv
void mouse(int button, int state, int x, int y)
{
  if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
  {
	  posMouse[0] = x - px0; 
		posMouse[1] = y - py0;
  }
	display();
}

void motion(int x, int y)
{
  posMouse[0] = (x - px0);
  posMouse[1] = (y - py0);
	display();
}

