
uniform sampler2D image;
varying vec2 texCoord;

void main(void)
{
  vec4 diffuse = gl_FrontMaterial.diffuse;
 
  if(texCoord.s < 0.0 || texCoord.s > 1.0 || texCoord.t < 0.0 || texCoord.t > 1.0)
  	gl_FragColor = diffuse;
  else
		gl_FragColor = texture2D(image, texCoord);
		
}