varying vec2 texCoord;
uniform float rTop;
uniform int type;
uniform float eps;
uniform float freq;
uniform float time;
const float pi = 3.14159265;
const float reductH = 0.9;//Zk
const float reductV = 0.9;//cZk
const float phi0 = pi * reductH;
const float rBottom = 1.0;//0.5;
const float h = 1.0;

void main(void)
{
	//~ʓe
	float r = rTop + (rBottom - rTop) * (0.5  - gl_Vertex.z / h);
	float phi = acos(gl_Vertex.x / r);
	float as = 1.0 / (1.0 - 2.0 * phi0 / pi);
	texCoord.s = as * (phi - phi0) / pi;
	float len = sqrt(h * h + (rBottom -rTop) * (rBottom - rTop));
	float at = 1.0 / ((1.0 - 2.0 * reductV) * len);
	texCoord.t = at * (gl_Vertex.z + 0.5*h - reductV) * len / h;
	texCoord.t = 1.0 - texCoord.t;//㉺]

	vec2 pos = gl_Vertex.xz;
  //geometryό`
	if(type == 0)//㕔܂͉gEk(`EOp`j
	{
		eps *= sin(2.0 * time);
		if(eps > 0.0)
			gl_Vertex.x = pos.s * (1.0 - eps * (pos.t + 0.5));
		else
			gl_Vertex.x = pos.s * (1.0 + eps *(0.5 -  pos.t));
  }
  
	else if(type == 1)//ribbon
	{
		freq *= sin(2.0 * time);
	  pos.x -= eps * sin(2.0 * pi * freq * pos.t);
		gl_Vertex.x = pos.x / (1.0 + 2.0*abs(eps));//̑傫𒴂Ȃ悤ɏk		
  }
  gl_Position = ftransform();
}
