
uniform sampler2D image;
uniform int imgWidth, imgHeight;
varying vec2 pos;//eNX`W

const float pi = 3.14159265;
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{	
	vec2 texCoord = vec2(pos.x * dx, pos.y * dy);
	vec3 col = texture2D(image, texCoord).rgb;

	gl_FragColor = vec4(col, 1.0);		
}
