/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

ybgƖ؂̂V[̃Aj[V
OpenGL{GLSL
*/

#define FILENAME_IN0 "../../bmp256/ground1.bmp"
#define FILENAME_IN1 "../../bmp256/grain1.bmp"
#define FILENAME_IN2 "../../bmp256/leaf22.bmp"

//o͉摜t@C
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include <math.h>
#include "../../myGlsl.h"
#include "../../myMath3.h"
#include "../../myPrimitive3.h"
#include "../../bmpLoadSave.h"
#include "myTree1.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void drawTree();
void drawGround();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void setLight();
void viewPos();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void setTextureGround();
void setTextureGrain();
void setTextureLeaf();
void drawPet();
void CalcShadowMat(float* mat, CVector pos);
void drawShadow();

CmyTree1 tree[2];

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageOut[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLuint texName[3];//eNX`ʖ

//affineϊpϐ
struct Object
{
	float pos[3], angle[3], scale[3];
};
//l(Pet)
Object obj = { 
	0.0, 0.0, 0.0,//pos
  0.0, 0.0, 0.0,//angle
//	2.0, 2.0, 2.0 //scale
	1.0, 1.0, 1.0 //scale
};
Object obj0 = obj;//lۑ

//
float lightPos[]  = {0.0, 20.0, 20.0, 1.0};//ʒu
float lightPos0[] = {0.0, 20.0, 20.0, 1.0};//ʒu(l)

//JƎ̐
struct View
{
  //J
	float pos[3];//ʒui_j
	float cnt[3];//_
  float dist;  //_王_܂ł̋
  float theta; //piʂƂ̕Ίpj
  float phi;   //ʊp
  //̐
  float fovY;  //p
  float nearZ; //ONbv(ߕ)
  float farZ;  //Nbv()
};
//l
View view = { 
	0.0, 0.0, 0.0,//pos(̐ݒl)
  0.0, 0.7, 0.0,//cnt 
	6.0, 0.0, 0.0,//dist, theta, phi
	40.0, 0.1, 100.0//fovY,nearZ, farZ
};
View view0 = view;//lۑ
//Window̃TCY
int width = 500;
int height = 500;
//AtBϊ
enum SELECT_KEY {ROTATE, SCALE, TRANSLATE, LIGHT};
SELECT_KEY sKey = ROTATE;
//}EX
int xStart, yStart;
bool flagMouse = false;
//wvL[tO
bool flagHelp = false;
//ʒuύXtO
bool flagLight = false;
//ܲ԰ڰ<-->دސ؂ւtO
bool flagWireframe = false;
//shader program
GLuint program, program2;
//Aj[V
#include "../../myPet.h"
CmyPet pet ;
int frameCount = 0;
int actionMode = 0;

//oߎ
double curTime, lastTime, elapseTime1, elapseTime2;
int fps = 0;//frame per sec

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_Animation3D");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
  init();
  initGlsl(&program, "tree.vert", "tree.frag");
  initGlsl(&program2, "pet.vert", "pet.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteTextures(3, texName);
 	glDeleteProgram(program);
 	glDeleteProgram(program2);
 return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.5, 0.6, 0.9, 1.0);
  viewPos();//_߂
  setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);
  glShadeModel(GL_SMOOTH);

	glGenTextures(3, texName);//eNX`IuWFNg̖Ot
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN0);
  setTextureGround();
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN1);
	setTextureGrain();
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN2);
	setTextureLeaf();

	tree[0].vPos = CVector(1.0, 0.0, 1.0);
	tree[1].vPos = CVector(-1.0, 0.0, 1.0);
	//tree[2].vPos = CVector(0.0, 0.0, 0.0);
	tree[0].create();
	tree[1].create();
	//tree[2].create();
	//Ԋ֌W
  lastTime = timeGetTime();
  fps = 0;
  elapseTime1 = 0.0;//1secԈȓ̌oߎ
  elapseTime2 = 0.0; //init()̑oߎ

  //pet robot Aj[V
  pet.unitTime = 0.025;//Pt[̎ԁiŏ͉̒lj
  //t[f[^쐬
  pet.numFrame0 = 0;
  frameCount = 0;
  if(actionMode == 0)
  {
		pet.vPos.x = 0.0;
		pet.vPos.z = 0.0;
		pet.vAng.y = 0.0;
		pet.walk(2.0, 0.2, 0.5);
		pet.turn(90.0, 1.0);
		pet.walk(1.5, 0.2, 0.5);
		pet.turn(90.0, 1.0);
		pet.walk(2.0, 0.2, 0.5);
		pet.turn(90.0, 1.0);
		pet.walk(1.5, 0.2, 0.5);
		pet.turn(90.0, 1.0);
  }
  else
  {
		pet.walk(2, 0.2, 0.5);
		pet.turn(90.0, 1.0);
		pet.stand(3.0);
		pet.swingTail(5, 1.0);
		pet.wait(1.0);
		pet.initPose(2.0);
  }
	printf("numFrame0=%d \n", pet.numFrame0);

  printf("}EX/L[̐ɂ'H'L[vbV \n");
}

void setTextureGround()
{
  //eNX`IuWFNg̍쐬
  glBindTexture(GL_TEXTURE_2D, texName[0]);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̎w 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setTextureGrain()
{
  //eNX`IuWFNg̍쐬
  glBindTexture(GL_TEXTURE_2D, texName[1]);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̎w 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setTextureLeaf()
{
  //eNX`IuWFNg̍쐬
  glBindTexture(GL_TEXTURE_2D, texName[2]);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̎w 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void display(void)
{
  //Ԍv
	curTime = timeGetTime();
  float dt = (float)(curTime - lastTime) * 0.001;//secɕϊ
  elapseTime1 += dt;
  elapseTime2 += dt;
  fps ++;
  if(elapseTime1 >= 1.0)
  {
		printf("fps = %d \n", fps);
		elapseTime1 = 0.0;
		fps = 0;
  }
	lastTime = curTime;

	//J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();//_ςƂ͂̈ʒuɕKv
  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, 1.0, 0.0);
  else
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, -1.0, 0.0);

  //'L'ʒu
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  if(flagWireframe)//'W'wireframesolid model؂ւ
  {
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
  }
  else glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

  glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);
  glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, texName[1]);
  glActiveTexture(GL_TEXTURE2);
  glBindTexture(GL_TEXTURE_2D, texName[2]);

  //`
  glUseProgram(program);
	//n
	GLint imageLoc = glGetUniformLocation(program, "image");
	glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	drawGround();
 	//
	tree[0].imageLoc = imageLoc;
	tree[1].imageLoc = imageLoc;
	drawTree();
  glUseProgram(0);

  glUseProgram(program2);
  //`
	drawPet();
  glUseProgram(0);
	//e
  drawShadow();
  frameCount++;

	if(flagHelp)
  {
		printf("L[ɂAtBϊ/ړ \n");
		printf("@,Fx \n");
		printf("@,Fy \n");
		printf("@[Shift]{,Fz \n");
		printf("@'R':] \n");
		printf("@'T':sړ \n");
		printf("@'S':ݸ \n");
		printf("@'L'Aʒüړ \n");
		printf("'W'ܲ԰ڰтƿدِ؂ւ \n");
		printf("}EXŎ_ύX \n");
		printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
		printf("  panFщEE{^NbNŒ_Eɕω \n");
		printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
		printf("  tumbleFEɃhbOƎ_Eɕω \n");
		printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
		printf("  zoomFE{^NbNŃY[C \n");
		printf("        EE{^NbNŃY[AEg \n");
		printf("[Shift]+'R'ŃZbg \n");
		flagHelp = false;
  }
  //I
  glutSwapBuffers();
}

void drawTree()
{

	for(int k = 0; k < 2; k++) 
	{
		tree[k].time = elapseTime2;
		tree[k].draw();
	}
}

void drawGround()
{
	float diffuseG[] = {0.5f, 0.7f, 0.6f, 1.0f};
  float ambientG[] = {0.2f, 0.3f, 0.1f, 1.0f};
	float specularG[] = {0.1f, 0.1f, 0.1f, 1.0f};
	float highlightG = 5.0;
	glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuseG);
	glMaterialfv(GL_FRONT,GL_AMBIENT,ambientG);
	glMaterialfv(GL_FRONT,GL_SPECULAR,specularG);
	glMaterialf(GL_FRONT,GL_SHININESS,highlightG);

	drawPlateY(50.0);
  glPopMatrix();
}

void drawPet()
{
  glPushMatrix();
  glTranslatef(obj.pos[0], obj.pos[1], obj.pos[2]);
  glRotatef(obj.angle[2], 0.0, 0.0, 1.0);//z]
  glRotatef(obj.angle[1], 0.0, 1.0, 0.0);//y]
  glRotatef(obj.angle[0], 1.0, 0.0, 0.0);//x]
  glScalef(obj.scale[0], obj.scale[1], obj.scale[2]);
  pet.draw(frameCount);
	glPopMatrix();
}
void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎w
  glMatrixMode(GL_PROJECTION);
  //vWFNVs̏
  glLoadIdentity();
  //es̐ݒieϊj
  gluPerspective(view.fovY, (double)w/(double)h, view.nearZ, view.farZ);
	//fr[s̐錾
  glMatrixMode(GL_MODELVIEW);
  //fr[s̏
  glLoadIdentity();
  //_ݒir[COϊj
  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, 1.0, 0.0);
  //\EBhẼTCY
  width = w;
  height = h;
}

void setLight(void)
{
//  float lightAmbient0[] = {0.5, 0.5, 0.5, 1.0}; //
  float lightAmbient0[] = {1.0, 1.0, 1.0, 1.0}; //
  float lightDiffuse0[] = {1.0, 1.0, 1.0, 1.0}; //gU
  float lightSpecular0[] = {1.0, 1.0, 1.0, 1.0};//ʌ
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightAmbient0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightDiffuse0);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightSpecular0);
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);
}
void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'r':
	  sKey = ROTATE;
	  break;
  case 's':
	  sKey = SCALE;
	  break;
  case 't':
	  sKey = TRANSLATE;
	  break;
  case 'R'://resetilɖ߂)
		obj = obj0;
	  view = view0;
	  viewPos();
	  break;
  case 'l':
	  sKey = LIGHT;
	  break;
  case 'w':
	  if(flagWireframe) flagWireframe = false;
	  else if(!flagWireframe) flagWireframe = true;
	  break;
	case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(0, 0, width, height, GL_RGB, GL_UNSIGNED_BYTE, imageOut);
		saveBitmap24(width, height, imageOut, FILENAME_OUT); 
	  break;
  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
  if(sKey == TRANSLATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  obj.pos[0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://-x
		  obj.pos[0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) obj.pos[1] += 0.1;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.pos[2] -= 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) obj.pos[1] -= 0.1;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.pos[2] += 0.1; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == ROTATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x]
		  obj.angle[0] += 10.0;
		  break;
	  case GLUT_KEY_LEFT://-x]
		  obj.angle[0] -= 10.0;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) obj.angle[1] += 10;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.angle[2] += 10; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) obj.angle[1] -= 10;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.angle[2] -= 10; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == SCALE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://xg
		  obj.scale[0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://xk
		  obj.scale[0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) obj.scale[1] += 0.1;//yg
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.scale[2] += 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) obj.scale[1] -= 0.1;//yk
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.scale[2] -= 0.1; //z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == LIGHT)
  {
		float d = 1.0;
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  lightPos[0] += d;
		  break;
	  case GLUT_KEY_LEFT:
		  lightPos[0] -= d;//-x
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) lightPos[1] += d;//y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] -= d;//z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) lightPos[1] -= d;//-y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] += d;//-z
		  break;
	  default:
		  break;
	  }
  }
	if(key == GLUT_KEY_F1) 
	{
		actionMode ++;
		if(actionMode == 2) actionMode = 0;
		init();
	}

}

//ȉ̂R̊֐̓}EXɂ鎋_̕ύXɕKv
void mouse(int button, int state, int x, int y)
{
  double pp = M_PI / 180.0;

  if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
  {
	  xStart = x; yStart = y;
	  flagMouse = true;
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist -= 0.5; //߂Â
	  }
  }
  else if(button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
  {
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist += 0.5; //
	  }
	  else if(( x < width/4 || x > 3*width/4) && (y > height/4 && y < 3*height/4))//pan
	  {
		  if(x < width/4 ) view.phi -= 1.0;
		  else view.phi += 1.0;
		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.phi) * cos(pp * view.theta);
		  view.cnt[0] = view.pos[0] - view.dist * sin(pp * view.phi) * cos(pp * view.theta);
	  }
	  else if((x > width/4 && x < 3*width/4) && (y < height/4 || y > 3*height/4))//tilt
	  {
		  if( y < height/4)
			  view.theta += 1.0; 
		  else
			  view.theta -= 1.0;

		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.theta) * cos(pp * view.phi);
		  view.cnt[0] = view.pos[0] - view.dist * cos(pp * view.theta) * sin(pp * view.phi);
		  view.cnt[1] = view.pos[1] - view.dist * sin(pp * view.theta);
	  }
	  else if(x < width/8 && y > 7*height/8) view.fovY -= 1.0;//zoom in
	  else if(x > 7*width/8 && y > 7*height/8) view.fovY += 1.0;//zoom out
  }
  else flagMouse = false;
  if(state == GLUT_DOWN) viewPos();
}

void motion(int x, int y)
{
  if(!flagMouse) return;
  if(cos(M_PI * view.theta /180.0) >= 0.0)
	view.phi -= 0.5 * (float)(x - xStart) ;//tumble
  else
	view.phi += 0.5 * (float)(x - xStart) ;//tumble

  view.theta += 0.05 * (float)(y - yStart) ;//crane

  viewPos();
  xStart = x;
  yStart = y;
}

void viewPos(void)
{
  double pp = M_PI / 180.0;
  view.pos[2] = view.cnt[2] + view.dist * cos(pp * view.theta) * cos(pp * view.phi);//z
  view.pos[0] = view.cnt[0] + view.dist * cos(pp * view.theta) * sin(pp * view.phi);//x
  view.pos[1] = view.cnt[1] + view.dist * sin(pp * view.theta);//y
  //printf("view.posX=%f, view.posY=%f, view.posZ=%f \n", view.pos[0], view.pos[1], view.pos[2]);
  //printf("cntX=%f, cntY=%f, cntZ=%f \n", view.cnt[0], view.cnt[1], view.cnt[2]);
  //printf("phi=%f, theta=%f, fovY=%f \n", view.phi, view.theta, view.fovY);
	resize(width, height);
}

//e`ɕKv
//------------------------------------------------------------------------
void CalcShadowMat(float* mat, CVector pos)
{
  float ex, ey, ez;//̕
  float a, b, c, d;//̖ʂ̃p[^
  float s; //objectS܂ł̋
  float x, y, z;

  x = lightPos[0] - pos.x;
  y = lightPos[1] - pos.y;
  z = lightPos[2] - pos.z;

  //̕xNg
  s = sqrt(x * x + y * y + z * z);
  ex = x / s;
  ey = y / s;
  ez = z / s;

  //tA̕xNg(j
  a = 0.0;
  b = 1.0;
  c = 0.0;
  d = -0.01; //tAƉe̊h
	//shadow matrix
  mat[0] = b * ey + c * ez;
  mat[1] = -a * ey;
  mat[2] = -a * ez;
  mat[3] = 0.0;
  mat[4] = -b * ex;
  mat[5] = a * ex + c * ez;
  mat[6] = -b * ez;
  mat[7] = 0.0;
  mat[8] = -c * ex;
  mat[9] = -c * ey;
  mat[10] = a * ex + b * ey;
  mat[11] = 0.0;
  mat[12] = -d * ex;
  mat[13] = -d * ey;
  mat[14] = -d * ez;
  mat[15] = a * ex + b * ey + c * ez;
}

//-----------------------------------------------------------------------------
void drawShadow()
{
  //vZ͕sɑ΂e
  //޼ުĂƂɌ̕ςA^Iɓ_ɑ΂e
  float mat[16]; //es̗vf

  pet.flagShadow = true;
	tree[0].flagShadow = true;
	tree[1].flagShadow = true;
	glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

	glDepthMask(GL_FALSE);
  //e̕`
  CalcShadowMat(mat, pet.vPos);
  glPushMatrix();
	  glMultMatrixf(mat);//}gNX̏Z
	  drawPet();
  glPopMatrix();
	for(int i = 0; i < 2; i++)
	{
  CalcShadowMat(mat, tree[i].vPos);
  glPushMatrix();
	  glMultMatrixf(mat);//}gNX̏Z
	  tree[i].draw();
  glPopMatrix();
	}

  //e̕`I
  glDepthMask(GL_TRUE);
  glDisable(GL_BLEND);
  pet.flagShadow = false;
	tree[0].flagShadow = false;
	tree[1].flagShadow = false;
}


