//myGrass1.h
//zIȑ
//y㉺

//ő
#define MAX_STALK 10//s
#define MAX_LEAF  4//es番򂷂ť
/*
double random(double minV, double maxV)
{//minV`maxV̈l
	return( (maxV - minV) * (double)rand() / (double)RAND_MAX ) + minV;
}
*/
class CmyGrass1
{
public:
	CmyGrass1(void);
	~CmyGrass1(void) { };
	void create();
	void draw();
	//oϐ
	CVector vPos;//is̉[ʒuj
	float angle;//y]
	//s
	int numRepeatStalk ;//㐔
	float lenStalk0;//ŉ[̒(3̒ClinkP1/3)
	float radStalk0;//ŉ[̔a
	float rateStalk;//(linkPj
	//t
	int numLeaf;//1̌s番ť
	float beta0 ;  //ʂ̕Ίp
	float length0; //
	float width0;  //
	//float rate   ; //
	float time;//oߎ

private:
	//o֐
	void drawLeaf(int noK, int noJ);
	//oϐ
	//s
	CVector vAxisStalk[MAX_STALK];
	float angStalk[MAX_STALK];//]p
	float lenStalk[MAX_STALK];//
	float radStalk[MAX_STALK];//a
	float ampStalk[MAX_STALK];//敗U̐Uipxj
	float periodStalk[MAX_STALK];//敗U̎
	float phaseStalk[MAX_STALK];//敗Üʑ

	//t
	float beta[MAX_STALK][MAX_LEAF]; //ʂ̕Ίpix]j
	float gamma[MAX_STALK][MAX_LEAF]; //s}ꂷt̉]piy]j
	float lengthLeaf[MAX_STALK][MAX_LEAF];//zTCY
	float widthLeaf[MAX_STALK][MAX_LEAF];//xTCY
	float amp[MAX_STALK][MAX_LEAF];//敗U̐Uipxj
	float period[MAX_STALK][MAX_LEAF];//敗U̎
	float phase[MAX_STALK][MAX_LEAF];//敗Üʑ

};
//----------------------------------------------------------------
CmyGrass1::CmyGrass1()
{
	//s
	numRepeatStalk = 5;
	angle = random(-45.0, 45.0);
	rateStalk = 0.9 + random(-0.02, 0.02);
	lenStalk0 = 0.2 + random(-0.1, 0.1);
	radStalk0 = 0.02 + random(-0.01, 0.01);
	for(int k = 0; k < numRepeatStalk; k++)
	{
		vAxisStalk[k]   = CVector(0.0, 0.0, 1.0);
		angStalk[k] = random(-3.0, 3.0);
	}
	
	//t
	numLeaf = 3;
	beta0  =  20.0 + random(-10.0, 10.0);
	length0 = 0.3 + random(-0.05, 0.05);
	width0 =  0.3 + random(-0.05, 0.05);
}
//-----------------------------------------------------------------------------
void CmyGrass1::create()
{
	int j, k;

	//s
	lenStalk[0] = lenStalk0;
	radStalk[0] = radStalk0;
	ampStalk[0]    = random(-1.0, 1.0);
	periodStalk[0] = 2.0 + random(-0.1, 0.1);
	phaseStalk[0]  = random(-10.0, 10.0);
	for(k = 1; k < numRepeatStalk; k++)
	{
		lenStalk[k]    = lenStalk[k-1] * rateStalk ;
		radStalk[k]    = radStalk[k-1] * rateStalk ;
		ampStalk[k]    = 0.5 * (2.0 + (float)k) + random(-2.0, 2.0);
		periodStalk[k] = 2.0 + random(-0.1, 0.1);
		phaseStalk[k]  = random(-10.0, 10.0);
	}

	//t
	float len0 = length0;//
	float wid0 = width0;//
	float len, wid;

	//t̃f[^
	for(k = 0; k < numRepeatStalk; k++)
	{
		len0 *= rateStalk * (1.0 + random(-0.05, 0.05));
		wid0 *= rateStalk * (1.0 + random(-0.05, 0.05));
		for(j = 0; j < numLeaf; j++)
		{
			len = len0;
			wid = wid0;
			lengthLeaf[k][j] = len;
			widthLeaf[k][j] = wid;
			beta[k][j] = beta0 + random(-10.0, 10.0);
			gamma[k][j] = (360.0 / (float)numLeaf) * float(j) + random(-20.0, 20.0) ;
			amp[k][j]        = 3.0 + random(-0.1, 0.1);
			period[k][j]     = 2.0 + random(-0.1, 0.1);
			phase[k][j]      = random(-10.0, 10.0);
//printf("k=%d, j=%d \n",k, j);
		}//j
	}//k
}

//-----------------------------------------------------------------------------
void CmyGrass1::draw()
{
	float diffuse[] = {0.1f, 0.4f, 0.2f, 1.0f};
  float ambient[] = {0.2f, 0.5f, 0.3f, 1.0f};
	float specular[] = {0.1f, 0.1f, 0.1f, 1.0f};
	float highlight = 10;

	int j, k;

	//S
	glPushMatrix();
	glTranslatef(vPos.x, vPos.y, vPos.z);
	glRotatef(angle, 0.0, 1.0, 0.0);
	//s
	for(k = 0; k < numRepeatStalk; k++)
	{
		glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
		glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
		glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
		glMaterialf(GL_FRONT,GL_SHININESS,highlight);

		float amp0 = ampStalk[k];
		float period0 = periodStalk[k];
		float phase0 = phaseStalk[k];
		float ang = amp0 * sin(2.0 * M_PI * time / period0 + phase0);
//printf("time = %f ang = %f period=%f \n", time,ang,  period0);
		glRotatef(angStalk[k] + ang, vAxisStalk[k].x, vAxisStalk[k].y, vAxisStalk[k].z);
		glPushMatrix();
			glScalef(radStalk[k], lenStalk[k], radStalk[k]);
			glTranslatef(0.0, 0.5, 0.0);
			drawCylinderY(1.0, rateStalk, 1.1, 6, 2);
		glPopMatrix();
		glTranslatef(0.0, lenStalk[k], 0.0);

		//t
		for(j = 0; j < numLeaf; j++) 
		{
//printf("k=%d, j=%d \n",k, j);
			glPushMatrix();
				glRotatef(gamma[k][j], 0.0, 1.0, 0.0);
				drawLeaf(k, j) ;
			glPopMatrix();
		}
	}
	glPopMatrix();
}

void CmyGrass1::drawLeaf(int noK, int noJ)
{
	float diffuse[] = {0.3f, 0.3f, 0.3f, 1.0f};
  float ambient[] = {0.7f, 0.7f, 0.7f, 1.0f};
	float specular[] = {0.3f, 0.3f, 0.3f, 1.0f};
	float highlight = 20.0;
	glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
	glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
	glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
	glMaterialf(GL_FRONT,GL_SHININESS,highlight);

	float amp0 = amp[noK][noJ];
	float period0 = period[noK][noJ];
	float phase0 = phase[noK][noJ];
	float ang = amp0 * sin(2.0 * M_PI * time / period0 + phase0);
	glPushMatrix();
		glRotatef(beta[noK][noJ] + ang, -1.0, 0.0, 0.0);
		glRotatef(90.0 + ang, 0.0, 0.0, 1.0);
		glScalef(widthLeaf[noK][noJ], 1.0, lengthLeaf[noK][noJ]);
		glTranslatef(0.0, 0.0, 0.5);
		drawPlateY(1.0);
		//drawTexPlateY(1.0, 1, 1);
	glPopMatrix();
}


