/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

A[gAj[V
3DAj[Vɑ΂ŕpltB^
OpenGL{GLSL

*/

#define FILENAME_IN0 "../../bmp256/ground1.bmp"
#define FILENAME_IN1 "../../bmp256/grain1.bmp"
#define FILENAME_IN2 "../../bmp256/leaf22.bmp"

#define FILENAME_OUT "file0.bmp"

#include <windows.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include <math.h>
#include "../../myGlsl.h"
#include "../../myMath3.h"
#include "../../myPrimitive3.h"
#include "../../myTexture3.h"
#include "../../bmpLoadSave.h"
#include "myTree1.h"
#include "myGrass1.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void drawPlate();
void drawTree();
void drawGrass();
void drawGround();
void drawPet();
void resize(int w, int h);
void resizeOrtho(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void setLight();
void viewPos();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void setTextureGround();
void setTextureGrain();
void setTextureLeaf();
void setFramebuffer();
void setTextureFBO();

CmyTree1 tree[2];

//摜f[^̃TCY
int imgWidth, imgHeight;
//摜f[^z
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageOut[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];

//VF[_vO
GLuint program1, program2, program3;
//texture object
GLuint texName[4];
//renderbuffer object
GLuint rbName;
//framebuffer object
GLuint fbName;
//modal filter size
int size = 3;
float gamma = 1.0;
int nLevel = 8;

//쐬eNX`̃TCY
int imgWidth0  = 256;
int imgHeight0 = 256;
//\摜̍n_
int px0 = 10;
int py0 = 10;
int qx0, qy0;//

//
float lightPos[]  = {0.0, 20.0, 20.0, 1.0};//ʒu
float lightPos0[] = {0.0, 20.0, 20.0, 1.0};//ʒu(l)

//JƎ̐
struct View
{
  //J
	float pos[3];//ʒui_j
	float cnt[3];//_
  float dist;  //_王_܂ł̋
  float theta; //piʂƂ̕Ίpj
  float phi;   //ʊp
  //̐
  float fovY;  //p
  float nearZ; //ONbv(ߕ)
  float farZ;  //Nbv()
};
//l
View view = { 
	0.0, 0.0, 0.0,//pos(̐ݒl)
  0.0, 0.7, 0.0,//cnt 
	6.0, 0.0, 0.0,//dist, theta, phi
	40.0, 0.1, 100.0//fovY,nearZ, farZ
};
View view0 = view;//lۑ

//Window̃TCY
int width  = 300;
int height = 300;
//AtBϊ
enum SELECT_KEY {LIGHT};
SELECT_KEY sKey = LIGHT;
//}EX
int xStart, yStart;
bool flagMouse = false;
//wvL[tO
bool flagHelp = false;
//pet animation
#include "../../myPet.h"
CmyPet pet ;
int frameCount = 0;
int actionMode = 0;

//oߎ
double curTime, lastTime, elapseTime1, elapseTime2;
int fps = 0;//frame per sec

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_ArtAnimation");
  //EBhẼTCYύX
  glutReshapeFunc(resizeOrtho);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
	glewInit();//glew.hɎĂ
  init();
	initGlsl(&program1, "tree.vert", "tree.frag");
  initGlsl(&program2, "pet.vert", "pet.frag");
	initGlsl(&program3, "modal.vert", "modal.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteTextures(4, texName);
	glDeleteFramebuffersEXT(1, &fbName);
	glDeleteRenderbuffersEXT(1, &fbName);
	glDeleteProgram(program1);
	glDeleteProgram(program2);
  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  viewPos();//_߂
  setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);
  glShadeModel(GL_SMOOTH);

	glGenTextures(4, texName);//eNX`IuWFNg̖Ot
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN0);
  setTextureGround();
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN1);
	setTextureGrain();
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN2);
	setTextureLeaf();
	setTextureFBO();
	setFramebuffer();

	//
	tree[0].vPos = CVector( 1.0, 0.0, 1.0);
	tree[1].vPos = CVector(-1.0, 0.0, 1.0);
	tree[0].create();
	tree[1].create();

	//Ԋ֌W
  lastTime = timeGetTime();
  fps = 0;
  elapseTime1 = 0.0;//1secԈȓ̌oߎ
  elapseTime2 = 0.0; //init()̑oߎ

  //pet robot Aj[V
  pet.unitTime = 0.05;//Pt[̎ԁiŏ͉̒lj
  //t[f[^쐬
  pet.numFrame0 = 0;
  frameCount = 0;
  if(actionMode == 0)
  {
		pet.vPos.x = 0.0;
		pet.vPos.z = 0.0;
		pet.vAng.y = 0.0;
		pet.walk(2.0, 0.2, 0.5);
		pet.turn(90.0, 1.0);
		pet.walk(1.5, 0.2, 0.5);
		pet.turn(90.0, 1.0);
		pet.walk(2.0, 0.2, 0.5);
		pet.turn(90.0, 1.0);
		pet.walk(1.5, 0.2, 0.5);
		pet.turn(90.0, 1.0);
  }
  else
  {
		pet.walk(2, 0.2, 0.5);
		pet.turn(90.0, 1.0);
		pet.stand(3.0);
		pet.swingTail(5, 1.0);
		pet.wait(1.0);
		pet.initPose(2.0);
  }
	printf("numFrame0=%d \n", pet.numFrame0);

  printf("}EX/L[̐ɂ'H'L[vbV \n");
}

void setTextureGround()
{
  //eNX`IuWFNg̍쐬
  glBindTexture(GL_TEXTURE_2D, texName[0]);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̎w 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  //F̒
//  glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
  glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setTextureGrain()
{
  //eNX`IuWFNg̍쐬
  glBindTexture(GL_TEXTURE_2D, texName[1]);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̎w 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setTextureLeaf()
{
  //eNX`IuWFNg̍쐬
  glBindTexture(GL_TEXTURE_2D, texName[2]);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̎w 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}


void setFramebuffer(void)
{
	//renderbuffer object ̐
	glGenRenderbuffersEXT( 1, &rbName );
	glBindRenderbufferEXT( GL_RENDERBUFFER_EXT, rbName );
	
	glRenderbufferStorageEXT( GL_RENDERBUFFER_EXT, GL_DEPTH_COMPONENT, imgWidth0, imgHeight0 );
  //framebuffer object ̐
	glGenFramebuffersEXT( 1, &fbName );
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbName );
  //textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT,
	                                           GL_TEXTURE_2D, texName[3], 0 );
	//renderbufferframebuffer objectɌт
	glFramebufferRenderbufferEXT( GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT,
	                                         GL_RENDERBUFFER_EXT, rbName );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void setTextureFBO()
{
  glBindTexture(GL_TEXTURE_2D, texName[3]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth0,imgHeight0,0,GL_RGB,GL_UNSIGNED_BYTE,0);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void display(void)
{
  //Ԍv
	curTime = timeGetTime();
  float dt = (float)(curTime - lastTime) * 0.001;//secɕϊ
  elapseTime1 += dt;
  elapseTime2 += dt;
  fps ++;
  if(elapseTime1 >= 1.0)
  {
		printf("fps = %d \n", fps);
//		printf("elapseTime2 = %f \n", elapseTime2);
		elapseTime1 = 0.0;
		fps = 0;
  }
	lastTime = curTime;

	//step1:texture̍쐬
	//setLight();
  glClearColor( 0.6, 0.7, 0.8, 1.0 );//wiF
  //framebuffer objectL
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbName );

	glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);//ground
	glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, texName[1]);//tree grain
	glActiveTexture(GL_TEXTURE2);
  glBindTexture(GL_TEXTURE_2D, texName[2]);//tree leaf

	//J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	resize(imgWidth0, imgHeight0);

	if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, 1.0, 0.0);
  else
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, -1.0, 0.0);

  //'L'ʒu
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

   //`
  glUseProgram(program1);
	//n
	GLint imageLoc = glGetUniformLocation(program1, "image");
	glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	drawGround();
 	//
	tree[0].imageLoc = imageLoc;
	tree[1].imageLoc = imageLoc;
	drawTree();
  glUseProgram(0);
  glUseProgram(program2);
  //`
	drawPet();
  glUseProgram(0);

 //framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );

	//step2:ʏrendering
  glClearColor(0.2, 0.2, 0.3, 1.0);//wiF
	//J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	resizeOrtho(width, height);

  //`
	glActiveTexture(GL_TEXTURE3);
  glBindTexture(GL_TEXTURE_2D, texName[3]);
  glUseProgram(program3);
  GLint imageLoc2 = glGetUniformLocation(program3, "image");
  glUniform1i(imageLoc2, 3);//GL_TEXTURE3Kp
	GLint imgWidthLoc = glGetUniformLocation(program3, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth0);
	GLint imgHeightLoc = glGetUniformLocation(program3, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight0);
	GLint sizeLoc = glGetUniformLocation(program3, "size");
	glUniform1i(sizeLoc, size);
	GLint gammaLoc = glGetUniformLocation(program3, "gamma");
	glUniform1f(gammaLoc, gamma);
	GLint nLevelLoc = glGetUniformLocation(program3, "nLevel");
	glUniform1i(nLevelLoc, nLevel);

	//̈ʒu
	qx0 = px0;
  qy0 = height - imgHeight0- py0;
	if(qy0 < 0) qy0 = 0;
	glPushMatrix();
  glTranslatef(px0, qy0, 0.0);
  drawPlate();
	glPopMatrix();
  glUseProgram(0);
  glBindTexture(GL_TEXTURE_2D, 0);

  frameCount++;

	if(flagHelp)
  {
		printf("ړ \n");
		printf("@,Fx \n");
		printf("@,Fy \n");
		printf("@[Shift]{,Fz \n");
		printf("@'L'Aʒüړ \n");
		printf("}EXŎ_ύX \n");
		printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
		printf("  panFщEE{^NbNŒ_Eɕω \n");
		printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
		printf("  tumbleFEɃhbOƎ_Eɕω \n");
		printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
		printf("  zoomFE{^NbNŃY[C \n");
		printf("        EE{^NbNŃY[AEg \n");
		printf("[Shift]+'R'ŃZbg \n");
		flagHelp = false;
  }
  //I
  glutSwapBuffers();
}

void drawTree()
{
	for(int k = 0; k < 2; k++) 
	{
		tree[k].time = elapseTime2;
		tree[k].draw();
	}
}

void drawGround()
{
	float diffuse[] = {0.8f, 0.8f, 0.8f, 1.0f};
  float ambient[] = {0.4f, 0.4f, 0.4f, 1.0f};
	float specular[] = {0.1f, 0.1f, 0.1f, 1.0f};
	float highlight = 20.0;
	glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
	glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
	glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
	glMaterialf(GL_FRONT,GL_SHININESS,highlight);

	drawTexPlateY(20.0, 5, 5);
}

void drawPlate()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth0, 0);
		glVertex2i(imgWidth0, imgHeight0);
		glVertex2i(0, imgHeight0);
	glEnd();
}

void drawPet()
{
  glPushMatrix();
/*
  glTranslatef(obj.pos[0], obj.pos[1], obj.pos[2]);
  glRotatef(obj.angle[2], 0.0, 0.0, 1.0);//z]
  glRotatef(obj.angle[1], 0.0, 1.0, 0.0);//y]
  glRotatef(obj.angle[0], 1.0, 0.0, 0.0);//x]
*/
//  glScalef(2.0, 2.0, 2.0);

		pet.draw(frameCount);
	glPopMatrix();
}

void resize(int w, int h)
{//eNX`쐬
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎w
  glMatrixMode(GL_PROJECTION);
  //vWFNVs̏
  glLoadIdentity();
  //es̐ݒieϊj
  gluPerspective(view.fovY, (double)w/(double)h, view.nearZ, view.farZ);
	//fr[s̐錾
  glMatrixMode(GL_MODELVIEW);
  //fr[s̏
  glLoadIdentity();
  //_ݒir[COϊj
//  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, 1.0, 0.0);
  //\EBhẼTCY
//  width = w;
//  height = h;
}

void resizeOrtho(int w, int h)
{//쐬eNX`\Ƃ
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒieϊj
	gluOrtho2D(0.0, w, 0.0, h);
	//fr[s̐錾
  glMatrixMode(GL_MODELVIEW);
  //fr[s̏
  glLoadIdentity();

	width = w;
	height = h;
}


void setLight(void)
{
  float lightAmbient0[] = {1.0, 1.0, 1.0, 1.0}; //
  float lightDiffuse0[] = {1.0, 1.0, 1.0, 1.0}; //gU
  float lightSpecular0[] = {1.0, 1.0, 1.0, 1.0};//ʌ
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightAmbient0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightDiffuse0);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightSpecular0);
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);
}
void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'R'://resetilɖ߂)
	  view = view0;
	  viewPos();
		for(int i = 0; i < 3; i++) lightPos[i] = lightPos0[i];
	  break;
  case 'l':
	  sKey = LIGHT;
	  break;
  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
	  break;
  case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(px0, qy0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, imageOut);
		saveBitmap24(imgWidth, imgHeight, imageOut, FILENAME_OUT); 
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
  if(sKey == LIGHT)
  {
		float d = 1.0;
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  lightPos[0] += d;
		  break;
	  case GLUT_KEY_LEFT:
		  lightPos[0] -= d;//-x
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) lightPos[1] += d;//y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] -= d;//z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) lightPos[1] -= d;//-y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] += d;//-z
		  break;
	  default:
		  break;
	  }
  }

	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) size += 2;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	size -= 2;  
		if(size < 1) size = 1;
		if(size > 9) size = 9;
		printf("TCYsize = %d \n", size);
	}	

	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) gamma += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	gamma -= 0.05;  
		if(gamma < 0.1) gamma = 0.1;
		printf("K}lgamma = %f \n", gamma);
	}	

	if(key == GLUT_KEY_F3) 
	{//ő32K
	  if(glutGetModifiers() == 0) nLevel += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	nLevel -= 1;  
		if(nLevel < 2) nLevel = 2;
		else if(nLevel == 17) nLevel = 32;
		else if(nLevel > 32) nLevel = 32;
		else if(nLevel == 31) nLevel = 16;
		printf("KnLevel = %d \n", nLevel);
	}
	if(key == GLUT_KEY_F4) 
	{
		actionMode ++;
		if(actionMode == 2) actionMode = 0;
		init();
	}

}

//ȉ̂R̊֐̓}EXɂ鎋_̕ύXɕKv
void mouse(int button, int state, int x, int y)
{
  double pp = M_PI / 180.0;

  if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
  {
	  xStart = x; yStart = y;
	  flagMouse = true;
	  if(x > imgWidth0/4 && x < 3*imgWidth0/4 && y > imgHeight0/4 && y < 3*imgHeight0/4)//dolly
	  {
		  view.dist -= 0.5; //߂Â
	  }
  }
  else if(button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
  {
	  if(x > imgWidth0/4 && x < 3*imgWidth0/4 && y > imgHeight0/4 && y < 3*imgHeight0/4)//dolly
	  {
		  view.dist += 0.5; //
	  }
	  else if(( x < imgWidth0/4 || x > 3*width/4) && (y > imgHeight0/4 && y < 3*imgHeight0/4))//pan
	  {
		  if(x < imgWidth0/4 ) view.phi -= 1.0;
		  else view.phi += 1.0;
		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.phi) * cos(pp * view.theta);
		  view.cnt[0] = view.pos[0] - view.dist * sin(pp * view.phi) * cos(pp * view.theta);
	  }
	  else if((x > imgWidth0/4 && x < 3*imgWidth0/4) && (y < imgHeight0/4 || y > 3*imgHeight0/4))//tilt
	  {
		  if( y < imgHeight0/4)
			  view.theta += 1.0; 
		  else
			  view.theta -= 1.0;

		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.theta) * cos(pp * view.phi);
		  view.cnt[0] = view.pos[0] - view.dist * cos(pp * view.theta) * sin(pp * view.phi);
		  view.cnt[1] = view.pos[1] - view.dist * sin(pp * view.theta);
	  }
	  else if(x < imgWidth0/8 && y > 7*imgHeight0/8) view.fovY -= 1.0;//zoom in
	  else if(x > 7*imgWidth0/8 && y > 7*imgHeight0/8) view.fovY += 1.0;//zoom out
  }
  else flagMouse = false;
  if(state == GLUT_DOWN) viewPos();
}

void motion(int x, int y)
{
  if(!flagMouse) return;
  if(cos(M_PI * view.theta /180.0) >= 0.0)
	view.phi -= 0.5 * (float)(x - xStart) ;//tumble
  else
	view.phi += 0.5 * (float)(x - xStart) ;//tumble

  view.theta += 0.5 * (float)(y - yStart) ;//crane

  viewPos();
  xStart = x;
  yStart = y;
}

void viewPos(void)
{
  double pp = M_PI / 180.0;
  view.pos[2] = view.cnt[2] + view.dist * cos(pp * view.theta) * cos(pp * view.phi);//z
  view.pos[0] = view.cnt[0] + view.dist * cos(pp * view.theta) * sin(pp * view.phi);//x
  view.pos[1] = view.cnt[1] + view.dist * sin(pp * view.theta);//y
  //printf("view.posX=%f, view.posY=%f, view.posZ=%f \n", view.pos[0], view.pos[1], view.pos[2]);
  //printf("cntX=%f, cntY=%f, cntZ=%f \n", view.cnt[0], view.cnt[1], view.cnt[2]);
  //printf("phi=%f, theta=%f, fovY=%f \n", view.phi, view.theta, view.fovY);
//	resize(width, height);
	resize(imgWidth0, imgHeight0);
//	resizeOrtho(width, height);
}

