
uniform float nRatio;
uniform mat4 ViewTranspose;//r[ϊ̃fr[s(]uj
uniform sampler2D imageRandom;
uniform float ampNoise;
uniform int numGrid;
varying vec3 P;
varying vec3 N;
varying vec4 Refract;
float dd = 1.0 / float(numGrid);

void main(void)
{
  vec2 texCoord = gl_Vertex.xy + vec2(0.5, 0.5) ;
  //s,tWɂ鍂}bv̔	
	float deltaS = texture2D(imageRandom, texCoord + vec2(dd, 0.0)).r - texture2D(imageRandom, texCoord - vec2(dd, 0.0)).r;
	float deltaT = texture2D(imageRandom, texCoord + vec2(0.0, dd)).r - texture2D(imageRandom, texCoord - vec2(0.0, dd)).r;
	deltaS *= ampNoise;
	deltaT *= ampNoise;
	//s,tW̒PʃxNg
	vec3 As = vec3(1.0, 0.0, 0.0);//x
	vec3 At = vec3(0.0, 1.0, 0.0);//y

  P = (gl_ModelViewMatrix * gl_Vertex).xyz;
  N = normalize(gl_NormalMatrix * gl_Normal);
  N -= As * deltaS + At * deltaT;
  //()xNg
  vec3 incident = normalize(P);
  //ܗ
  vec3 col = texture2D(imageRandom, texCoord).rgb;
	nRatio += (col.r - 0.5) * ampNoise ;
	//܃xNg
	vec3 refract0 = refract(incident, N, 1.0 / nRatio);
	//܃xNgɂeNX`W
  Refract = ViewTranspose * vec4(refract0, 1.0);
  //Refract = gl_TextureMatrix[0] * vec4(refract0, 1.0);
  gl_Position = ftransform();
}
