/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

L[u}bsOɂ܊}bsO
܂KXɗp
framebuffer object𗘗p
OpenGL+GLSL
*/
//#define FILENAME_IN "../../bmp/Px3.bmp"
#define FILENAME_IN "../../bmp/O.bmp"

//o͉摜t@C
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include <math.h>
#include "../../myPrimitive3.h"
#include "../../myGlsl.h"
#include "../../bmpLoadSave.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void draw();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void setLight();
void setCamera();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void setTexture();
void setCubeMap();
void initFramebuffer();
void makeImageRandom();
void setTextureRandom();

//ỸAtBϊpϐ
float pos[] = { 0.0, 0.0, 0.0 };  //objectSxyzW
float scale[] = { 1.0, 1.0, 0.1 };//傫({)
float angle[] = { 0.0, 0.0, 0.0 };//]px
//l
float pos0[] = { 0.0, 0.0, 0.0 };
float scale0[] = { 1.0, 1.0, 0.1 };
float angle0[] = { 0.0, 0.0, 0.0 };
//
float lightPos[]  = {0.0, 5.0, 5.0, 1.0}; //ʒu
float lightPos0[] = {0.0, 5.0, 5.0, 1.0};//ʒu(l)

//JƎ̐
struct View
{
  //J
	float pos[3];//ʒui_j
	float cnt[3];//_
  float dist;  //_王_܂ł̋
  float theta; //piʂƂ̕Ίpj
  float phi;   //ʊp
  //̐
  float fovY;  //p
  float nearZ; //ONbv(ߕ)
  float farZ;  //Nbv()
};
//l
View view = { 
	0.0, 0.0, 0.0,//pos
  0.0, 0.0, 0.0,//cnt 
	1.0, 0.0, 0.0,//dist, theta, phi
	60.0, 0.1, 20.0//fovY,nearZ, farZ
};
View view0 = view;//lۑ
//Window̃TCY
int width = 500;
int height = 500;
//AtBϊ
enum SELECT_KEY {ROTATE, SCALE, TRANSLATE, LIGHT};
SELECT_KEY sKey = TRANSLATE;
//}EX
int xStart, yStart;
bool flagMouse = false;
//wvL[tO
bool flagHelp = false;
//ʒuύXtO
bool flagLight = false;//ǉ
//ܲ԰ڰ<-->دސ؂ւtO
bool flagWireframe = false;//ǉ
float curTime, lastTime, elapseTime;
int frameCount = 0;
int fps = 0;
int numGrid = 100;
float transparency0 = 0.8;
float nRatio0 = 1.1;
float ampNoise = 0.3;
//texture map
int imgWidth, imgHeight;//摜̃TCY
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageRandom[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];

//cube map øp
#define TEX_WIDTH  512
#define TEX_HEIGHT 512
//FBO֘A
GLuint	texName[3];//texture object
GLuint	rbName;//renderbuffer
GLuint	fbName;//framebuffer

//eNX`[\
struct Target{
	GLenum name;//^[Qbg
	GLint x, y;//摜̈ʒu
	GLdouble cx, cy, cz;//_
	GLdouble ux, uy, uz;//AbvxNg
};

struct Target target[] = {
  { //E
    GL_TEXTURE_CUBE_MAP_POSITIVE_X,
    0, TEX_HEIGHT,
    1.0, 0.0, 0.0,
    0.0, -1.0, 0.0,
  },
  { 
	 //
	 GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
    0, 0,
    -1.0, 0.0, 0.0,
    0.0, -1.0, 0.0,
  },
  { //V
    GL_TEXTURE_CUBE_MAP_POSITIVE_Y,
    TEX_WIDTH, TEX_HEIGHT,
    0.0, 1.0, 0.0,
    0.0, 0.0, 1.0,
  },
  { 
		//
    GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
    TEX_WIDTH,0,
    0.0, -1.0, 0.0,
    0.0, 0.0, -1.0,
  },
  { //O
    GL_TEXTURE_CUBE_MAP_POSITIVE_Z,
    2*TEX_WIDTH, TEX_HEIGHT,
    0.0, 0.0, 1.0,
    0.0, -1.0, 0.0,
  },
  { //
    GL_TEXTURE_CUBE_MAP_NEGATIVE_Z,
    2*TEX_WIDTH, 0,
    0.0, 0.0, -1.0,
    0.0, -1.0, 0.0,
  }
};
//VF[_vO
GLuint program1, program2;


int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_CloudGlass");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
	glewInit();
  init();
	initFramebuffer();
  initGlsl(&program1, "texture.vert", "texture.frag");
  initGlsl(&program2, "refract.vert", "refract.frag");
	
  //Cxg[vɓ
  glutMainLoop();
	glDeleteTextures(3, texName);
	glDeleteRenderbuffersEXT(1, &rbName);
	glDeleteFramebuffersEXT(1, &fbName);
  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.2, 0.2, 0.6, 1.0);
 
  setCamera();//_߂
  setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);
  printf("}EX/L[̐ɂ'h'L[vbV \n");

	//J[摜̎擾
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
  //eNX`̐ݒ
	glGenTextures(3, texName);
	setTexture();
  setCubeMap();
	makeImageRandom();
	setTextureRandom();
}

void setTexture()
{
  glBindTexture(GL_TEXTURE_2D, texName[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);//NEAREST);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);//NEAREST);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setCubeMap()
{
  glBindTexture(GL_TEXTURE_CUBE_MAP, texName[1]);
  for(int i = 0; i < 6; i++)
	  glTexImage2D(target[i].name,0,GL_RGBA,TEX_WIDTH,TEX_HEIGHT,0,GL_RGBA,GL_UNSIGNED_BYTE, 0);

  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_WRAP_T,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_WRAP_R,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_CUBE_MAP, 0);
}

void setTextureRandom()
{
  glBindTexture(GL_TEXTURE_2D, texName[2]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_LUMINANCE,imgWidth,imgHeight,0,GL_LUMINANCE,GL_UNSIGNED_BYTE,imageRandom);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void initFramebuffer( void )
{
	//renderbuffer
	glGenRenderbuffersEXT( 1, &rbName );
	glBindRenderbufferEXT( GL_RENDERBUFFER_EXT, rbName );
	glRenderbufferStorageEXT( GL_RENDERBUFFER_EXT, GL_DEPTH_COMPONENT, TEX_WIDTH, TEX_HEIGHT );
  //framebuffer
	glGenFramebuffersEXT( 1, &fbName );
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbName );
	glFramebufferRenderbufferEXT( GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT,
								  GL_RENDERBUFFER_EXT, rbName );

	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

double random(double minV, double maxV)
{//minV`maxV̈l
	return( (maxV - minV) * (double)rand() / (double)RAND_MAX ) + minV;
}

void makeImageRandom()
{
	int i, j, k;
	
	for(j = 0; j < imgHeight; j++)
		for(i = 0; i < imgWidth; i++){
			k = i + j * imgWidth;
			imageRandom[k] = GLubyte(random(0.0, 255.0));
		}
}

void display(void)
{
	//texture unit  texture object ̊֘At
	glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);
	/*
	glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_CUBE_MAP, texName[1]);
	glActiveTexture(GL_TEXTURE2);
  glBindTexture(GL_TEXTURE_2D, texName[2]);
*/
	//step1:}bv̍쐬
	//IuWFNgS猩ŨV[쐬AeNX`ɓ]
	//framebuffer object L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbName );

  // ϊs̐ݒ (texture쐬j
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(90.0, 1.0, 0.1, 30.0);//p90
  
  // fr[ϊs̐ݒ 
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  // IuWFNg猩V[eNX`ɗp 
  for (int i = 0; i < 6; ++i) 
  {
    glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT,
                              target[i].name, texName[1], 0);
    glViewport(0, 0, TEX_WIDTH, TEX_HEIGHT);
		//J[obt@,fvXobt@̃NA
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glPushMatrix();
		gluLookAt(pos[0], pos[1], pos[2], 
		    pos[0]+target[i].cx, pos[1]+target[i].cy, pos[2]+target[i].cz,
				target[i].ux, target[i].uy, target[i].uz);
		glLightfv(GL_LIGHT0, GL_POSITION, lightPos);
		//texture̕`
		glUseProgram(program1);
		GLint imageLoc = glGetUniformLocation(program1, "image");
		glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
		GLint image2Loc = glGetUniformLocation(program1, "imageRandom");
		glUniform1i(image2Loc, 2);//GL_TEXTURE2Kp
		glTranslatef(0.0, 0.0, -5.0);
		glScalef(5.0, 5.0 * (float)imgHeight / (float)imgWidth, 1.0);
		drawGridPlate(1.0, 1.0, imgWidth, imgHeight);
		glPopMatrix();
		glUseProgram(0);
  }
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );

  //ʏ̕`惂[hɖ߂
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  resize(width, height);  
	//step2(SIuWFNg_Oj
	//texture unit  texture object ̊֘At
	glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_CUBE_MAP, texName[1]);
	glActiveTexture(GL_TEXTURE2);
  glBindTexture(GL_TEXTURE_2D, texName[2]);

	//texture unit  texture object ̊֘At
  // VF[_vO̓Kp 
  glUseProgram(program2);
  GLint tranLoc = glGetUniformLocation(program2, "transparency");
  glUniform1f(tranLoc, transparency0);
  GLint ratioLoc = glGetUniformLocation(program2, "nRatio");
  glUniform1f(ratioLoc, nRatio0);
	GLint image2Loc = glGetUniformLocation(program2, "imageRandom");
	glUniform1i(image2Loc, 2);//GL_TEXTURE2Kp
	GLint numGridLoc = glGetUniformLocation(program2, "numGrid");
	glUniform1i(numGridLoc, numGrid);

  float m[16] ;
  glGetFloatv(GL_MODELVIEW_MATRIX, m);
  GLint ViewTransLoc = glGetUniformLocation(program2, "ViewTranspose");
  glUniformMatrix4fv(ViewTransLoc, 1, GL_TRUE, m);
	GLint ampLoc = glGetUniformLocation(program2, "ampNoise");
	glUniform1f(ampLoc, ampNoise);

  //ݒ//'l'ʒu
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  if(flagWireframe)//'w'wireframesolid model؂ւ
  {
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
  }
  else glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

  //fragment shader̃jtH[ϐtex̃CfbNX擾
  GLint samplerLoc = glGetUniformLocation(program2, "sampler");
  glUniform1i(samplerLoc, 1);//GL_TEXTURE0Kp
  //(Y)̕`
  draw(); 
  // VF[_vO̓Kp	
  glUseProgram(0);

	//step3(w̕ʂtexture_Oj
	glUseProgram(program1);
	GLint imageLoc = glGetUniformLocation(program1, "image");
	glUniform1i(imageLoc, 0);//GL_TEXTURE0Kp
	image2Loc = glGetUniformLocation(program1, "imageRandom");
	glUniform1i(image2Loc, 2);//GL_TEXTURE2Kp
	
  glPushMatrix();
	glTranslatef(0.0, 0.0, -5.0);
	glScalef(5.0, 5.0 * (float)imgHeight / (float)imgWidth, 1.0);
	drawGridPlate(1.0, 1.0, imgWidth, imgHeight);
	glPopMatrix();
  // VF[_vO̓Kp	
  glUseProgram(0);

  curTime = timeGetTime();
  //1R}̏v
  float dt = (float)(curTime - lastTime) * 0.001;//sec
  lastTime = curTime;
  elapseTime += dt;
  fps ++;
  if(elapseTime >= 1.0)
  {
//  	printf("frame per sec = %d , dt = %f\n", fps, dt);
	  elapseTime = 0.0;
	  fps = 0;
  }
  frameCount++;

	if(flagHelp)
  {
		printf("L[ɂAtBϊ/ړ \n");
		printf("@,Fx \n");
		printf("@,Fy \n");
		printf("@[Shift]{,Fz \n");
		printf("@'r':] \n");
		printf("@'t':sړ \n");
		printf("@'s':ݸ \n");
		printf("@'l'Aʒüړ \n");
		printf("'w'ܲ԰ڰтƿدِ؂ւ \n");
		printf("}EXŎ_ύX \n");
		printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
		printf("  panFщEE{^NbNŒ_Eɕω \n");
		printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
		printf("  tumbleFEɃhbOƎ_Eɕω \n");
		printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
		printf("  zoomFE{^NbNŃY[C \n");
		printf("        EE{^NbNŃY[AEg \n");
		printf("[Shift]+'r'ŃZbg \n");
		printf("[F1]L[FܗnRatio0̕ύX \n");
		printf("[F2]L[Fߗtransparency0̕ύX \n");
		printf("[F3]L[FiqnumGrid̕ύX \n");
		printf("[F4]L[FGUampNoise̕ύX \n");
		flagHelp = false;
  }
  //I
  glutSwapBuffers();
}

void draw(void)
{
  float ambient[] = { 0.3, 0.3, 0.3, 1.0};
  float diffuse[] = { 0.7, 0.7, 0.7, 1.0};
  float specular[]= { 0.5, 0.5, 0.5, 1.0};

  glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
  glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
  glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
  glMaterialf(GL_FRONT,GL_SHININESS,100);

  glPushMatrix();
  glTranslatef(pos[0], pos[1], pos[2]);
  glRotatef(angle[2], 0.0, 0.0, 1.0);//z]
  glRotatef(angle[1], 0.0, 1.0, 0.0);//y]
  glRotatef(angle[0], 1.0, 0.0, 0.0);//x]
  glScalef(scale[0], scale[1], scale[2]);
//	glutSolidSphere(0.2, numGrid, numGrid);
//glutSolidTorus(0.2, 0.5, 20, 20);
//  glutSolidTeapot(0.2);
	drawGridPlate(1.0, (float)imgHeight / (float)imgWidth, numGrid, numGrid);
  glPopMatrix();
}


void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎w
  glMatrixMode(GL_PROJECTION);
  //vWFNVs̏
  glLoadIdentity();
  //es̐ݒieϊj
  gluPerspective(view.fovY, (double)w/(double)h, view.nearZ, view.farZ);
  glMatrixMode(GL_MODELVIEW);
  //fr[s̏
  glLoadIdentity();

  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, 1.0, 0.0);
  else
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, -1.0, 0.0);
 
 //\EBhẼTCY
  width = w;
  height = h;
}

void setLight()
{
  float lightAmbient0[] = {0.5, 0.1, 0.1, 1.0}; //
  float lightDiffuse0[] = {1.0, 0.2, 0.2, 1.0}; //gU
  float lightSpecular0[] = {0.5, 0.5, 0.5, 1.0};//ʌ
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightAmbient0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightDiffuse0);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightSpecular0);
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);
}
void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'r':
	  sKey = ROTATE;
	  break;
  case 's':
	  sKey = SCALE;
	  break;
  case 't':
	  sKey = TRANSLATE;
	  break;
  case 'R'://resetilɖ߂)
		for(int i = 0; i < 3; i++)
		{
			pos[i] = pos0[i]; scale[i] = scale0[i]; angle[i] = angle0[i];
			lightPos[i] = lightPos0[i];
		}
	  view = view0;
	  setCamera();
	  break;
  case 'l':
	  sKey = LIGHT;
	  break;
  case 'w':
	  if(flagWireframe) flagWireframe = false;
	  else if(!flagWireframe) flagWireframe = true;
	  break;
  case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(0, 0, width, height, GL_RGB, GL_UNSIGNED_BYTE, image);
		saveBitmap24(width, height, image, FILENAME_OUT); 
		loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	  break;
  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
  if(sKey == TRANSLATE)
  {
		float d = 0.05;
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  pos[0] += d;
		  break;
	  case GLUT_KEY_LEFT://-x
		  pos[0] -= d;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) pos[1] += d;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) pos[2] -= d; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) pos[1] -= d;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) pos[2] += d; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == ROTATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x]
		  angle[0] += 10.0;
		  break;
	  case GLUT_KEY_LEFT://-x]
		  angle[0] -= 10.0;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) angle[1] += 10;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) angle[2] += 10; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) angle[1] -= 10;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) angle[2] -= 10; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == SCALE)
  {
		float d = 0.05;
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://xg
		  scale[0] += d;
		  break;
	  case GLUT_KEY_LEFT://xk
		  scale[0] -= d;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) scale[1] += d;//yg
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) scale[2] += d; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) scale[1] -= d;//yk
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) scale[2] -= d; //z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == LIGHT)
  {
		float d = 0.5;
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  lightPos[0] += d;
		  break;
	  case GLUT_KEY_LEFT:
		  lightPos[0] -= d;//-x
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) lightPos[1] += d;//y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] -= d;//z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) lightPos[1] -= d;//-y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] += d;//-z
		  break;
	  default:
		  break;
	  }
  }
	if(key == GLUT_KEY_F1) 
	{
		if(glutGetModifiers() == 0) nRatio0 += 0.02;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	nRatio0 -= 0.02;
		printf("ܗ= %f \n", nRatio0);		
	}	
	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) transparency0 += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	transparency0 -= 0.1;  
		if(transparency0 < 0.0) transparency0 = 0.0;
		if(transparency0 > 1.0) transparency0 = 1.0;
		printf("x= %f \n", transparency0);
	}	
	if(key == GLUT_KEY_F3) 
	{
	  if(glutGetModifiers() == 0) numGrid += 10;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	numGrid -= 10; 
		if(numGrid < 10) numGrid = 10;
	  printf("numGrid = %d \n", numGrid);
	}	
	if(key == GLUT_KEY_F4) 
	{
		if(glutGetModifiers() == 0) ampNoise += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	ampNoise -= 0.05;

		printf("GU= %f \n", ampNoise);		
	}	

}

//ȉ̂R̊֐̓}EXɂ鎋_̕ύXɕKv
void mouse(int button, int state, int x, int y)
{
  double pp = M_PI / 180.0;

  if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
  {
	  xStart = x; yStart = y;
	  flagMouse = true;
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist -= 0.05; //߂Â
	  }
  }
  else if(button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
  {
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist += 0.05; //
	  }
	  else if(( x < width/4 || x > 3*width/4) && (y > height/4 && y < 3*height/4))//pan
	  {
		  if(x < width/4 ) view.phi -= 0.1;
		  else view.phi += 1.0;
		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.phi) * cos(pp * view.theta);
		  view.cnt[0] = view.pos[0] - view.dist * sin(pp * view.phi) * cos(pp * view.theta);
	  }
	  else if((x > width/4 && x < 3*width/4) && (y < height/4 || y > 3*height/4))//tilt
	  {
		  if( y < height/4)
			  view.theta += 0.1; 
		  else
			  view.theta -= 0.1;

		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.theta) * cos(pp * view.phi);
		  view.cnt[0] = view.pos[0] - view.dist * cos(pp * view.theta) * sin(pp * view.phi);
		  view.cnt[1] = view.pos[1] - view.dist * sin(pp * view.theta);
	  }
	  else if(x < width/8 && y > 7*height/8) view.fovY -= 1.0;//zoom in
	  else if(x > 7*width/8 && y > 7*height/8) view.fovY += 1.0;//zoom out
  }
  else flagMouse = false;
  if(state == GLUT_DOWN) setCamera();
}

void motion(int x, int y)
{
  if(!flagMouse) return;
  if(cos(M_PI * view.theta /180.0) >= 0.0)
	view.phi -= 0.5 * (float)(x - xStart) ;//tumble
  else
	view.phi += 0.5 * (float)(x - xStart) ;//tumble

  view.theta += 0.5 * (float)(y - yStart) ;//crane

  setCamera();
  xStart = x;
  yStart = y;
}

void setCamera()
{
  double pp = M_PI / 180.0;
  view.pos[2] = view.cnt[2] + view.dist * cos(pp * view.theta) * cos(pp * view.phi);//z
  view.pos[0] = view.cnt[0] + view.dist * cos(pp * view.theta) * sin(pp * view.phi);//x
  view.pos[1] = view.cnt[1] + view.dist * sin(pp * view.theta);//y
//  printf("view.posX=%f, view.posY=%f, view.posZ=%f \n", view.pos[0], view.pos[1], view.pos[2]);
//  printf("cntX=%f, cntY=%f, cntZ=%f \n", view.cnt[0], view.cnt[1], view.cnt[2]);
//  printf("phi=%f, theta=%f, fovY=%f \n", view.phi, view.theta, view.fovY);
  resize(width, height);
}

