/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

3UCN
Ԋu_zu
OpenGL + GLSL

*/
//摜t@C
//#define FILENAME_IN "../../bmp256/matumae256-1.bmp"
//#define FILENAME_IN "../../bmp256/Lenna.bmp"
#define FILENAME_IN "../../bmp256/dog3-2.bmp"

//o͉摜t@C
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include <math.h>
#include "../../myGlsl.h"
#include "../../myPrimitive3.h"
#include "../../bmpLoadSave.h"
#define NUM_GEN_MAX  MAX_IMG_HEIGHT * MAX_IMG_WIDTH / 16

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void drawPlate();
void draw();
void setTextureHeight();
void levelTrans(); 
void makeVoronoi(short* posX, short* posY, float* red, float* green, float* blue);
void makeImageVoronoiAndHeight();
void setLight();
void idle();
void viewPos();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void resizePlate(int w, int h);

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte image2[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageHeight[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
GLubyte imageVoronoi[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageBoundary[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];


//affineϊpϐ
struct Object
{
	float pos[3], angle[3], scale[3];
};
//l
Object obj = {
	0.0, 0.0, 0.0,//pos
  0.0, 0.0, 0.0,//angle
  1.0, 1.0, 1.0 //scale
};
Object obj0 = obj;//lۑ

//
float lightPos[]  = {15.0, 20.0, 30.0, 1.0};//ʒu
float lightPos0[] = {15.0, 20.0, 30.0, 1.0};//ʒu(l)

//JƎ̐
struct View
{
  //J
	float pos[3];//ʒui_j
	float cnt[3];//_
  float dist;  //_王_܂ł̋
  float theta; //piʂƂ̕Ίpj
  float phi;   //ʊp
  //̐
  float fovY;  //p
  float nearZ; //ONbv(ߕ)
  float farZ;  //Nbv()
};
//l
View view = { 
	0.0, 0.0, 0.0,//pos
  0.0, 0.0, 0.0,//cnt 
	3.0, 0.0, 0.0,//dist, theta, phi
	30.0, 0.1, 100.0//fovY,nearZ, farZ
};
View view0 = view;//lۑ
//Window̃TCY(摜TCY傫邱Ɓj
int width = 512;
int height = 512;
//AtBϊ
enum SELECT_KEY {ROTATE, SCALE, TRANSLATE, LIGHT};
SELECT_KEY sKey = ROTATE;
//}EX
int xStart, yStart;
bool flagMouse = false;
//wvL[tO
bool flagHelp = false;
//ʒuύXtO
bool flagLight = false;

//\摜̍n_
int size = 6;//~̃TCY
int interval = 12;//_Ԋu
int disp = 6;//ŝ̗
int numGen;//_JEg
float eta = 0.05;//
int nLevel = 8;//K
float gamma = 1.0;//Px̃K}l

//VF[_vO
GLuint program;
//texture object
GLuint texName[2];
//Ԍv
LARGE_INTEGER freq, time1, time2;
DWORD pTime;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_Equally3D");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
	initGlsl(&program, "equally3D.vert", "equally3D.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteTextures(2, texName);
	glDeleteProgram(program);
  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
	glEnable(GL_DEPTH_TEST);	
  setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	//wiF
  glClearColor(0.2, 0.2, 0.2, 1.0);
	//J[摜̎擾
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	glGenTextures(2, texName);//eNX`IuWFNg̖Ot
  viewPos();//_߂
	makeImageVoronoiAndHeight();
  printf("}EX/L[̐ɂ'H'L[vbV \n");
}

void setTextureVoronoi()
{
  glBindTexture(GL_TEXTURE_2D, texName[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,imageVoronoi);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setTextureHeight()
{
  glBindTexture(GL_TEXTURE_2D, texName[1]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_LUMINANCE,imgWidth,imgHeight,0,GL_LUMINANCE,GL_UNSIGNED_BYTE,imageHeight);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void makeImageVoronoiAndHeight()
{
	//_̈ʒuƐF̃m
	short *posX, *posY;
	float *red, *green, *blue;
	posX = (short*)malloc(NUM_GEN_MAX * sizeof(short));
	posY = (short*)malloc(NUM_GEN_MAX * sizeof(short));
	red = (float*)malloc(NUM_GEN_MAX * sizeof(float));
	green = (float*)malloc(NUM_GEN_MAX * sizeof(float));
	blue = (float*)malloc(NUM_GEN_MAX * sizeof(float));
	if(posX == NULL || posY == NULL || red == NULL || green == NULL || blue == NULL)
	{
		printf("_̃mۂł܂ \n");
		return;
	}

  glDisable(GL_LIGHTING);
	//step1:PxCKጸ
	levelTrans();
	//step2:VoronoiMapeNX`摜쐬
	makeVoronoi(posX, posY, red, green, blue);

	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	resizePlate(width, height);

	glColor3f(0.0, 0.0, 0.0);//䎆̐F
	drawPlate();
	for(int k = 0; k < numGen; k++)
	{
		glColor3f(red[k], green[k], blue[k]);
		glPushMatrix();
		glTranslatef(posX[k], posY[k], 0);
		glutSolidCone(size, size, 24, 2);
		glPopMatrix();
	}
	//t[obt@Ƀ_ÔeNX`摜Ƃ
 	glPixelStorei(GL_PACK_ALIGNMENT, 1);
	glReadPixels(0, 0, imgWidth, imgHeight, GL_RGB, GL_UNSIGNED_BYTE, imageVoronoi);
	setTextureVoronoi();

	//step3:height map摜
	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glColor3f(0.0, 0.0, 0.0);//䎆̐F
	drawPlate();
	for(int k = 0; k < numGen; k++)
	{
		glColor3f(1.0, 1.0, 1.0);
		glPushMatrix();
		glTranslatef(posX[k], posY[k], 0);
		glutSolidCone(size, size, 24, 2);
		glPopMatrix();
	}
	//obt[t@Ƀ_ÔeNX`摜Ƃ
 	glPixelStorei(GL_PACK_ALIGNMENT, 1);
	glReadPixels(0, 0, imgWidth, imgHeight, GL_LUMINANCE, GL_UNSIGNED_BYTE, imageHeight);
	setTextureHeight();

	free(posX);
	free(posY);
	free(red);
	free(green);
	free(blue);
}

void display(void)
{
  //Ԍv
  LARGE_INTEGER freq, time1, time2;
	DWORD pTime;
	memset(&freq,  0x00, sizeof freq);
	memset(&time1, 0x00, sizeof time1);
	memset(&time2, 0x00, sizeof time2);
	pTime = 0;

	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &time1);

	setLight();

	//step4:VF[_ŃeNX`摜\
	resize(width, height);
	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();//_ςƂ͂̈ʒuɕKv
  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, 1.0, 0.0);
  else
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, -1.0, 0.0);

  glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);
  glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, texName[1]);

  // VF[_vO̓Kp 
	glUseProgram(program);

	GLint image0Loc = glGetUniformLocation(program, "imageVoronoi");
	glUniform1i(image0Loc, 0);//GL_TEXTURE0Kp
	GLint image1Loc = glGetUniformLocation(program, "imageHeight");
	glUniform1i(image1Loc, 1);//GL_TEXTURE1Kp
	GLint imgWidthLoc = glGetUniformLocation(program, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint etaLoc = glGetUniformLocation(program, "eta");
	glUniform1f(etaLoc, eta);

	draw();

	// VF[_vỎ 
  glUseProgram(0);

	QueryPerformanceCounter( &time2);
	pTime = (DWORD)((time2.QuadPart - time1.QuadPart) * 1000 / freq.QuadPart);
//	printf(" = %d[ms] \n", pTime);
	if(flagHelp)
  {
		printf("L[ɂAtBϊ/ړ \n");
		printf("@,Fx \n");
		printf("@,Fy \n");
		printf("@[Shift]{,Fz \n");
		printf("@'R':] \n");
		printf("@'T':sړ \n");
		printf("@'S':ݸ \n");
		printf("@'L'Aʒüړ \n");
		printf("}EXŎ_ύX \n");
		printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
		printf("  panFщEE{^NbNŒ_Eɕω \n");
		printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
		printf("  tumbleFEɃhbOƎ_Eɕω \n");
		printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
		printf("  zoomFE{^NbNŃY[C \n");
		printf("        EE{^NbNŃY[AEg \n");
		printf("[Shift]+'R'ŃZbg \n");
		printf("[F1]L[F_Ԋuinterval̕ύX \n");
		printf("[F2]L[Fψʗdisp̕ύX \n");
		printf("[F3]L[F~TCYsize̕ύX \n");
		printf("[F4]L[FWeta̕ύX \n");
		printf("[F5]L[FK}lgammȃ \n");
		printf("[F6]L[FKnLevel̑ \n");
		flagHelp = false;
  }
  //I
	glutSwapBuffers();
}

void draw(void)
{
  float ambient[] = { 0.3, 0.3, 0.3, 1.0};
  float diffuse[] = { 0.7, 0.7, 0.7, 1.0};
  float specular[]= { 1.0, 1.0, 1.0, 1.0};

  glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
  glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
  glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
  glMaterialf(GL_FRONT,GL_SHININESS,100);

  glPushMatrix();
  glTranslatef(obj.pos[0], obj.pos[1], obj.pos[2]);
  glRotatef(obj.angle[1], 0.0, 1.0, 0.0);//y]
  glRotatef(obj.angle[0], 1.0, 0.0, 0.0);//x]
  glRotatef(obj.angle[2], 0.0, 0.0, 1.0);//z]
  glScalef(obj.scale[0], obj.scale[1], obj.scale[2]);
  //glScalef(1.0, (float)imgHeight/(float)imgWidth, 1.0);

	drawGridPlate(1.0, (float)imgHeight/(float)imgWidth, imgWidth, imgHeight);
	//drawGridPlate((float)imgWidth/(float)imgHeight, 1.0, imgWidth, imgHeight);
	//drawGridPlate(1.0, 1.0, imgWidth, imgHeight);
  glPopMatrix();
}

void levelTrans()
{//ZxxϊƊK팸
	int i, j, k, m, n;
	double zStep = 255.0 / float(nLevel-1);

	for(m = 0; m < 3; m++)
	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			k = i + j * imgWidth;
			//Px
			image2[k][m] = (GLubyte)(pow((double)image[k][m]/255.0, (double)gamma) * 255.0);
			//Kጸ
			n = floor((double)image2[k][m] / zStep + 0.5);
			image2[k][m] = (GLubyte)(zStep * n);
		}
	}
}

void makeVoronoi(short* posX, short* posY, float* red, float* green, float* blue)
{
	int i, j, ii, jj, k;

	numGen = 0;
	//_̈ʒuƐF
	for(jj = 0; jj <= imgHeight/interval; jj++)
	{
		j = jj * interval;
		for(ii = 0; ii <= imgWidth/interval; ii++)
		{
			i = ii * interval;
			if(jj == (jj/2) * 2) posX[numGen] = i ;
			else posX[numGen] = i + (int)fmod((double)disp, (double)interval);
			posY[numGen] = j;
			k = i + j * imgWidth;
			red[numGen]   = (float)image2[k][0] / 255.0;
			green[numGen] = (float)image2[k][1] / 255.0;
			blue[numGen]  = (float)image2[k][2] / 255.0;
			numGen ++;
		}
	}
}

void drawPlate()
{
	glBegin(GL_QUADS);
		glVertex2i(0, 0);
		glVertex2i(imgWidth, 0);
		glVertex2i(imgWidth, imgHeight);
		glVertex2i(0, imgHeight);
	glEnd();
}

void resizePlate(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎wƏ
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  //es̐ݒ
	glOrtho(0.0, w, 0.0, h, -size, 10);
  //\EBhẼTCY
  width = w;
  height = h;
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎w
  glMatrixMode(GL_PROJECTION);
  //vWFNVs̏
  glLoadIdentity();
  //es̐ݒieϊj
  gluPerspective(view.fovY, (double)w/(double)h, view.nearZ, view.farZ);
	//fr[s̐錾
  glMatrixMode(GL_MODELVIEW);
  //\EBhẼTCY
  width = w;
  height = h;
}

void setLight()
{
  float lightAmbient0[] = {0.5, 0.5, 0.5, 1.0}; //
  float lightDiffuse0[] = {1.0, 1.0, 1.0, 1.0}; //gU
  float lightSpecular0[] = {1.0, 1.0, 1.0, 1.0};//ʌ
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightAmbient0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightDiffuse0);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightSpecular0);
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;

  case 'r':
	  sKey = ROTATE;
	  break;
  case 's':
	  sKey = SCALE;
	  break;
  case 't':
	  sKey = TRANSLATE;
	  break;
  case 'R'://resetilɖ߂)
		obj = obj0;
	  view = view0;
	  viewPos();
		for(int i = 0 ; i < 3; i++) lightPos[i] = lightPos0[i];
	  break;
  case 'l':
	  sKey = LIGHT;
	  break;

  case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(0, 0, width, height, GL_RGB, GL_UNSIGNED_BYTE, image);
		saveBitmap24(width, height, image, FILENAME_OUT); 
		loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN);
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}


void special(int key, int x, int y)
{
  if(sKey == TRANSLATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  obj.pos[0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://-x
		  obj.pos[0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) obj.pos[1] += 0.1;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.pos[2] -= 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) obj.pos[1] -= 0.1;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.pos[2] += 0.1; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == ROTATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x]
		  obj.angle[0] += 10.0;
		  break;
	  case GLUT_KEY_LEFT://-x]
		  obj.angle[0] -= 10.0;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) obj.angle[1] += 10;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.angle[2] += 10; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) obj.angle[1] -= 10;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.angle[2] -= 10; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == SCALE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://xg
		  obj.scale[0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://xk
		  obj.scale[0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) obj.scale[1] += 0.1;//yg
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.scale[2] += 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) obj.scale[1] -= 0.1;//yk
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.scale[2] -= 0.1; //z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == LIGHT)
  {
		float d = 1.0;
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  lightPos[0] += d;
		  break;
	  case GLUT_KEY_LEFT:
		  lightPos[0] -= d;//-x
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) lightPos[1] += d;//y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] -= d;//z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) lightPos[1] -= d;//-y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] += d;//-z
		  break;
	  default:
		  break;
	  }
  }

	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) interval += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	interval -= 1;  
		if(interval < 4) interval = 4;;
		printf("interval = %d \n", interval);
		makeImageVoronoiAndHeight();
	}
	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) disp += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	disp -= 1;  
		printf("disp = %d \n", disp);
		makeImageVoronoiAndHeight();
	}
	if(key == GLUT_KEY_F3) 
	{
	  if(glutGetModifiers() == 0) size += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	size -= 1;  
		printf("size = %d \n", size);
		makeImageVoronoiAndHeight();
	}
	if(key == GLUT_KEY_F4) 
	{
	  if(glutGetModifiers() == 0) eta += 0.01;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	eta -= 0.01; 
		if(eta < 0.0) eta = 0.0;
		printf("eta = %f \n", eta); 
	}

	if(key == GLUT_KEY_F5) 
	{
	  if(glutGetModifiers() == 0) gamma += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	gamma -= 0.05;  
		if(gamma < 0.1) gamma = 0.1;
		printf("K}lgamma = %f \n", gamma);
		makeImageVoronoiAndHeight();
	}	

	if(key == GLUT_KEY_F6) 
	{
	  if(glutGetModifiers() == 0) nLevel += 1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	nLevel -= 1;  
		if(nLevel < 2) nLevel = 2;
		else if(nLevel == 17) nLevel = 32;
		else if(nLevel == 33) nLevel = 64;
		else if(nLevel == 65) nLevel = 128;
		else if(nLevel == 129) nLevel = 256;
		else if(nLevel >= 256) nLevel = 256;
		else if(nLevel == 255) nLevel = 128;
		else if(nLevel == 127) nLevel = 64;
		else if(nLevel == 63) nLevel = 32;
		else if(nLevel == 31) nLevel = 16;
		printf("KnLevel = %d \n", nLevel);
		makeImageVoronoiAndHeight();
	}

	display();
}

//ȉ̂R̊֐̓}EXɂ鎋_̕ύXɕKv
void mouse(int button, int state, int x, int y)
{
  double pp = M_PI / 180.0;

  if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
  {
	  xStart = x; yStart = y;
	  flagMouse = true;
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist -= 0.1; //߂Â
	  }
  }
  else if(button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
  {
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist += 0.1; //
	  }
	  else if(( x < width/4 || x > 3*width/4) && (y > height/4 && y < 3*height/4))//pan
	  {
		  if(x < width/4 ) view.phi -= 1.0;
		  else view.phi += 1.0;
		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.phi) * cos(pp * view.theta);
		  view.cnt[0] = view.pos[0] - view.dist * sin(pp * view.phi) * cos(pp * view.theta);
	  }
	  else if((x > width/4 && x < 3*width/4) && (y < height/4 || y > 3*height/4))//tilt
	  {
		  if( y < height/4)
			  view.theta += 1.0; 
		  else
			  view.theta -= 1.0;

		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.theta) * cos(pp * view.phi);
		  view.cnt[0] = view.pos[0] - view.dist * cos(pp * view.theta) * sin(pp * view.phi);
		  view.cnt[1] = view.pos[1] - view.dist * sin(pp * view.theta);
	  }
	  else if(x < width/8 && y > 7*height/8) view.fovY -= 1.0;//zoom in
	  else if(x > 7*width/8 && y > 7*height/8) view.fovY += 1.0;//zoom out
  }
  else flagMouse = false;
  if(state == GLUT_DOWN) viewPos();
}

void motion(int x, int y)
{
  if(!flagMouse) return;
  if(cos(M_PI * view.theta /180.0) >= 0.0)
	view.phi -= 0.5 * (float)(x - xStart) ;//tumble
  else
	view.phi += 0.5 * (float)(x - xStart) ;//tumble

  view.theta += 0.5 * (float)(y - yStart) ;//crane

  viewPos();
  xStart = x;
  yStart = y;
}

void viewPos()
{
  double pp = M_PI / 180.0;
  view.pos[2] = view.cnt[2] + view.dist * cos(pp * view.theta) * cos(pp * view.phi);//z
  view.pos[0] = view.cnt[0] + view.dist * cos(pp * view.theta) * sin(pp * view.phi);//x
  view.pos[1] = view.cnt[1] + view.dist * sin(pp * view.theta);//y
  //printf("view.posX=%f, view.posY=%f, view.posZ=%f \n", view.pos[0], view.pos[1], view.pos[2]);
  //printf("cntX=%f, cntY=%f, cntZ=%f \n", view.cnt[0], view.cnt[1], view.cnt[2]);
  //printf("phi=%f, theta=%f, fovY=%f \n", view.phi, view.theta, view.fovY);
	resize(width, height);
}


