

uniform float nRatio;
uniform mat4 ViewTranspose;//r[ϊ̃fr[s(]uj
varying vec3 P;
varying vec3 N;
varying vec4 Refract;

void main(void)
{
  P = gl_ModelViewMatrix * gl_Vertex;
  N = normalize(gl_NormalMatrix * gl_Normal);

  //()xNg
  vec3 incident = normalize(P);
  //܃xNg
	vec3 refract0 = refract(incident, N, 1.0 / nRatio);
	//܃xNgɂeNX`W
	Refract = ViewTranspose * vec4(refract0, 1.0);
//Refract = gl_TextureMatrix[0] * vec4(refract0, 1.0);
  gl_Position = ftransform();
}
