
uniform sampler2D imageHeight;
uniform int imgWidth, imgHeight;
uniform float eta;
varying vec3 P;
varying vec3 N;
varying vec2 texCoord;
//eNX`WԂɂfʒu̒P
float dx = 1.0 / float(imgWidth);
float dy = 1.0 / float(imgHeight);

void main(void)
{
	//eNX`W
  texCoord = gl_Vertex.xy + vec2(0.5, 0.5);
  //TvOj
	float hh = texture2D(imageHeight, texCoord).r;//r,g,bl
  //s,tWɂ鍂}bv̔	
	float deltaS = texture2D(imageHeight, texCoord + dx).b - texture2D(imageHeight, texCoord - dx).b;
	float deltaT = texture2D(imageHeight, texCoord + dy).b - texture2D(imageHeight, texCoord - dy).b;
	//s,tW̒PʃxNg
	vec3 As = vec3(1.0, 0.0, 0.0);//x
	vec3 At = vec3(0.0, 1.0, 0.0);//y
	//
	gl_Vertex.z += hh * eta ;
  P = vec3(gl_ModelViewMatrix * gl_Vertex);
  N = normalize(gl_NormalMatrix * gl_Normal).xyz;
  //V@xNg
  N -= As * deltaS + At * deltaT;
  
  gl_Position = ftransform();
}
