/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg


׍HiNbNEgX˃fj
OpenGL + GLSL

*/
//摜t@C
#define FILENAME_IN_1 "../../bmp256/dog3-2.bmp"
#define FILENAME_IN_2 "../../bmp256/dogHeight3-2.bmp"

//o͉摜t@C
#define FILENAME_OUT "file0.bmp"

#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include <math.h>
#include "../../myGlsl.h"
#include "../../myPrimitive3.h"
#include "../../bmpLoadSave.h"
#define NUM_GEN_MAX  MAX_IMG_HEIGHT * MAX_IMG_WIDTH / 16

//֐̃vg^Cv錾
void init();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void draw();
void gaussian();
void setTexture();
void setTextureVoronoi();
void setTextureHeight();
void setLight();
void idle();
void viewPos();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);

//ϐ
//摜̃TCY
int imgWidth, imgHeight;
GLubyte image[MAX_IMG_HEIGHT * MAX_IMG_WIDTH][3];
GLubyte imageHeight[MAX_IMG_HEIGHT * MAX_IMG_WIDTH];
//affineϊpϐ
struct Object
{
	float pos[3], angle[3], scale[3];
};
//l
Object obj = {
	0.0, 0.0, 0.0,//pos
  0.0, 0.0, 0.0,//angle
  1.0, 1.0, 1.0 //scale
};
Object obj0 = obj;//lۑ

//
float lightPos[]  = {15.0, 20.0, 100.0, 1.0};//ʒu
float lightPos0[] = {15.0, 20.0, 100.0, 1.0};//ʒu(l)

//JƎ̐
struct View
{
  //J
	float pos[3];//ʒui_j
	float cnt[3];//_
  float dist;  //_王_܂ł̋
  float theta; //piʂƂ̕Ίpj
  float phi;   //ʊp
  //̐
  float fovY;  //p
  float nearZ; //ONbv(ߕ)
  float farZ;  //Nbv()
};
//l
View view = { 
	0.0, 0.0, 0.0,//pos
  0.0, 0.0, 0.0,//cnt 
	4.0, 0.0, 0.0,//dist, theta, phi
	30.0, 0.1, 100.0//fovY,nearZ, farZ
};
View view0 = view;//lۑ
//Window̃TCY
int width = 512;
int height = 512;
//AtBϊ
enum SELECT_KEY {ROTATE, SCALE, TRANSLATE, LIGHT};
SELECT_KEY sKey = ROTATE;
//̎
enum KIND {GOLD, SILVER, COPPER, BRONZE};
KIND kind = GOLD;
//}EX
int xStart, yStart;
bool flagMouse = false;
//wvL[tO
bool flagHelp = false;
//ʒuύXtO
bool flagLight = false;

float alpha = 0.5;//摜W
float eta = 0.05;//W
float rough = 0.1;//eW
int mode = 0;//\[h
//Gaussian Filter
int size = 5;
//VF[_vO
GLuint program;
//texture object
GLuint texName[2];

int main(int argc, char** argv)
{
  glutInit(&argc, argv);

  //\[h
  glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE  | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("SL_Metalwork");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //\
  glutDisplayFunc(display);
  //ݒ
  init();
	initGlsl(&program, "metal.vert", "metal.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteTextures(2, texName);
	glDeleteProgram(program);
  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{	
  glClearColor(0.2, 0.2, 0.2, 1.0);//wiF
  setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
  printf("}EX/L[̐ɂ'H'L[vbV \n");
	//J[摜̎擾
	loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN_1);
	loadGrayData(imageHeight, &imgWidth, &imgHeight, FILENAME_IN_2);//hight map
	gaussian();
	glGenTextures(2, texName);//eNX`IuWFNg̖Ot
	//makeNormalMap();
	setTexture();
	setTextureHeight();
  viewPos();//_߂
}

void setTexture()
{
  glBindTexture(GL_TEXTURE_2D, texName[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,imgWidth,imgHeight,0,GL_RGB,GL_UNSIGNED_BYTE,image);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void setTextureHeight()
{
  glBindTexture(GL_TEXTURE_2D, texName[1]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  //eNX`̊蓖 
  glTexImage2D(GL_TEXTURE_2D,0,GL_LUMINANCE,imgWidth,imgHeight,0,GL_LUMINANCE,GL_UNSIGNED_BYTE,imageHeight);
  //eNX`gEk@̎w 
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);
}

void display(void)
{
  //Ԍv
  LARGE_INTEGER freq, time1, time2;
	DWORD pTime;
	memset(&freq,  0x00, sizeof freq);
	memset(&time1, 0x00, sizeof time1);
	memset(&time2, 0x00, sizeof time2);
	pTime = 0;

	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &time1);

	resize(width, height);	
	//J[obt@ƃfvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();//_ςƂ͂̈ʒuɕKv
  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, 1.0, 0.0);
  else
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, -1.0, 0.0);

  //ݒ//'l'ʒu
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);
  glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);
  glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, texName[1]);

  // VF[_vO̓Kp 
	glUseProgram(program);
	GLint image0Loc = glGetUniformLocation(program, "image");
	glUniform1i(image0Loc, 0);//GL_TEXTURE0Kp
	GLint image3Loc = glGetUniformLocation(program, "imageHeight");
	glUniform1i(image3Loc, 1);//GL_TEXTURE1Kp
	GLint imgWidthLoc = glGetUniformLocation(program, "imgWidth");
	glUniform1i(imgWidthLoc, imgWidth);
	GLint imgHeightLoc = glGetUniformLocation(program, "imgHeight");
	glUniform1i(imgHeightLoc, imgHeight);
	GLint alphaLoc = glGetUniformLocation(program, "alpha");
	glUniform1f(alphaLoc, alpha);
	GLint etaLoc = glGetUniformLocation(program, "eta");
	glUniform1f(etaLoc, eta);
	GLint roughLoc = glGetUniformLocation(program, "rough");
	glUniform1f(roughLoc, rough);
	GLint modeLoc = glGetUniformLocation(program, "mode");
	glUniform1i(modeLoc, mode);

	draw();

	// VF[_vỎ 
  glUseProgram(0);

	QueryPerformanceCounter( &time2);
	pTime = (DWORD)((time2.QuadPart - time1.QuadPart) * 1000 / freq.QuadPart);
//	printf(" = %d[ms] \n", pTime);
	if(flagHelp)
  {
		printf("L[ɂAtBϊ/ړ \n");
		printf("@,Fx \n");
		printf("@,Fy \n");
		printf("@[Shift]{,Fz \n");
		printf("@'R':] \n");
		printf("@'T':sړ \n");
		printf("@'S':ݸ \n");
		printf("@'L'Aʒüړ \n");
		printf("}EXŎ_ύX \n");
		printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
		printf("  panFщEE{^NbNŒ_Eɕω \n");
		printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
		printf("  tumbleFEɃhbOƎ_Eɕω \n");
		printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
		printf("  zoomFE{^NbNŃY[C \n");
		printf("        EE{^NbNŃY[AEg \n");
		printf("[Shift]+'R'ŃZbg \n");
		printf("[F1]L[FƖ@ϓeta̕ύX \n");
		printf("[F2]L[F摜uhWalpha̕ύX \n");
		printf("[F3]L[FeWrough̕ύX \n");
		printf("[F4]L[FKEVAtB^̃TCYsize̕ύX \n");
		printf("[F5]L[F̎kind̕ύX \n");
		printf("[F6]L[F\[hmode̐؂ւ \n");
		flagHelp = false;
  }
  //I
	glutSwapBuffers();
}

void draw(void)
{
	float ambient[4];
	float diffuse[4];
	float specular[4];

	ambient[3] = 1.0;
	diffuse[3] = 1.0;
	specular[3] = 1.0;

	if( kind == GOLD )
	{
			ambient[0] = 0.24725; ambient[1] = 0.1995; ambient[2] = 0.0745;
			diffuse[0] = 0.75164; diffuse[1] = 0.60648; diffuse[2] = 0.22648;
			specular[0] = 0.62828; specular[1] = 0.555802; specular[2] = 0.366065;
	}
	else if(kind == SILVER)
	{
			ambient[0] = 0.19225; ambient[1] = 0.19225; ambient[2] = 0.19225;
			diffuse[0] = 0.50754; diffuse[1] = 0.50745; diffuse[2] = 0.50754;
			specular[0]= 0.508273; specular[1] = 0.508273; specular[2] = 0.508273;
	}
	else if(kind == COPPER)
	{
			ambient[0] = 0.19125; ambient[1] = 0.0735; ambient[2] = 0.0225;
			diffuse[0] = 0.7038; diffuse[1] = 0.27048; diffuse[2] = 0.0828;
			specular[0]= 0.256777; specular[1] = 0.137622; specular[2] = 0.086014;
	}
	else// BRONZE:
	{
			ambient[0] = 0.2125; ambient[1] = 0.1275; ambient[2] = 0.054;
			diffuse[0] = 0.714; diffuse[1] = 0.4284; diffuse[2] = 0.18144;
			specular[0]= 0.393548; specular[1] = 0.271906; specular[2] = 0.166721;
	}

  glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
  glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
  glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
  glMaterialf(GL_FRONT,GL_SHININESS,100);

  glPushMatrix();
  glTranslatef(obj.pos[0], obj.pos[1], obj.pos[2]);
  glRotatef(obj.angle[1], 0.0, 1.0, 0.0);//y]
  glRotatef(obj.angle[0], 1.0, 0.0, 0.0);//x]
  glRotatef(obj.angle[2], 0.0, 0.0, 1.0);//z]
  glScalef(obj.scale[0], obj.scale[1], obj.scale[2]);

	drawGridPlate(1.0, (float)imgHeight/(float)imgWidth, 500, 500);
  glPopMatrix();
}
void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎w
  glMatrixMode(GL_PROJECTION);
  //vWFNVs̏
  glLoadIdentity();
  //es̐ݒieϊj
  gluPerspective(view.fovY, (double)w/(double)h, view.nearZ, view.farZ);
	//fr[s̐錾
  glMatrixMode(GL_MODELVIEW);
  //\EBhẼTCY
  width = w;
  height = h;
}

void gaussian()
{
	float sigma = 5.0;
	//Gaussian filter  parameter
	float weight[81];

	GLubyte *imageHeight2;
	imageHeight2 = (GLubyte*)malloc(MAX_IMG_HEIGHT * MAX_IMG_WIDTH * sizeof(GLubyte));

	int i, j, k, ii, jj;

	for(j = 0; j < imgHeight; j++)
		for(i = 0; i < imgWidth; i++) imageHeight2[i + j * imgHeight] = imageHeight[i + j * imgHeight] ;

	for(jj = 0; jj < size; jj++)		
	{
		j = -(size-1)/2 + jj;
		for(ii = 0; ii < size; ii++)
		{ 
			i = -(size-1)/2 + ii;
			weight[ii + jj * size] = exp(-double(i*i + j*j) / (2.0 * sigma * sigma));
		}
	}
	float sum = 0.0;
	for(k = 0; k < size * size; k++) sum += weight[k];
	for(k = 0; k < size * size; k++) weight[k] /= sum;//2.0 * 3.141592 * sigma * sigma;//sum;//d
//for(k = 0; k < size * size; k++) printf("k=%d weight=%f \n", k, weight[k]);

	//R{[V
	for(j = 0; j < imgHeight; j++)
	{
		for(i = 0; i < imgWidth; i++)
		{
			if(j < (size-1)/2 || j >= imgHeight - (size-1)/2 || i < (size-1)/2 || i >= imgWidth - (size-1)/2)
			{ 
				imageHeight[i + j * imgWidth] = imageHeight2[i + j * imgWidth]; 
			}
			else
			{
				sum = 0.0;
				for(jj = -(size-1)/2; jj <= (size-1)/2; jj++)
				{
					for(ii = -(size-1)/2; ii <= (size-1)/2; ii++)
					{
						k = (size-1)/2+ii + ((size-1)/2+jj) * size;
						sum += (float)imageHeight2[i+ii + (j+jj) * imgWidth] * weight[k];
					}
				}
				imageHeight[i + j * imgWidth] = (GLubyte)sum;
			}
		}
	}
	free(imageHeight2);
}

void setLight()
{
  float lightAmbient0[] = {0.5, 0.5, 0.5, 1.0}; //
  float lightDiffuse0[] = {1.0, 1.0, 1.0, 1.0}; //gU
  float lightSpecular0[] = {1.0, 1.0, 1.0, 1.0};//ʌ
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightAmbient0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightDiffuse0);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightSpecular0);
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);
}


void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'r':
	  sKey = ROTATE;
	  break;
  case 's':
	  sKey = SCALE;
	  break;
  case 't':
	  sKey = TRANSLATE;
	  break;
  case 'R'://resetilɖ߂)
		obj = obj0;
	  view = view0;
	  viewPos();
	  break;
  case 'l':
	  sKey = LIGHT;
	  break;

  case 'S'://image̕ۑ([Shift] + 'S')
  	glPixelStorei(GL_PACK_ALIGNMENT, 1);
		glReadPixels(0, 0, width, height, GL_RGB, GL_UNSIGNED_BYTE, image);
		saveBitmap24(width, height, image, FILENAME_OUT); 
		loadColorData(image, &imgWidth, &imgHeight, FILENAME_IN_1);
	  break;

  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
		display();
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
  if(sKey == TRANSLATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  obj.pos[0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://-x
		  obj.pos[0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) obj.pos[1] += 0.1;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.pos[2] -= 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) obj.pos[1] -= 0.1;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.pos[2] += 0.1; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == ROTATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x]
		  obj.angle[0] += 10.0;
		  break;
	  case GLUT_KEY_LEFT://-x]
		  obj.angle[0] -= 10.0;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) obj.angle[1] += 10;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.angle[2] += 10; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) obj.angle[1] -= 10;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.angle[2] -= 10; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == SCALE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://xg
		  obj.scale[0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://xk
		  obj.scale[0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) obj.scale[1] += 0.1;//yg
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.scale[2] += 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) obj.scale[1] -= 0.1;//yk
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) obj.scale[2] -= 0.1; //z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == LIGHT)
  {
		float d = 1.0;
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  lightPos[0] += d;
		  break;
	  case GLUT_KEY_LEFT:
		  lightPos[0] -= d;//-x
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) lightPos[1] += d;//y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] -= d;//z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) lightPos[1] -= d;//-y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] += d;//-z
		  break;
	  default:
		  break;
	  }
  }
	
	if(key == GLUT_KEY_F1) 
	{
	  if(glutGetModifiers() == 0) eta += 0.01;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	eta -= 0.01; 
		if(eta < 0.0) eta = 0.0;
		printf("ϓ eta = %f \n", eta); 
	}
	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) alpha += 0.05;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	alpha -= 0.05; 
		if(alpha < 0.0) alpha = 0.0;
		if(alpha > 1.0) alpha = 1.0;
		printf("alpha = %f \n", alpha); 
	}
	if(key == GLUT_KEY_F3) 
	{
	  if(glutGetModifiers() == 0) rough += 0.01;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	rough -= 0.01; 
		if(rough < 0.0) rough = 0.0;
		printf("rough = %f \n", rough); 
	}

	if(key == GLUT_KEY_F4) 
	{
		size += 2;
		if(size > 9) size = 1;
		printf("size = %d \n", size);
		loadGrayData(imageHeight, &imgWidth, &imgHeight, FILENAME_IN_2);//hight map
		gaussian();
		setTextureHeight();
	}

	if(key == GLUT_KEY_F5) 
	{
		if(kind == GOLD) {
			kind = SILVER;
			printf("kind = %s \n", "SILVER");
		}
		else if(kind == SILVER) {
			kind = COPPER;
			printf("kind = %s \n", "COPPER");
		}
		else if(kind == COPPER) {
			kind = BRONZE;
			printf("kind = %s \n", "BRONZE");
		}
		else if(kind == BRONZE) {
			kind = GOLD;
			printf("kind = %s \n", "GOLD");
		}	
	}
	if(key == GLUT_KEY_F6) 
	{
		mode += 1;
		if(mode > 1) mode = 0;
		printf("mode = %d \n", mode);
	}

	display();
}

//ȉ̂R̊֐̓}EXɂ鎋_̕ύXɕKv
void mouse(int button, int state, int x, int y)
{
  double pp = M_PI / 180.0;

  if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
  {
	  xStart = x; yStart = y;
	  flagMouse = true;
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist -= 0.1; //߂Â
	  }
  }
  else if(button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
  {
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist += 0.1; //
	  }
	  else if(( x < width/4 || x > 3*width/4) && (y > height/4 && y < 3*height/4))//pan
	  {
		  if(x < width/4 ) view.phi -= 1.0;
		  else view.phi += 1.0;
		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.phi) * cos(pp * view.theta);
		  view.cnt[0] = view.pos[0] - view.dist * sin(pp * view.phi) * cos(pp * view.theta);
	  }
	  else if((x > width/4 && x < 3*width/4) && (y < height/4 || y > 3*height/4))//tilt
	  {
		  if( y < height/4)
			  view.theta += 1.0; 
		  else
			  view.theta -= 1.0;

		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.theta) * cos(pp * view.phi);
		  view.cnt[0] = view.pos[0] - view.dist * cos(pp * view.theta) * sin(pp * view.phi);
		  view.cnt[1] = view.pos[1] - view.dist * sin(pp * view.theta);
	  }
	  else if(x < width/8 && y > 7*height/8) view.fovY -= 1.0;//zoom in
	  else if(x > 7*width/8 && y > 7*height/8) view.fovY += 1.0;//zoom out
  }
  else flagMouse = false;
  if(state == GLUT_DOWN) viewPos();
}

void motion(int x, int y)
{
  if(!flagMouse) return;
  if(cos(M_PI * view.theta /180.0) >= 0.0)
	view.phi -= 0.5 * (float)(x - xStart) ;//tumble
  else
	view.phi += 0.5 * (float)(x - xStart) ;//tumble

  view.theta += 0.5 * (float)(y - yStart) ;//crane

  viewPos();
  xStart = x;
  yStart = y;
}

void viewPos()
{
  double pp = M_PI / 180.0;
  view.pos[2] = view.cnt[2] + view.dist * cos(pp * view.theta) * cos(pp * view.phi);//z
  view.pos[0] = view.cnt[0] + view.dist * cos(pp * view.theta) * sin(pp * view.phi);//x
  view.pos[1] = view.cnt[1] + view.dist * sin(pp * view.theta);//y
  //printf("view.posX=%f, view.posY=%f, view.posZ=%f \n", view.pos[0], view.pos[1], view.pos[2]);
  //printf("cntX=%f, cntY=%f, cntZ=%f \n", view.cnt[0], view.cnt[1], view.cnt[2]);
  //printf("phi=%f, theta=%f, fovY=%f \n", view.phi, view.theta, view.fovY);
	resize(width, height);
}


